"{ Package: 'stx:goodies/xmlsuite/xquery' }"

"{ NameSpace: XQuery }"

UpdateCommand subclass:#ReplaceCommand
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XQuery-Update Facility'
!


!ReplaceCommand class methodsFor:'priorities'!

priority
    "Superclass says that I am responsible to implement this method"

    ^30
! !

!ReplaceCommand methodsFor:'checks'!

checkSourceSequence:arg 
    "Superclass says that I am responsible to implement this method"

    self 
        assert:
            (arg allSatisfy:[:item| item type = self targetSequence first type])
        description:('replacing different node types').

    "Created: / 14-11-2007 / 10:06:41 / janfrog"
    "Modified: / 14-11-2007 / 15:20:01 / janfrog"
!

checkTargetSequence:anXQuerySequence
    self 
        assert: (anXQuerySequence containsSingleNode)
        description:'Target sequence must contain one node (see section 2.3.3.1)'.
    self
        assert: (anXQuerySequence first item isDocumentNode not)
                 description:'Target sequence node must have a parent (see section 2.3.3.1)'.

    "Modified: / 14-11-2007 / 11:58:32 / janfrog"
! !

!ReplaceCommand methodsFor:'executing'!

execute
    "Superclass says that I am responsible to implement this method"


       self replaceNode: self targetSequence first  with: self sourceSequence

    "Created: / 14-11-2007 / 10:06:41 / janfrog"
    "Modified: / 14-11-2007 / 16:09:43 / janfrog"
! !

!ReplaceCommand methodsFor:'replacing'!

replaceNode:targetNode with:sourceNodes 
    |importedSourceNodeIds|

    importedSourceNodeIds := sourceNodes 
                collect:[:sourceNode | 
                    targetNode documentAdaptor importForeignNode:sourceNode item nodeId
                        adaptor:sourceNode documentAdaptor
                ].
    targetNode documentAdaptor updReplaceNode:targetNode item nodeId
        with:importedSourceNodeIds

    "Created: / 14-11-2007 / 10:24:04 / janfrog"
    "Modified: / 05-12-2007 / 14:26:29 / janfrog"
! !

!ReplaceCommand class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/stx/goodies/xmlsuite/xquery/XQuery__ReplaceCommand.st,v 1.5 2008-01-02 14:05:52 wrobll1 Exp $'
! !
