"{ Package: 'stx:goodies/xmlsuite/xquery' }"

"{ NameSpace: XQuery }"

XMLv2::XPathDocumentAdaptor subclass:#XPathDocumentAdaptorProxy
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XQuery-Executor'
!

XPathDocumentAdaptorProxy class instanceVariableNames:'instance'

"
 No other class instance variables are inherited by this class.
"
!


!XPathDocumentAdaptorProxy class methodsFor:'accessing'!

documentClass

    ^self

    "Created: / 02-11-2006 / 11:51:56 / ked"
    "Modified: / 03-11-2006 / 11:29:24 / ked"
!

instance
    instance ifNil:[
        instance := self new.
    ].
    ^ instance

    "Created: / 03-11-2006 / 11:19:39 / ked"
! !

!XPathDocumentAdaptorProxy methodsFor:'checking'!

ensureIsValidNodeId:anObject 

    ^self

    "Created: / 03-11-2006 / 11:28:23 / ked"
!

ensureNotReleased 

    ^self

    "Created: / 03-11-2006 / 12:19:28 / ked"
! !

!XPathDocumentAdaptorProxy methodsFor:'private'!

wrapNodeCollection: aNodeCollection withDocumentAdaptor: aDocumentAdaptor

    ^aNodeCollection collect:[:item | XQueryAccessedNode new nodeId: item; documentAdaptor: aDocumentAdaptor ].

    "Created: / 03-11-2006 / 20:52:38 / ked"
!

wrapSingleNode: aNodeId withDocumentAdaptor: aDocumentAdaptor
    aNodeId ifNil:[
        ^nil.
    ].

    ^XQueryAccessedNode new nodeId: aNodeId; documentAdaptor: aDocumentAdaptor.

    "Created: / 03-11-2006 / 20:52:29 / ked"
! !

!XPathDocumentAdaptorProxy methodsFor:'resource management'!

primReleaseResources

    ^self

    "Created: / 12-12-2006 / 10:46:25 / janfrog"
! !

!XPathDocumentAdaptorProxy methodsFor:'xpath axes'!

xpathDocumentOf: aNode

    aNode isXQueryConstructedNode ifTrue:[
        aNode nodeParent ifNil:[
            ^aNode.
        ] ifNotNil:[
            ^self xpathDocumentOf: aNode nodeParent.
        ].
    ] ifFalse:[
        aNode constructedParent ifNil:[
            ^self wrapSingleNode:(aNode documentAdaptor document) withDocumentAdaptor:(aNode documentAdaptor).
        ] ifNotNil:[
            ^self xpathDocumentOf: aNode constructedParent.
        ].
    ].

    "Modified: / 03-11-2006 / 20:53:39 / ked"
    "Created: / 14-12-2006 / 23:25:54 / janfrog"
! !

!XPathDocumentAdaptorProxy methodsFor:'xpath primitives'!

primXpathAttributeOf: aNode 

    aNode isXQueryConstructedNode ifTrue:[
        ^aNode nodeAttributes.
    ] ifFalse:[
        aNode constructedAttributes ifNil:[
            aNode constructedParent ifNil:[
                ^self wrapNodeCollection:(aNode documentAdaptor xpathAttributeOf: aNode nodeId) withDocumentAdaptor:(aNode documentAdaptor).
            ] ifNotNil:[
                aNode constructedAttributes: OrderedCollection new.

                ^(self wrapNodeCollection:(aNode documentAdaptor xpathAttributeOf: aNode nodeId) withDocumentAdaptor:(aNode documentAdaptor))
                collect: [:node | aNode constructedAttributes add: node. node constructedParent: aNode. ].
            ].
        ] ifNotNil:[
            ^aNode constructedAttributes.
        ].
    ].

    "Modified: / 03-11-2006 / 20:53:17 / ked"
    "Created: / 14-12-2006 / 23:25:30 / janfrog"
!

primXpathAttributeValueOf: aNode

    aNode isXQueryConstructedNode ifTrue:[
        ^aNode nodeValue.
    ] ifFalse:[
        ^aNode documentAdaptor xpathAttributeValueOf: aNode nodeId.
    ].

    "Modified: / 03-11-2006 / 20:49:26 / ked"
    "Created: / 14-12-2006 / 23:27:59 / janfrog"
!

primXpathChildOf: aNode 

    aNode isXQueryConstructedNode ifTrue:[
        ^aNode nodeChildren.
    ] ifFalse:[
        aNode constructedChildren ifNil:[
            aNode constructedParent ifNil:[
                ^(self wrapNodeCollection:(aNode documentAdaptor xpathChildOf: aNode nodeId) withDocumentAdaptor:(aNode documentAdaptor))
                select: [:node | node xpathIsIgnorableText not ].
            ] ifNotNil:[
                aNode constructedChildren: OrderedCollection new.

                ^((self wrapNodeCollection:(aNode documentAdaptor xpathChildOf: aNode nodeId) withDocumentAdaptor:(aNode documentAdaptor))
                select: [:node | node xpathIsIgnorableText not ])
                collect: [:node | aNode constructedChildren add: node. node constructedParent: aNode. ].
            ].
        ] ifNotNil:[
            ^aNode constructedChildren.
        ].
    ].

    "Modified: / 03-12-2006 / 12:41:52 / ked"
    "Created: / 14-12-2006 / 23:25:42 / janfrog"
!

primXpathElementValueOf: aNode

    aNode isXQueryConstructedNode ifTrue:[
        ^aNode nodeValue.
    ] ifFalse:[
        ^aNode documentAdaptor xpathElementValueOf: aNode nodeId.
    ].

    "Modified: / 03-11-2006 / 20:49:46 / ked"
    "Created: / 14-12-2006 / 23:28:05 / janfrog"
!

primXpathIsAttribute: aNode

    aNode isXQueryConstructedNode ifTrue:[
        ^aNode nodeType = XQueryConstructedNode nodeTypeAttribute.
    ] ifFalse:[
        ^aNode documentAdaptor xpathIsAttribute: aNode nodeId.
    ].

    "Created: / 14-12-2006 / 23:26:47 / janfrog"
!

primXpathIsDocument: aNode

    aNode isXQueryConstructedNode ifTrue:[
        "aNode nodeParent ifNil:[^true. ]."
        ^aNode nodeType = XQueryConstructedNode nodeTypeDocument.
    ] ifFalse:[
        ^aNode documentAdaptor xpathIsDocument: aNode nodeId.
    ].

    "Modified: / 03-11-2006 / 14:27:32 / ked"
    "Created: / 14-12-2006 / 23:26:59 / janfrog"
    "Modified: / 20-03-2007 / 22:36:39 / janfrog"
!

primXpathIsDocumentFragment:aNode
    "Superclass says that I am responsible to implement this method"

     aNode isXQueryConstructedNode ifTrue:[
        "aNode nodeParent ifNil:[^true. ]."
        "^aNode nodeType = XQueryConstructedNode nodeTypeDocumentFragment."
        ^false
    ] ifFalse:[
        ^aNode documentAdaptor xpathIsDocumentFragment: aNode nodeId.
    ].

    "Created: / 10-08-2007 / 09:16:21 / janfrog"
!

primXpathIsElement: aNode

    aNode isXQueryConstructedNode ifTrue:[
        ^aNode nodeType = XQueryConstructedNode nodeTypeElement.
    ] ifFalse:[
        ^aNode documentAdaptor xpathIsElement: aNode nodeId.
    ].

    "Created: / 14-12-2006 / 23:27:30 / janfrog"
!

primXpathIsText: aNode

    aNode isXQueryConstructedNode ifTrue:[
        ^aNode nodeType = XQueryConstructedNode nodeTypeText.
    ] ifFalse:[
        ^aNode documentAdaptor xpathIsText: aNode nodeId.
    ].

    "Created: / 14-12-2006 / 23:27:34 / janfrog"
!

primXpathLocalNameOf: aNode

    aNode isXQueryConstructedNode ifTrue:[
        ^aNode nodeName localName.
    ] ifFalse:[
        ^aNode documentAdaptor xpathLocalNameOf: aNode nodeId.
    ].

    "Modified: / 03-11-2006 / 20:49:58 / ked"
    "Created: / 14-12-2006 / 23:28:12 / janfrog"
    "Modified: / 24-12-2006 / 16:13:17 / janfrog"
!

primXpathNameOf: aNode

    aNode isXQueryConstructedNode ifTrue:[
        ^aNode nodeName qualifiedName.
    ] ifFalse:[
        ^aNode documentAdaptor xpathNameOf: aNode nodeId.
    ].

    "Modified: / 08-11-2006 / 12:55:29 / ked"
    "Created: / 14-12-2006 / 23:27:50 / janfrog"
    "Modified: / 24-12-2006 / 16:12:37 / janfrog"
!

primXpathNamespaceOf: aNode

    aNode isXQueryConstructedNode ifTrue:[
        ^aNode nodeName ns.
    ] ifFalse:[
        ^aNode documentAdaptor xpathNamespaceOf: aNode nodeId.
    ].

    "Modified: / 03-11-2006 / 20:50:06 / ked"
    "Created: / 14-12-2006 / 23:28:18 / janfrog"
    "Modified: / 24-12-2006 / 16:13:08 / janfrog"
!

primXpathParentOf: aNode

    aNode isXQueryConstructedNode ifTrue:[
        ^aNode nodeParent.
    ] ifFalse:[
        aNode constructedParent ifNil:[
            ^self wrapSingleNode:(aNode documentAdaptor xpathParentOf: aNode nodeId) withDocumentAdaptor:(aNode documentAdaptor).
        ] ifNotNil:[
            ^aNode constructedParent
        ].
    ].

    "Modified: / 03-11-2006 / 20:53:48 / ked"
    "Created: / 14-12-2006 / 23:25:58 / janfrog"
!

primXpathTextValueOf: aNode

    aNode isXQueryConstructedNode ifTrue:[
        ^aNode nodeValue.
    ] ifFalse:[
        ^aNode documentAdaptor xpathTextValueOf: aNode nodeId.
    ].

    "Modified: / 03-11-2006 / 20:50:12 / ked"
    "Created: / 14-12-2006 / 23:28:26 / janfrog"
! !

!XPathDocumentAdaptorProxy class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/stx/goodies/xmlsuite/xquery/XQuery__XPathDocumentAdaptorProxy.st,v 1.6 2007-08-10 07:36:50 vranyj1 Exp $'
! !
