"{ Package: 'stx:goodies/xmlsuite/xquery' }"

"{ NameSpace: XQuery }"

Object subclass:#XQueryAbstractNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XQuery-DataNodes'
!


!XQueryAbstractNode methodsFor:'accessing'!

documentAdaptor
    ^ self subclassResponsibility

    "Created: / 14-11-2007 / 15:07:38 / janfrog"
!

documentURI

    ^self subclassResponsibility

    "Created: / 20-09-2007 / 14:51:16 / janfrog"
!

nodeId

    ^self subclassResponsibility

    "Created: / 14-11-2007 / 13:51:02 / janfrog"
!

xqueryType

    self isAttributeNode ifTrue:[^TypeAttribute instance].
    self isElementNode ifTrue:[^TypeElement instance].
    self isTextNode ifTrue:[^TypeText instance].
    self isDocumentNode ifTrue:[^TypeDocument instance].

    self shouldNeverBeReached

    "Created: / 05-12-2007 / 15:08:54 / janfrog"
! !

!XQueryAbstractNode methodsFor:'accessing - xpath axes'!

xpathAncestor
    ^ self 
        transformNodeIds:(self documentAdaptor xpathAncestorOf:self nodeId).

    "Created: / 07-10-2006 / 22:05:08 / ked"
    "Modified: / 03-11-2006 / 12:00:09 / ked"
    "Modified: / 18-11-2007 / 08:02:18 / janfrog"
!

xpathAncestorOrSelf
    ^ self 
        transformNodeIds:(self documentAdaptor xpathAncestorOrSelfOf:self nodeId).

    "Created: / 07-10-2006 / 22:05:24 / ked"
    "Modified: / 03-11-2006 / 12:00:19 / ked"
    "Modified: / 18-11-2007 / 08:02:18 / janfrog"
!

xpathAttribute
    ^ self 
        transformNodeIds:(self documentAdaptor xpathAttributeOf:self nodeId).

    "Created: / 07-10-2006 / 22:05:38 / ked"
    "Modified: / 03-11-2006 / 12:00:32 / ked"
    "Modified: / 18-11-2007 / 08:02:18 / janfrog"
!

xpathChild
    ^ self transformNodeIds:(self documentAdaptor xpathChildOf:self nodeId).

    "Created: / 07-10-2006 / 22:06:01 / ked"
    "Modified: / 03-11-2006 / 12:00:52 / ked"
    "Modified: / 18-11-2007 / 08:02:18 / janfrog"
!

xpathDescendant
    ^ self 
        transformNodeIds:(self documentAdaptor xpathDescendantOf:self nodeId).

    "Created: / 07-10-2006 / 22:06:12 / ked"
    "Modified: / 03-11-2006 / 12:01:10 / ked"
    "Modified: / 18-11-2007 / 08:02:18 / janfrog"
!

xpathDescendantOrSelf
    ^ self transformNodeIds:(self documentAdaptor 
                xpathDescendantOrSelfOf:self nodeId).

    "Created: / 07-10-2006 / 22:06:25 / ked"
    "Modified: / 03-11-2006 / 12:01:26 / ked"
    "Modified: / 18-11-2007 / 08:02:18 / janfrog"
!

xpathDocument
    ^ self transformNodeId:(self documentAdaptor xpathDocument).

    "Created: / 19-10-2006 / 16:03:39 / ked"
    "Modified: / 03-11-2006 / 12:17:12 / ked"
    "Modified: / 21-11-2007 / 14:03:28 / janfrog"
!

xpathFollowing
    ^ self 
        transformNodeIds:(self documentAdaptor xpathFollowingOf:self nodeId).

    "Created: / 07-10-2006 / 22:06:34 / ked"
    "Modified: / 03-11-2006 / 12:03:07 / ked"
    "Modified: / 18-11-2007 / 08:02:18 / janfrog"
!

xpathFollowingSibling
    ^ self transformNodeIds:(self documentAdaptor 
                xpathFollowingSiblingOf:self nodeId).

    "Created: / 07-10-2006 / 22:06:54 / ked"
    "Modified: / 03-11-2006 / 12:03:18 / ked"
    "Modified: / 18-11-2007 / 08:02:18 / janfrog"
!

xpathParent
    self xpathIsDocument ifTrue:[^nil].
    ^ self transformNodeId:(self documentAdaptor xpathParentOf:self nodeId).

    "Created: / 07-10-2006 / 22:07:06 / ked"
    "Modified: / 03-11-2006 / 12:03:57 / ked"
    "Modified: / 05-12-2007 / 21:52:11 / janfrog"
!

xpathPreceding
    ^ self 
        transformNodeIds:(self documentAdaptor xpathPrecedingOf:self nodeId).

    "Created: / 07-10-2006 / 22:07:17 / ked"
    "Modified: / 03-11-2006 / 12:04:29 / ked"
    "Modified: / 18-11-2007 / 08:02:18 / janfrog"
!

xpathPrecedingSibling
    ^ self transformNodeIds:(self documentAdaptor 
                xpathPrecedingSiblingOf:self nodeId).

    "Created: / 07-10-2006 / 22:07:30 / ked"
    "Modified: / 03-11-2006 / 12:10:03 / ked"
    "Modified: / 18-11-2007 / 08:02:18 / janfrog"
!

xpathSelf
    ^ self transformNodeId:(self nodeId).

    "Created: / 07-10-2006 / 22:07:39 / ked"
    "Modified: / 03-11-2006 / 12:10:22 / ked"
    "Modified: / 21-11-2007 / 14:03:28 / janfrog"
! !

!XQueryAbstractNode methodsFor:'accessing - xpath tests'!

xpathIsAttribute
    ^ self documentAdaptor xpathIsAttribute:self nodeId.

    "Created: / 19-10-2006 / 16:03:38 / ked"
    "Modified: / 03-11-2006 / 12:11:09 / ked"
    "Modified: / 18-11-2007 / 08:13:11 / janfrog"
!

xpathIsDocument
    ^ self documentAdaptor xpathIsDocument:self nodeId.

    "Created: / 19-10-2006 / 16:03:39 / ked"
    "Modified: / 03-11-2006 / 12:11:27 / ked"
    "Modified: / 05-12-2007 / 21:43:46 / janfrog"
!

xpathIsElement
    ^ self documentAdaptor xpathIsElement:self nodeId.

    "Created: / 19-10-2006 / 16:03:39 / ked"
    "Modified: / 03-11-2006 / 12:11:39 / ked"
    "Modified: / 18-11-2007 / 08:13:59 / janfrog"
!

xpathIsIgnorableText
    ^ self documentAdaptor xpathIsIgnorableText:self nodeId.

    "Created: / 03-12-2006 / 12:18:49 / ked"
    "Modified: / 19-11-2007 / 12:47:16 / janfrog"
!

xpathIsText
    ^ self documentAdaptor xpathIsText:self nodeId.

    "Created: / 19-10-2006 / 16:03:39 / ked"
    "Modified: / 03-11-2006 / 12:11:50 / ked"
    "Modified: / 18-11-2007 / 08:09:17 / janfrog"
! !

!XQueryAbstractNode methodsFor:'accessing - xpath values'!

xpathLocalName
    ^ self documentAdaptor xpathLocalNameOf:self nodeId.

    "Modified: / 03-11-2006 / 12:12:04 / ked"
    "Created: / 24-12-2006 / 17:52:13 / janfrog"
    "Modified: / 18-11-2007 / 08:08:52 / janfrog"
!

xpathName
    ^ self documentAdaptor xpathNameOf:self nodeId.

    "Created: / 02-11-2006 / 11:47:47 / ked"
    "Modified: / 03-11-2006 / 12:12:04 / ked"
    "Modified: / 18-11-2007 / 09:40:55 / janfrog"
!

xpathNamespace
    ^ self documentAdaptor xpathNamespaceOf:self nodeId.

    "Modified: / 03-11-2006 / 12:12:04 / ked"
    "Created: / 24-12-2006 / 17:52:24 / janfrog"
    "Modified: / 18-11-2007 / 08:08:34 / janfrog"
!

xpathValue
    ^ self documentAdaptor xpathValueOf:self nodeId.

    "Created: / 07-10-2006 / 22:08:48 / ked"
    "Modified: / 03-11-2006 / 12:12:29 / ked"
    "Modified: / 18-11-2007 / 08:17:19 / janfrog"
! !

!XQueryAbstractNode methodsFor:'adding & removing'!

appendInto:parentElement 
    self isElementNode ifTrue:[
        ^ parentElement appendElement:self
    ].
    self isTextNode ifTrue:[
        ^ parentElement appendText:self
    ].
    self isAttributeNode ifTrue:[
        ^ parentElement appendAttribute:self
    ]

    "Created: / 29-03-2007 / 13:57:20 / janfrog"
! !

!XQueryAbstractNode methodsFor:'converting'!

asString 

    | result childrenCollection attributesCollection |

    self xpathIsText ifTrue:[
        ^self xpathValue.
    ].

    self xpathIsAttribute ifTrue:[
        ^self xpathName, '="', self xpathValue, '"'.
    ].

    self assert: self xpathIsElement | self xpathIsDocument.

    childrenCollection := self xpathChild.
    attributesCollection := self xpathAttribute.

    result := ''.

    self xpathIsElement ifTrue:[
        result := result, '<', self xpathName.

        attributesCollection do:[:attribute |
            result := result, ' ', attribute asString.
        ].

        childrenCollection size > 0 ifTrue:[
            result := result, '>'.
        ] ifFalse:[
            result := result, ' />'.
        ].
    ].

    childrenCollection do:[:child |
        result := result, child asString.
    ].

    self xpathIsElement & (childrenCollection size > 0) ifTrue:[
        result := result, '</', self xpathName,'>'.
    ].

    ^result.

    "Created: / 01-12-2006 / 12:36:32 / ked"
! !

!XQueryAbstractNode methodsFor:'copying'!

copyNodeWithParent: aParent

    self subclassResponsibility

    "Created: / 03-11-2006 / 16:49:54 / ked"
! !

!XQueryAbstractNode methodsFor:'private'!

transformNodeId:aSingleNode

    ^self transformNodeIds:(Array with: aSingleNode)

    "Created: / 21-11-2007 / 14:03:28 / janfrog"
!

transformNodeIds:arg 
    "raise an error: must be redefined in concrete subclass(es)"

    ^ self subclassResponsibility

    "Created: / 18-11-2007 / 08:02:50 / janfrog"
! !

!XQueryAbstractNode methodsFor:'queries'!

hasParent

    ^self xpathParent notNil

    "Created: / 21-11-2007 / 09:28:15 / janfrog"
! !

!XQueryAbstractNode methodsFor:'testing'!

isAttributeNode
    "raise an error: must be redefined in concrete subclass(es)"

    ^ self subclassResponsibility

    "Created: / 29-03-2007 / 13:55:15 / janfrog"
!

isCellStoreNode

    ^false

    "Created: / 14-11-2007 / 13:59:33 / janfrog"
!

isDocumentNode

    ^ false

    "Created: / 14-11-2007 / 11:51:39 / janfrog"
    "Modified: / 14-11-2007 / 14:04:01 / janfrog"
!

isElementNode
    "raise an error: must be redefined in concrete subclass(es)"

    ^ self subclassResponsibility

    "Created: / 29-03-2007 / 13:55:15 / janfrog"
!

isElementOrAttributeNode

    ^self isElementNode 
        or:[self isAttributeNode]

    "Created: / 29-03-2007 / 16:01:39 / janfrog"
!

isTextNode
    "raise an error: must be redefined in concrete subclass(es)"

    ^ self subclassResponsibility

    "Created: / 29-03-2007 / 13:55:15 / janfrog"
!

isXQueryAccessedNode
    ^ false

    "Modified: / 29-10-2006 / 15:30:47 / ked"
!

isXQueryConstructedNode
    ^ false

    "Created: / 29-10-2006 / 15:30:47 / ked"
! !

!XQueryAbstractNode class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/stx/goodies/xmlsuite/xquery/XQuery__XQueryAbstractNode.st,v 1.12 2007-12-05 21:08:24 vranyj1 Exp $'
! !
