"{ Package: 'stx:goodies/xmlsuite/xquery' }"

"{ NameSpace: XQuery }"

Object subclass:#XQueryExecutor
	instanceVariableNames:'astTree documentProvider documentAdaptorsPool interpreter'
	classVariableNames:''
	poolDictionaries:''
	category:'XQuery-Executor'
!


!XQueryExecutor class methodsFor:'instance creation'!

new
    ^ self basicNew initialize.

    "Created: / 29-08-2007 / 09:39:50 / janfrog"
! !

!XQueryExecutor class methodsFor:'defaults'!

defaultDocumentProvider
    "default value for the 'documentProvider' instance variable (automatically generated)"

    ^XMLv2::XPathDocumentProvider default.

    "Created: / 19-10-2006 / 23:12:33 / ked"
    "Modified: / 02-12-2006 / 12:00:09 / ked"
    "Modified: / 05-12-2006 / 14:59:22 / janfrog"
! !

!XQueryExecutor methodsFor:'accessing'!

astTree
    ^ astTree

    "Created: / 31-03-2006 / 17:34:36 / ked"
!

astTree:something
    astTree := something.

    "Created: / 31-03-2006 / 17:34:36 / ked"
!

documentProvider
    documentProvider isNil ifTrue:[documentProvider := self class defaultDocumentProvider].
    ^ documentProvider

    "Created: / 19-10-2006 / 23:12:33 / ked"
    "Modified: / 10-12-2006 / 13:30:28 / janfrog"
!

documentProvider:aDocumentProvider

    <resource: #obsolete>
    self obsoleteMethodWarning.
    
    self setDocumentProvider: aDocumentProvider

    "Created: / 19-10-2006 / 23:12:33 / ked"
    "Modified: / 10-12-2006 / 13:28:58 / janfrog"
!

xqueryInterpreterClass
    ^ XQueryInterpreter

    "Created: / 14-11-2007 / 11:25:27 / janfrog"
! !

!XQueryExecutor methodsFor:'accessing - document'!

documentAdaptorsFor: aURI

    documentAdaptorsPool ifNil:[
        documentAdaptorsPool := Dictionary new.
    ].

    ^documentAdaptorsPool at: aURI ifAbsentPut:[
        
        (self documentProvider documentAdaptorsFor: aURI)
    ].

    "Modified: / 02-12-2006 / 11:59:45 / ked"
    "Created: / 20-09-2007 / 10:34:10 / janfrog"
!

releaseDocumentAdaptors
    documentAdaptorsPool ifNotNil:[
        documentAdaptorsPool do:[:documentAdaptor |
            documentAdaptor releaseResources.
        ].
        documentAdaptorsPool := nil.
    ].

    "Created: / 25-10-2006 / 09:24:43 / ked"
    "Modified: / 02-11-2006 / 10:28:44 / ked"
! !

!XQueryExecutor methodsFor:'evaluation'!

evaluate: aString

    "Provided for compatibility with @class XMLv2::XPathProcessor"

    ^self executeQuery: aString

    "Created: / 10-12-2006 / 13:32:17 / janfrog"
! !

!XQueryExecutor methodsFor:'initialization'!

initialize
    "Invoked when a new instance is created."
    "/ please change as required (and remove this comment)
    "/ astTree := nil.
    "/ documentProvider := nil.
    "/ documentAdaptorsPool := nil.
    "/ super initialize.   -- commented since inherited method does nothing
    
    interpreter := self xqueryInterpreterClass new

    "Created: / 29-08-2007 / 09:39:50 / janfrog"
    "Modified: / 14-11-2007 / 11:25:27 / janfrog"
!

setDocumentAdaptor: aDocumentAdaptor

    "Ignored. Provided fr compatilibility with @class XPathProcessor"

    "Created: / 10-12-2006 / 13:30:13 / janfrog"
!

setDocumentProvider: aDocumentProvider

    documentProvider := aDocumentProvider

    "Created: / 10-12-2006 / 13:29:28 / janfrog"
! !

!XQueryExecutor methodsFor:'libraries'!

loadFunctionLibrary: aFunctionLibrary

    interpreter loadFunctionLibrary: aFunctionLibrary

    "Created: / 29-08-2007 / 09:39:23 / janfrog"
! !

!XQueryExecutor methodsFor:'queries'!

executeQuery: queryString

    |millisecondsToRun resultSequence|

    millisecondsToRun := Time millisecondsToRun:
                            [resultSequence := self primExecuteQuery: queryString].

    ^(XQueryResult withAll:resultSequence)       
        setQueryString: queryString;
        setQueryTime: 
            (millisecondsToRun > 0
                ifTrue:[TimeDuration new setMilliseconds: millisecondsToRun]
                ifFalse:[nil]);
        yourself.

    "Created: / 31-03-2006 / 17:48:31 / ked"
    "Modified: / 03-12-2006 / 22:01:11 / ked"
    "Modified: / 21-11-2007 / 15:51:00 / janfrog"
!

primExecuteQuery:queryString 
    |result|

    Object errorSignal 
        handle:[:ex | XQueryParserError raiseErrorString:ex messageText. ]
        do:[ astTree := XQueryParser parseQuery:queryString. ].
    Object errorSignal 
        handle:[:ex | XQueryInterpreterError raiseErrorString:ex messageText. ]
        do:[ result := interpreter evaluateNode:self ].
    ^ result

    "Modified: / 03-12-2006 / 22:01:11 / ked"
    "Created: / 24-12-2006 / 13:53:35 / janfrog"
    "Modified: / 21-11-2007 / 15:41:07 / janfrog"
! !

!XQueryExecutor class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/stx/goodies/xmlsuite/xquery/XQuery__XQueryExecutor.st,v 1.7 2007-11-22 21:56:49 vranyj1 Exp $'
! !
