"{ Package: 'stx:goodies/xmlsuite/xquery' }"

"{ NameSpace: XQuery }"

Perseus::Scanner subclass:#XQueryScanner
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XQuery-Executor'
!


!XQueryScanner class methodsFor:'generated-comments'!

scannerDefinitionComment

	"<whitespace> : \s+;
<char> : [a-zA-Z];
<digit> : [0-9];
<char_ref> : ((&\#[0-9]+\;) | (&\#x[0-9a-fA-F]+\;));

<ncnamechar> : (<char> | <digit> | \. | \- | \_);
<ncname> : (<char> | \_) (<ncnamechar>)*;
<qname> : (<ncname> \:)? <ncname>;

<digits> : [0-9]+;
<integer_literal> : <digits>;
<decimal_literal> : (\.<digits>) | (<digits>\.[0-9]*);
<double_literal> : ((\.<digits>) | (<digits>(\.[0-9]*)?)) [eE] [\+\-]? <digits>;

<predefined_entity_ref> : &(lt | gt | amp | quot | apos)\;;
<escape_quot> : """";
<escape_apos> : '';

<string_literal> : ("" (<predefined_entity_ref> | <char_ref> | <escape_quot> | [^""&])* "") | (' (<predefined_entity_ref> | <char_ref> | <escape_apos> | [^'&])* ');

<element_content_char> : <char> - [{}<&];
<qout_attr_content_char> : <char> - [""{}<&];
<apos_attr_content_char> : <char> - ['{}<&];
"
! !

!XQueryScanner class methodsFor:'generated-initialization'!

initializeKeywordMap
    keywordMap := Dictionary new.
    #( #(112 'after' 71)
     #(112 'ancestor' 108)
     #(112 'and' 6)
     #(112 'as' 69)
     #(112 'ascending' 44)
     #(112 'at' 51)
     #(112 'attribute' 87)
     #(112 'before' 72)
     #(112 'by' 48)
     #(112 'child' 90)
     #(112 'comment' comment)
     #(112 'copy' 74)
     #(112 'declare' 37)
     #(112 'default' 38)
     #(112 'delete' 60)
     #(112 'descendant' 86)
     #(112 'descending' 45)
     #(112 'div' 7)
     #(112 'do' 59)
     #(112 'document' 67)
     #(112 'element' 39)
     #(112 'else' 12)
     #(112 'empty' 46)
     #(112 'eq' 17)
     #(112 'every' 9)
     #(112 'except' 25)
     #(112 'first' 75)
     #(112 'following' 105)
     #(112 'for' 55)
     #(112 'function' 33)
     #(112 'ge' 92)
     #(112 'greatest' 49)
     #(112 'gt' 84)
     #(112 'idiv' 13)
     #(112 'if' 10)
     #(112 'in' 50)
     #(112 'insert' 81)
     #(112 'intersect' 24)
     #(112 'into' 82)
     #(112 'is' 93)
     #(112 'last' 76)
     #(112 'le' 42)
     #(112 'least' 21)
     #(112 'let' 52)
     #(112 'lt' 28)
     #(112 'mod' 27)
     #(112 'modify' 56)
     #(112 'namespace' 40)
     #(112 'ne' 18)
     #(112 'node' 57)
     #(112 'of' 79)
     #(112 'or' 5)
     #(112 'order' 47)
     #(112 'ordered' 98)
     #(112 'parent' 107)
     #(112 'preceding' 103)
     #(112 'rename' 63)
     #(112 'replace' 83)
     #(112 'return' 41)
     #(112 'satisfies' 8)
     #(112 'self' 88)
     #(112 'some' 14)
     #(112 'stable' 43)
     #(112 'text' 68)
     #(112 'then' 11)
     #(112 'to' 1)
     #(112 'transform' 73)
     #(112 'union' 22)
     #(112 'unordered' 64)
     #(112 'updating' 29)
     #(112 'value' 78)
     #(112 'where' 54)
     #(112 'with' 80)
     #(113 'after' 71)
     #(113 'ancestor' 108)
     #(113 'and' 6)
     #(113 'as' 69)
     #(113 'ascending' 44)
     #(113 'at' 51)
     #(113 'attribute' 87)
     #(113 'before' 72)
     #(113 'by' 48)
     #(113 'child' 90)
     #(113 'comment' comment)
     #(113 'copy' 74)
     #(113 'declare' 37)
     #(113 'default' 38)
     #(113 'delete' 60)
     #(113 'descendant' 86)
     #(113 'descending' 45)
     #(113 'div' 7)
     #(113 'do' 59)
     #(113 'document' 67)
     #(113 'element' 39)
     #(113 'else' 12)
     #(113 'empty' 46)
     #(113 'eq' 17)
     #(113 'every' 9)
     #(113 'except' 25)
     #(113 'first' 75)
     #(113 'following' 105)
     #(113 'for' 55)
     #(113 'function' 33)
     #(113 'ge' 92)
     #(113 'greatest' 49)
     #(113 'gt' 84)
     #(113 'idiv' 13)
     #(113 'if' 10)
     #(113 'in' 50)
     #(113 'insert' 81)
     #(113 'intersect' 24)
     #(113 'into' 82)
     #(113 'is' 93)
     #(113 'last' 76)
     #(113 'le' 42)
     #(113 'least' 21)
     #(113 'let' 52)
     #(113 'lt' 28)
     #(113 'mod' 27)
     #(113 'modify' 56)
     #(113 'namespace' 40)
     #(113 'ne' 18)
     #(113 'node' 57)
     #(113 'of' 79)
     #(113 'or' 5)
     #(113 'order' 47)
     #(113 'ordered' 98)
     #(113 'parent' 107)
     #(113 'preceding' 103)
     #(113 'rename' 63)
     #(113 'replace' 83)
     #(113 'return' 41)
     #(113 'satisfies' 8)
     #(113 'self' 88)
     #(113 'some' 14)
     #(113 'stable' 43)
     #(113 'text' 68)
     #(113 'then' 11)
     #(113 'to' 1)
     #(113 'transform' 73)
     #(113 'union' 22)
     #(113 'unordered' 64)
     #(113 'updating' 29)
     #(113 'value' 78)
     #(113 'where' 54)
     #(113 'with' 80) ) 
            do:[:each | 
                (keywordMap at:each first ifAbsentPut:[ Dictionary new ]) at:(each at:2)
                    put:each last
            ].
    ^ keywordMap
! !

!XQueryScanner methodsFor:'accessing'!

source

    ^stream isExternalStream
        ifTrue:[self sourceFromExternalStream]
        ifFalse:[self sourceFromInternalStream]

    "Created: / 12-04-2007 / 11:52:21 / janfrog"
!

sourceFromExternalStream

    ^self shouldImplement "not yet implemented"

    "Created: / 12-04-2007 / 11:53:47 / janfrog"
!

sourceFromInternalStream

    ^stream collection asString.

    "Created: / 12-04-2007 / 11:54:00 / janfrog"
!

stream
    ^stream

    "Created: / 24-10-2007 / 15:55:43 / janfrog"
! !

!XQueryScanner methodsFor:'generated-scanner'!

scan1
    self step.
    (currentCharacter isLetter or:[ currentCharacter == $_ ]) ifTrue:[
        [
            self recordMatch:#( 113 ).
            self step.
            (currentCharacter isLetterOrDigit 
                or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ])
        ] whileTrue.
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch
!

scan10
    [
        self step.
        (currentCharacter <= $% or:[ currentCharacter >= $( ])
    ] whileTrue.
    (currentCharacter == $&) ifTrue:[
        self step.
        (currentCharacter == $g or:[ currentCharacter == $l ]) ifTrue:[
            ^ self scan8
        ].
        (currentCharacter == $#) ifTrue:[
            self step.
            (currentCharacter isXMLDigit) ifTrue:[
                [
                    self step.
                    (currentCharacter isXMLDigit)
                ] whileTrue.
                (currentCharacter == $;) ifTrue:[
                    ^ self scan10
                ].
                ^ self reportLastMatch
            ].
            (currentCharacter == $x) ifTrue:[
                self step.
                (currentCharacter isXMLDigit 
                    or:[
                        (currentCharacter between:$A and:$F) 
                            or:[ (currentCharacter between:$a and:$f) ]
                    ]) 
                        ifTrue:[
                            [
                                self step.
                                (currentCharacter isXMLDigit 
                                    or:[
                                        (currentCharacter between:$A and:$F) 
                                            or:[ (currentCharacter between:$a and:$f) ]
                                    ])
                            ] whileTrue.
                            (currentCharacter == $;) ifTrue:[
                                ^ self scan10
                            ].
                            ^ self reportLastMatch
                        ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        (currentCharacter == $a) ifTrue:[
            self step.
            (currentCharacter == $m) ifTrue:[
                self step.
                (currentCharacter == $p) ifTrue:[
                    ^ self scan9
                ].
                ^ self reportLastMatch
            ].
            (currentCharacter == $p) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    self step.
                    (currentCharacter == $s) ifTrue:[
                        ^ self scan9
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        (currentCharacter == $q) ifTrue:[
            self step.
            (currentCharacter == $u) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    ^ self scan8
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $') ifTrue:[
        self recordMatch:#( 118 ).
        self step.
        (currentCharacter == $') ifTrue:[
            ^ self scan10
        ].
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch
!

scan11
    [
        self recordMatch:#( 112 113 ).
        self step.
        (currentCharacter isLetterOrDigit 
            or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ])
    ] whileTrue.
    (currentCharacter == $:) ifTrue:[
        ^ self scan1
    ].
    ^ self reportLastMatch
!

scan12
    self recordMatch:#( 112 113 ).
    self step.
    ((currentCharacter between:$- and:$.) 
        or:[
            (currentCharacter between:$0 and:$9) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$q) 
                                        or:[ (currentCharacter between:$s and:$z) ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan11 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan1
    ].
    (currentCharacter == $r) ifTrue:[
        ^ self scan15
    ].
    ^ self reportLastMatch
!

scan13
    self recordMatch:#( 112 113 ).
    self step.
    (currentCharacter isXMLDigit 
        or:[
            (currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$d) 
                                        or:[
                                            (currentCharacter between:$f and:$n) 
                                                or:[ (currentCharacter between:$p and:$z) ]
                                        ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan11 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan1
    ].
    (currentCharacter == $e) ifTrue:[
        self recordMatch:#( 112 113 ).
        self step.
        ((currentCharacter between:$- and:$.) 
            or:[
                (currentCharacter between:$0 and:$9) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$r) 
                                            or:[ (currentCharacter between:$t and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan11 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan1
        ].
        (currentCharacter == $s) ifTrue:[
            self recordMatch:#( 112 113 ).
            self step.
            ((currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$0 and:$9) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$b) 
                                                or:[ (currentCharacter between:$d and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan11 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan1
            ].
            (currentCharacter == $c) ifTrue:[
                self recordMatch:#( 112 113 ).
                self step.
                (currentCharacter isXMLDigit 
                    or:[
                        (currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$d) 
                                                    or:[ (currentCharacter between:$f and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan11 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan1
                ].
                (currentCharacter == $e) ifTrue:[
                    self recordMatch:#( 112 113 ).
                    self step.
                    ((currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$0 and:$9) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$m) 
                                                        or:[ (currentCharacter between:$o and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan11 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan1
                    ].
                    (currentCharacter == $n) ifTrue:[
                        self recordMatch:#( 112 113 ).
                        self step.
                        ((currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$0 and:$9) 
                                    or:[
                                        (currentCharacter between:$A and:$Z) 
                                            or:[
                                                currentCharacter == $_ 
                                                    or:[
                                                        (currentCharacter between:$a and:$c) 
                                                            or:[ (currentCharacter between:$e and:$z) ]
                                                    ]
                                            ]
                                    ]
                            ]) 
                                ifTrue:[ ^ self scan11 ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan1
                        ].
                        (currentCharacter == $d) ifTrue:[
                            self recordMatch:#( 112 113 ).
                            self step.
                            (currentCharacter isXMLDigit 
                                or:[
                                    (currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[ currentCharacter == $_ or:[ (currentCharacter between:$b and:$z) ] ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan11 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan1
                            ].
                            (currentCharacter == $a) ifTrue:[
                                self recordMatch:#( 112 113 ).
                                self step.
                                ((currentCharacter between:$- and:$.) 
                                    or:[
                                        (currentCharacter between:$0 and:$9) 
                                            or:[
                                                (currentCharacter between:$A and:$Z) 
                                                    or:[
                                                        currentCharacter == $_ 
                                                            or:[
                                                                (currentCharacter between:$a and:$m) 
                                                                    or:[ (currentCharacter between:$o and:$z) ]
                                                            ]
                                                    ]
                                            ]
                                    ]) 
                                        ifTrue:[ ^ self scan11 ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan1
                                ].
                                (currentCharacter == $n) ifTrue:[
                                    self recordMatch:#( 112 113 ).
                                    self step.
                                    ((currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$0 and:$9) 
                                                or:[
                                                    (currentCharacter between:$A and:$Z) 
                                                        or:[
                                                            currentCharacter == $_ 
                                                                or:[
                                                                    (currentCharacter between:$a and:$s) 
                                                                        or:[ (currentCharacter between:$u and:$z) ]
                                                                ]
                                                        ]
                                                ]
                                        ]) 
                                            ifTrue:[ ^ self scan11 ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan1
                                    ].
                                    (currentCharacter == $t) ifTrue:[
                                        self recordMatch:#( 112 113 ).
                                        self step.
                                        (currentCharacter isLetterOrDigit 
                                            or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                                ifTrue:[ ^ self scan11 ].
                                        (currentCharacter == $-) ifTrue:[
                                            self recordMatch:#( 112 113 ).
                                            self step.
                                            (currentCharacter isXMLDigit 
                                                or:[
                                                    (currentCharacter between:$- and:$.) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[
                                                                            (currentCharacter between:$a and:$n) 
                                                                                or:[ (currentCharacter between:$p and:$z) ]
                                                                        ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan11 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan1
                                            ].
                                            (currentCharacter == $o) ifTrue:[
                                                self recordMatch:#( 112 113 ).
                                                self step.
                                                ((currentCharacter between:$- and:$.) 
                                                    or:[
                                                        (currentCharacter between:$0 and:$9) 
                                                            or:[
                                                                (currentCharacter between:$A and:$Z) 
                                                                    or:[
                                                                        currentCharacter == $_ 
                                                                            or:[
                                                                                (currentCharacter between:$a and:$q) 
                                                                                    or:[ (currentCharacter between:$s and:$z) ]
                                                                            ]
                                                                    ]
                                                            ]
                                                    ]) 
                                                        ifTrue:[ ^ self scan11 ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan1
                                                ].
                                                (currentCharacter == $r) ifTrue:[
                                                    self recordMatch:#( 112 113 ).
                                                    self step.
                                                    (currentCharacter isLetterOrDigit 
                                                        or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                                            ifTrue:[ ^ self scan11 ].
                                                    (currentCharacter == $-) ifTrue:[
                                                        self recordMatch:#( 112 113 ).
                                                        self step.
                                                        ((currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$0 and:$9) 
                                                                    or:[
                                                                        (currentCharacter between:$A and:$Z) 
                                                                            or:[
                                                                                currentCharacter == $_ 
                                                                                    or:[
                                                                                        (currentCharacter between:$a and:$r) 
                                                                                            or:[ (currentCharacter between:$t and:$z) ]
                                                                                    ]
                                                                            ]
                                                                    ]
                                                            ]) 
                                                                ifTrue:[ ^ self scan11 ].
                                                        (currentCharacter == $:) ifTrue:[
                                                            ^ self scan1
                                                        ].
                                                        (currentCharacter == $s) ifTrue:[
                                                            self recordMatch:#( 112 113 ).
                                                            self step.
                                                            (currentCharacter isXMLDigit 
                                                                or:[
                                                                    (currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$A and:$Z) 
                                                                                or:[
                                                                                    currentCharacter == $_ 
                                                                                        or:[
                                                                                            (currentCharacter between:$a and:$d) 
                                                                                                or:[ (currentCharacter between:$f and:$z) ]
                                                                                        ]
                                                                                ]
                                                                        ]
                                                                ]) 
                                                                    ifTrue:[ ^ self scan11 ].
                                                            (currentCharacter == $:) ifTrue:[
                                                                ^ self scan1
                                                            ].
                                                            (currentCharacter == $e) ifTrue:[
                                                                self recordMatch:#( 112 113 ).
                                                                self step.
                                                                ((currentCharacter between:$- and:$.) 
                                                                    or:[
                                                                        (currentCharacter between:$0 and:$9) 
                                                                            or:[
                                                                                (currentCharacter between:$A and:$Z) 
                                                                                    or:[
                                                                                        currentCharacter == $_ 
                                                                                            or:[
                                                                                                (currentCharacter between:$a and:$k) 
                                                                                                    or:[ (currentCharacter between:$m and:$z) ]
                                                                                            ]
                                                                                    ]
                                                                            ]
                                                                    ]) 
                                                                        ifTrue:[ ^ self scan11 ].
                                                                (currentCharacter == $:) ifTrue:[
                                                                    ^ self scan1
                                                                ].
                                                                (currentCharacter == $l) ifTrue:[
                                                                    self recordMatch:#( 112 113 ).
                                                                    self step.
                                                                    ((currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$0 and:$9) 
                                                                                or:[
                                                                                    (currentCharacter between:$A and:$Z) 
                                                                                        or:[
                                                                                            currentCharacter == $_ 
                                                                                                or:[
                                                                                                    (currentCharacter between:$a and:$e) 
                                                                                                        or:[ (currentCharacter between:$g and:$z) ]
                                                                                                ]
                                                                                        ]
                                                                                ]
                                                                        ]) 
                                                                            ifTrue:[ ^ self scan11 ].
                                                                    (currentCharacter == $:) ifTrue:[
                                                                        ^ self scan1
                                                                    ].
                                                                    (currentCharacter == $f) ifTrue:[
                                                                        self recordMatch:#( 91 112 113 ).
                                                                        self step.
                                                                        (currentCharacter isLetterOrDigit 
                                                                            or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                                                ifTrue:[ ^ self scan11 ].
                                                                        (currentCharacter == $:) ifTrue:[
                                                                            ^ self scan1
                                                                        ].
                                                                        ^ self reportLastMatch
                                                                    ].
                                                                    ^ self reportLastMatch
                                                                ].
                                                                ^ self reportLastMatch
                                                            ].
                                                            ^ self reportLastMatch
                                                        ].
                                                        ^ self reportLastMatch
                                                    ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan1
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan1
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    ^ self reportLastMatch
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $o) ifTrue:[
        self recordMatch:#( 112 113 ).
        self step.
        ((currentCharacter between:$- and:$.) 
            or:[
                (currentCharacter between:$0 and:$9) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$b) 
                                            or:[ (currentCharacter between:$d and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan11 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan1
        ].
        (currentCharacter == $c) ifTrue:[
            self recordMatch:#( 112 113 ).
            self step.
            (currentCharacter isXMLDigit 
                or:[
                    (currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$t) 
                                                or:[ (currentCharacter between:$v and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan11 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan1
            ].
            (currentCharacter == $u) ifTrue:[
                self recordMatch:#( 112 113 ).
                self step.
                ((currentCharacter between:$- and:$.) 
                    or:[
                        (currentCharacter between:$0 and:$9) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$l) 
                                                    or:[ (currentCharacter between:$n and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan11 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan1
                ].
                (currentCharacter == $m) ifTrue:[
                    self recordMatch:#( 112 113 ).
                    self step.
                    (currentCharacter isXMLDigit 
                        or:[
                            (currentCharacter between:$- and:$.) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$d) 
                                                        or:[ (currentCharacter between:$f and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan11 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan1
                    ].
                    (currentCharacter == $e) ifTrue:[
                        self recordMatch:#( 112 113 ).
                        self step.
                        ((currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$0 and:$9) 
                                    or:[
                                        (currentCharacter between:$A and:$Z) 
                                            or:[
                                                currentCharacter == $_ 
                                                    or:[
                                                        (currentCharacter between:$a and:$m) 
                                                            or:[ (currentCharacter between:$o and:$z) ]
                                                    ]
                                            ]
                                    ]
                            ]) 
                                ifTrue:[ ^ self scan11 ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan1
                        ].
                        (currentCharacter == $n) ifTrue:[
                            self recordMatch:#( 112 113 ).
                            self step.
                            ((currentCharacter between:$- and:$.) 
                                or:[
                                    (currentCharacter between:$0 and:$9) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[
                                                    currentCharacter == $_ 
                                                        or:[
                                                            (currentCharacter between:$a and:$s) 
                                                                or:[ (currentCharacter between:$u and:$z) ]
                                                        ]
                                                ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan11 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan1
                            ].
                            (currentCharacter == $t) ifTrue:[
                                self recordMatch:#( 112 113 ).
                                self step.
                                (currentCharacter isLetterOrDigit 
                                    or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                        ifTrue:[ ^ self scan11 ].
                                (currentCharacter == $-) ifTrue:[
                                    self recordMatch:#( 112 113 ).
                                    self step.
                                    ((currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$0 and:$9) 
                                                or:[
                                                    (currentCharacter between:$A and:$Z) 
                                                        or:[
                                                            currentCharacter == $_ 
                                                                or:[
                                                                    (currentCharacter between:$a and:$m) 
                                                                        or:[ (currentCharacter between:$o and:$z) ]
                                                                ]
                                                        ]
                                                ]
                                        ]) 
                                            ifTrue:[ ^ self scan11 ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan1
                                    ].
                                    (currentCharacter == $n) ifTrue:[
                                        self recordMatch:#( 112 113 ).
                                        self step.
                                        (currentCharacter isXMLDigit 
                                            or:[
                                                (currentCharacter between:$- and:$.) 
                                                    or:[
                                                        (currentCharacter between:$A and:$Z) 
                                                            or:[
                                                                currentCharacter == $_ 
                                                                    or:[
                                                                        (currentCharacter between:$a and:$n) 
                                                                            or:[ (currentCharacter between:$p and:$z) ]
                                                                    ]
                                                            ]
                                                    ]
                                            ]) 
                                                ifTrue:[ ^ self scan11 ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan1
                                        ].
                                        (currentCharacter == $o) ifTrue:[
                                            self recordMatch:#( 112 113 ).
                                            self step.
                                            ((currentCharacter between:$- and:$.) 
                                                or:[
                                                    (currentCharacter between:$0 and:$9) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[
                                                                            (currentCharacter between:$a and:$c) 
                                                                                or:[ (currentCharacter between:$e and:$z) ]
                                                                        ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan11 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan1
                                            ].
                                            (currentCharacter == $d) ifTrue:[
                                                self recordMatch:#( 112 113 ).
                                                self step.
                                                (currentCharacter isXMLDigit 
                                                    or:[
                                                        (currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$A and:$Z) 
                                                                    or:[
                                                                        currentCharacter == $_ 
                                                                            or:[
                                                                                (currentCharacter between:$a and:$d) 
                                                                                    or:[ (currentCharacter between:$f and:$z) ]
                                                                            ]
                                                                    ]
                                                            ]
                                                    ]) 
                                                        ifTrue:[ ^ self scan11 ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan1
                                                ].
                                                (currentCharacter == $e) ifTrue:[
                                                    self recordMatch:#( 58 112 113 ).
                                                    self step.
                                                    (currentCharacter isLetterOrDigit 
                                                        or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                            ifTrue:[ ^ self scan11 ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan1
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    ^ self reportLastMatch
                                ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan1
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch
!

scan14
    [
        self recordMatch:#( 115 ).
        self step.
        (currentCharacter isXMLDigit)
    ] whileTrue.
    (currentCharacter == $E or:[ currentCharacter == $e ]) ifTrue:[
        ^ self scan2
    ].
    ^ self reportLastMatch
!

scan15
    self recordMatch:#( 112 113 ).
    self step.
    (currentCharacter isXMLDigit 
        or:[
            (currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$d) 
                                        or:[
                                            (currentCharacter between:$f and:$n) 
                                                or:[ (currentCharacter between:$p and:$z) ]
                                        ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan11 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan1
    ].
    (currentCharacter == $e) ifTrue:[
        self recordMatch:#( 112 113 ).
        self step.
        ((currentCharacter between:$- and:$.) 
            or:[
                (currentCharacter between:$0 and:$9) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$b) 
                                            or:[ (currentCharacter between:$d and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan11 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan1
        ].
        (currentCharacter == $c) ifTrue:[
            self recordMatch:#( 112 113 ).
            self step.
            (currentCharacter isXMLDigit 
                or:[
                    (currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$d) 
                                                or:[ (currentCharacter between:$f and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan11 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan1
            ].
            (currentCharacter == $e) ifTrue:[
                self recordMatch:#( 112 113 ).
                self step.
                ((currentCharacter between:$- and:$.) 
                    or:[
                        (currentCharacter between:$0 and:$9) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$c) 
                                                    or:[ (currentCharacter between:$e and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan11 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan1
                ].
                (currentCharacter == $d) ifTrue:[
                    self recordMatch:#( 112 113 ).
                    self step.
                    (currentCharacter isXMLDigit 
                        or:[
                            (currentCharacter between:$- and:$.) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$h) 
                                                        or:[ (currentCharacter between:$j and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan11 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan1
                    ].
                    (currentCharacter == $i) ifTrue:[
                        self recordMatch:#( 112 113 ).
                        self step.
                        ((currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$0 and:$9) 
                                    or:[
                                        (currentCharacter between:$A and:$Z) 
                                            or:[
                                                currentCharacter == $_ 
                                                    or:[
                                                        (currentCharacter between:$a and:$m) 
                                                            or:[ (currentCharacter between:$o and:$z) ]
                                                    ]
                                            ]
                                    ]
                            ]) 
                                ifTrue:[ ^ self scan11 ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan1
                        ].
                        (currentCharacter == $n) ifTrue:[
                            self recordMatch:#( 112 113 ).
                            self step.
                            ((currentCharacter between:$- and:$.) 
                                or:[
                                    (currentCharacter between:$0 and:$9) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[
                                                    currentCharacter == $_ 
                                                        or:[
                                                            (currentCharacter between:$a and:$f) 
                                                                or:[ (currentCharacter between:$h and:$z) ]
                                                        ]
                                                ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan11 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan1
                            ].
                            (currentCharacter == $g) ifTrue:[
                                self recordMatch:#( 112 113 ).
                                self step.
                                (currentCharacter isLetterOrDigit 
                                    or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                        ifTrue:[ ^ self scan11 ].
                                (currentCharacter == $-) ifTrue:[
                                    self recordMatch:#( 112 113 ).
                                    self step.
                                    ((currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$0 and:$9) 
                                                or:[
                                                    (currentCharacter between:$A and:$Z) 
                                                        or:[
                                                            currentCharacter == $_ 
                                                                or:[
                                                                    (currentCharacter between:$a and:$r) 
                                                                        or:[ (currentCharacter between:$t and:$z) ]
                                                                ]
                                                        ]
                                                ]
                                        ]) 
                                            ifTrue:[ ^ self scan11 ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan1
                                    ].
                                    (currentCharacter == $s) ifTrue:[
                                        self recordMatch:#( 112 113 ).
                                        self step.
                                        (currentCharacter isXMLDigit 
                                            or:[
                                                (currentCharacter between:$- and:$.) 
                                                    or:[
                                                        (currentCharacter between:$A and:$Z) 
                                                            or:[
                                                                currentCharacter == $_ 
                                                                    or:[
                                                                        (currentCharacter between:$a and:$h) 
                                                                            or:[ (currentCharacter between:$j and:$z) ]
                                                                    ]
                                                            ]
                                                    ]
                                            ]) 
                                                ifTrue:[ ^ self scan11 ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan1
                                        ].
                                        (currentCharacter == $i) ifTrue:[
                                            self recordMatch:#( 112 113 ).
                                            self step.
                                            ((currentCharacter between:$- and:$.) 
                                                or:[
                                                    (currentCharacter between:$0 and:$9) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[ currentCharacter == $a or:[ (currentCharacter between:$c and:$z) ] ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan11 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan1
                                            ].
                                            (currentCharacter == $b) ifTrue:[
                                                self recordMatch:#( 112 113 ).
                                                self step.
                                                ((currentCharacter between:$- and:$.) 
                                                    or:[
                                                        (currentCharacter between:$0 and:$9) 
                                                            or:[
                                                                (currentCharacter between:$A and:$Z) 
                                                                    or:[
                                                                        currentCharacter == $_ 
                                                                            or:[
                                                                                (currentCharacter between:$a and:$k) 
                                                                                    or:[ (currentCharacter between:$m and:$z) ]
                                                                            ]
                                                                    ]
                                                            ]
                                                    ]) 
                                                        ifTrue:[ ^ self scan11 ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan1
                                                ].
                                                (currentCharacter == $l) ifTrue:[
                                                    self recordMatch:#( 112 113 ).
                                                    self step.
                                                    (currentCharacter isXMLDigit 
                                                        or:[
                                                            (currentCharacter between:$- and:$.) 
                                                                or:[
                                                                    (currentCharacter between:$A and:$Z) 
                                                                        or:[
                                                                            currentCharacter == $_ 
                                                                                or:[
                                                                                    (currentCharacter between:$a and:$h) 
                                                                                        or:[ (currentCharacter between:$j and:$z) ]
                                                                                ]
                                                                        ]
                                                                ]
                                                        ]) 
                                                            ifTrue:[ ^ self scan11 ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan1
                                                    ].
                                                    (currentCharacter == $i) ifTrue:[
                                                        self recordMatch:#( 112 113 ).
                                                        self step.
                                                        ((currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$0 and:$9) 
                                                                    or:[
                                                                        (currentCharacter between:$A and:$Z) 
                                                                            or:[
                                                                                currentCharacter == $_ 
                                                                                    or:[
                                                                                        (currentCharacter between:$a and:$m) 
                                                                                            or:[ (currentCharacter between:$o and:$z) ]
                                                                                    ]
                                                                            ]
                                                                    ]
                                                            ]) 
                                                                ifTrue:[ ^ self scan11 ].
                                                        (currentCharacter == $:) ifTrue:[
                                                            ^ self scan1
                                                        ].
                                                        (currentCharacter == $n) ifTrue:[
                                                            self recordMatch:#( 112 113 ).
                                                            self step.
                                                            ((currentCharacter between:$- and:$.) 
                                                                or:[
                                                                    (currentCharacter between:$0 and:$9) 
                                                                        or:[
                                                                            (currentCharacter between:$A and:$Z) 
                                                                                or:[
                                                                                    currentCharacter == $_ 
                                                                                        or:[
                                                                                            (currentCharacter between:$a and:$f) 
                                                                                                or:[ (currentCharacter between:$h and:$z) ]
                                                                                        ]
                                                                                ]
                                                                        ]
                                                                ]) 
                                                                    ifTrue:[ ^ self scan11 ].
                                                            (currentCharacter == $:) ifTrue:[
                                                                ^ self scan1
                                                            ].
                                                            (currentCharacter == $g) ifTrue:[
                                                                self recordMatch:#( 110 112 113 ).
                                                                self step.
                                                                (currentCharacter isLetterOrDigit 
                                                                    or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                                        ifTrue:[ ^ self scan11 ].
                                                                (currentCharacter == $:) ifTrue:[
                                                                    ^ self scan1
                                                                ].
                                                                ^ self reportLastMatch
                                                            ].
                                                            ^ self reportLastMatch
                                                        ].
                                                        ^ self reportLastMatch
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    ^ self reportLastMatch
                                ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan1
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $o) ifTrue:[
        ^ self scan16
    ].
    ^ self reportLastMatch
!

scan16
    self recordMatch:#( 112 113 ).
    self step.
    ((currentCharacter between:$- and:$.) 
        or:[
            (currentCharacter between:$0 and:$9) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$b) 
                                        or:[ (currentCharacter between:$d and:$z) ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan11 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan1
    ].
    (currentCharacter == $c) ifTrue:[
        ^ self scan17
    ].
    ^ self reportLastMatch
!

scan17
    self recordMatch:#( 112 113 ).
    self step.
    (currentCharacter isXMLDigit 
        or:[
            (currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$d) 
                                        or:[ (currentCharacter between:$f and:$z) ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan11 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan1
    ].
    (currentCharacter == $e) ifTrue:[
        ^ self scan18
    ].
    ^ self reportLastMatch
!

scan18
    self recordMatch:#( 112 113 ).
    self step.
    ((currentCharacter between:$- and:$.) 
        or:[
            (currentCharacter between:$0 and:$9) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$r) 
                                        or:[ (currentCharacter between:$t and:$z) ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan11 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan1
    ].
    (currentCharacter == $s) ifTrue:[
        self recordMatch:#( 112 113 ).
        self step.
        ((currentCharacter between:$- and:$.) 
            or:[
                (currentCharacter between:$0 and:$9) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$r) 
                                            or:[ (currentCharacter between:$t and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan11 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan1
        ].
        (currentCharacter == $s) ifTrue:[
            self recordMatch:#( 112 113 ).
            self step.
            (currentCharacter isXMLDigit 
                or:[
                    (currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$h) 
                                                or:[ (currentCharacter between:$j and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan11 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan1
            ].
            (currentCharacter == $i) ifTrue:[
                self recordMatch:#( 112 113 ).
                self step.
                ((currentCharacter between:$- and:$.) 
                    or:[
                        (currentCharacter between:$0 and:$9) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$m) 
                                                    or:[ (currentCharacter between:$o and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan11 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan1
                ].
                (currentCharacter == $n) ifTrue:[
                    self recordMatch:#( 112 113 ).
                    self step.
                    ((currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$0 and:$9) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$f) 
                                                        or:[ (currentCharacter between:$h and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan11 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan1
                    ].
                    (currentCharacter == $g) ifTrue:[
                        self recordMatch:#( 112 113 ).
                        self step.
                        (currentCharacter isLetterOrDigit 
                            or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                ifTrue:[ ^ self scan11 ].
                        (currentCharacter == $-) ifTrue:[
                            self recordMatch:#( 112 113 ).
                            self step.
                            (currentCharacter isXMLDigit 
                                or:[
                                    (currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[
                                                    currentCharacter == $_ 
                                                        or:[
                                                            (currentCharacter between:$a and:$h) 
                                                                or:[ (currentCharacter between:$j and:$z) ]
                                                        ]
                                                ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan11 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan1
                            ].
                            (currentCharacter == $i) ifTrue:[
                                self recordMatch:#( 112 113 ).
                                self step.
                                ((currentCharacter between:$- and:$.) 
                                    or:[
                                        (currentCharacter between:$0 and:$9) 
                                            or:[
                                                (currentCharacter between:$A and:$Z) 
                                                    or:[
                                                        currentCharacter == $_ 
                                                            or:[
                                                                (currentCharacter between:$a and:$m) 
                                                                    or:[ (currentCharacter between:$o and:$z) ]
                                                            ]
                                                    ]
                                            ]
                                    ]) 
                                        ifTrue:[ ^ self scan11 ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan1
                                ].
                                (currentCharacter == $n) ifTrue:[
                                    self recordMatch:#( 112 113 ).
                                    self step.
                                    ((currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$0 and:$9) 
                                                or:[
                                                    (currentCharacter between:$A and:$Z) 
                                                        or:[
                                                            currentCharacter == $_ 
                                                                or:[
                                                                    (currentCharacter between:$a and:$r) 
                                                                        or:[ (currentCharacter between:$t and:$z) ]
                                                                ]
                                                        ]
                                                ]
                                        ]) 
                                            ifTrue:[ ^ self scan11 ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan1
                                    ].
                                    (currentCharacter == $s) ifTrue:[
                                        self recordMatch:#( 112 113 ).
                                        self step.
                                        ((currentCharacter between:$- and:$.) 
                                            or:[
                                                (currentCharacter between:$0 and:$9) 
                                                    or:[
                                                        (currentCharacter between:$A and:$Z) 
                                                            or:[
                                                                currentCharacter == $_ 
                                                                    or:[
                                                                        (currentCharacter between:$a and:$s) 
                                                                            or:[ (currentCharacter between:$u and:$z) ]
                                                                    ]
                                                            ]
                                                    ]
                                            ]) 
                                                ifTrue:[ ^ self scan11 ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan1
                                        ].
                                        (currentCharacter == $t) ifTrue:[
                                            self recordMatch:#( 112 113 ).
                                            self step.
                                            ((currentCharacter between:$- and:$.) 
                                                or:[
                                                    (currentCharacter between:$0 and:$9) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[
                                                                            (currentCharacter between:$a and:$q) 
                                                                                or:[ (currentCharacter between:$s and:$z) ]
                                                                        ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan11 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan1
                                            ].
                                            (currentCharacter == $r) ifTrue:[
                                                self recordMatch:#( 112 113 ).
                                                self step.
                                                (currentCharacter isXMLDigit 
                                                    or:[
                                                        (currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$A and:$Z) 
                                                                    or:[
                                                                        currentCharacter == $_ 
                                                                            or:[
                                                                                (currentCharacter between:$a and:$t) 
                                                                                    or:[ (currentCharacter between:$v and:$z) ]
                                                                            ]
                                                                    ]
                                                            ]
                                                    ]) 
                                                        ifTrue:[ ^ self scan11 ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan1
                                                ].
                                                (currentCharacter == $u) ifTrue:[
                                                    self recordMatch:#( 112 113 ).
                                                    self step.
                                                    ((currentCharacter between:$- and:$.) 
                                                        or:[
                                                            (currentCharacter between:$0 and:$9) 
                                                                or:[
                                                                    (currentCharacter between:$A and:$Z) 
                                                                        or:[
                                                                            currentCharacter == $_ 
                                                                                or:[
                                                                                    (currentCharacter between:$a and:$b) 
                                                                                        or:[ (currentCharacter between:$d and:$z) ]
                                                                                ]
                                                                        ]
                                                                ]
                                                        ]) 
                                                            ifTrue:[ ^ self scan11 ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan1
                                                    ].
                                                    (currentCharacter == $c) ifTrue:[
                                                        self recordMatch:#( 112 113 ).
                                                        self step.
                                                        ((currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$0 and:$9) 
                                                                    or:[
                                                                        (currentCharacter between:$A and:$Z) 
                                                                            or:[
                                                                                currentCharacter == $_ 
                                                                                    or:[
                                                                                        (currentCharacter between:$a and:$s) 
                                                                                            or:[ (currentCharacter between:$u and:$z) ]
                                                                                    ]
                                                                            ]
                                                                    ]
                                                            ]) 
                                                                ifTrue:[ ^ self scan11 ].
                                                        (currentCharacter == $:) ifTrue:[
                                                            ^ self scan1
                                                        ].
                                                        (currentCharacter == $t) ifTrue:[
                                                            self recordMatch:#( 112 113 ).
                                                            self step.
                                                            (currentCharacter isXMLDigit 
                                                                or:[
                                                                    (currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$A and:$Z) 
                                                                                or:[
                                                                                    currentCharacter == $_ 
                                                                                        or:[
                                                                                            (currentCharacter between:$a and:$h) 
                                                                                                or:[ (currentCharacter between:$j and:$z) ]
                                                                                        ]
                                                                                ]
                                                                        ]
                                                                ]) 
                                                                    ifTrue:[ ^ self scan11 ].
                                                            (currentCharacter == $:) ifTrue:[
                                                                ^ self scan1
                                                            ].
                                                            (currentCharacter == $i) ifTrue:[
                                                                self recordMatch:#( 112 113 ).
                                                                self step.
                                                                (currentCharacter isXMLDigit 
                                                                    or:[
                                                                        (currentCharacter between:$- and:$.) 
                                                                            or:[
                                                                                (currentCharacter between:$A and:$Z) 
                                                                                    or:[
                                                                                        currentCharacter == $_ 
                                                                                            or:[
                                                                                                (currentCharacter between:$a and:$n) 
                                                                                                    or:[ (currentCharacter between:$p and:$z) ]
                                                                                            ]
                                                                                    ]
                                                                            ]
                                                                    ]) 
                                                                        ifTrue:[ ^ self scan11 ].
                                                                (currentCharacter == $:) ifTrue:[
                                                                    ^ self scan1
                                                                ].
                                                                (currentCharacter == $o) ifTrue:[
                                                                    self recordMatch:#( 112 113 ).
                                                                    self step.
                                                                    ((currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$0 and:$9) 
                                                                                or:[
                                                                                    (currentCharacter between:$A and:$Z) 
                                                                                        or:[
                                                                                            currentCharacter == $_ 
                                                                                                or:[
                                                                                                    (currentCharacter between:$a and:$m) 
                                                                                                        or:[ (currentCharacter between:$o and:$z) ]
                                                                                                ]
                                                                                        ]
                                                                                ]
                                                                        ]) 
                                                                            ifTrue:[ ^ self scan11 ].
                                                                    (currentCharacter == $:) ifTrue:[
                                                                        ^ self scan1
                                                                    ].
                                                                    (currentCharacter == $n) ifTrue:[
                                                                        self recordMatch:#( 62 112 113 ).
                                                                        self step.
                                                                        (currentCharacter isLetterOrDigit 
                                                                            or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                                                ifTrue:[ ^ self scan11 ].
                                                                        (currentCharacter == $:) ifTrue:[
                                                                            ^ self scan1
                                                                        ].
                                                                        ^ self reportLastMatch
                                                                    ].
                                                                    ^ self reportLastMatch
                                                                ].
                                                                ^ self reportLastMatch
                                                            ].
                                                            ^ self reportLastMatch
                                                        ].
                                                        ^ self reportLastMatch
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    ^ self reportLastMatch
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan1
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch
!

scan2
    self step.
    (currentCharacter isXMLDigit) ifTrue:[
        [
            self recordMatch:#( 116 ).
            self step.
            (currentCharacter isXMLDigit)
        ] whileTrue.
        ^ self reportLastMatch
    ].
    (currentCharacter == $+ or:[ currentCharacter == $- ]) ifTrue:[
        self step.
        (currentCharacter isXMLDigit) ifTrue:[
            [
                self recordMatch:#( 116 ).
                self step.
                (currentCharacter isXMLDigit)
            ] whileTrue.
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch
!

scan3
    self step.
    (currentCharacter == $t) ifTrue:[
        ^ self scan4
    ].
    ^ self reportLastMatch
!

scan4
    self step.
    (currentCharacter == $;) ifTrue:[
        ^ self recordAndReportMatch:#( 117 ).
    ].
    ^ self reportLastMatch
!

scan5
    self step.
    (currentCharacter == $t) ifTrue:[
        ^ self scan6
    ].
    ^ self reportLastMatch
!

scan6
    self step.
    (currentCharacter == $;) ifTrue:[
        ^ self scan7
    ].
    ^ self reportLastMatch
!

scan7
    [
        self step.
        (currentCharacter <= $!! 
            or:[ (currentCharacter between:$# and:$%) or:[ currentCharacter >= $' ] ])
    ] whileTrue.
    (currentCharacter == $") ifTrue:[
        self recordMatch:#( 118 ).
        self step.
        (currentCharacter == $") ifTrue:[
            ^ self scan7
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $&) ifTrue:[
        self step.
        (currentCharacter == $g or:[ currentCharacter == $l ]) ifTrue:[
            ^ self scan5
        ].
        (currentCharacter == $#) ifTrue:[
            self step.
            (currentCharacter isXMLDigit) ifTrue:[
                [
                    self step.
                    (currentCharacter isXMLDigit)
                ] whileTrue.
                (currentCharacter == $;) ifTrue:[
                    ^ self scan7
                ].
                ^ self reportLastMatch
            ].
            (currentCharacter == $x) ifTrue:[
                self step.
                (currentCharacter isXMLDigit 
                    or:[
                        (currentCharacter between:$A and:$F) 
                            or:[ (currentCharacter between:$a and:$f) ]
                    ]) 
                        ifTrue:[
                            [
                                self step.
                                (currentCharacter isXMLDigit 
                                    or:[
                                        (currentCharacter between:$A and:$F) 
                                            or:[ (currentCharacter between:$a and:$f) ]
                                    ])
                            ] whileTrue.
                            (currentCharacter == $;) ifTrue:[
                                ^ self scan7
                            ].
                            ^ self reportLastMatch
                        ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        (currentCharacter == $a) ifTrue:[
            self step.
            (currentCharacter == $m) ifTrue:[
                self step.
                (currentCharacter == $p) ifTrue:[
                    ^ self scan6
                ].
                ^ self reportLastMatch
            ].
            (currentCharacter == $p) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    self step.
                    (currentCharacter == $s) ifTrue:[
                        ^ self scan6
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        (currentCharacter == $q) ifTrue:[
            self step.
            (currentCharacter == $u) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    ^ self scan5
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch
!

scan8
    self step.
    (currentCharacter == $t) ifTrue:[
        ^ self scan9
    ].
    ^ self reportLastMatch
!

scan9
    self step.
    (currentCharacter == $;) ifTrue:[
        ^ self scan10
    ].
    ^ self reportLastMatch
!

scanForToken
    self step.
    ((currentCharacter between:$A and:$Z) 
        or:[
            currentCharacter == $_ 
                or:[
                    (currentCharacter between:$b and:$c) 
                        or:[
                            currentCharacter == $e 
                                or:[
                                    (currentCharacter between:$g and:$o) 
                                        or:[ (currentCharacter between:$q and:$z) ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan11 ].
    (currentCharacter isXMLDigit) ifTrue:[
        [
            self recordMatch:#( 114 ).
            self step.
            (currentCharacter isXMLDigit)
        ] whileTrue.
        (currentCharacter == $E or:[ currentCharacter == $e ]) ifTrue:[
            ^ self scan2
        ].
        (currentCharacter == $.) ifTrue:[
            ^ self scan14
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter isSeparator 
        or:[ currentCharacter == (Character value:16rB) ]) 
            ifTrue:[
                [
                    self recordMatch:#whitespace.
                    self step.
                    (currentCharacter isSeparator 
                        or:[ currentCharacter == (Character value:16rB) ])
                ] whileTrue.
                ^ self reportLastMatch
            ].
    (currentCharacter == $!!) ifTrue:[
        self step.
        (currentCharacter == $=) ifTrue:[
            ^ self recordAndReportMatch:#( 26 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $") ifTrue:[
        ^ self scan7
    ].
    (currentCharacter == $$) ifTrue:[
        ^ self recordAndReportMatch:#( 35 ).
    ].
    (currentCharacter == $&) ifTrue:[
        self step.
        (currentCharacter == $g or:[ currentCharacter == $l ]) ifTrue:[
            ^ self scan3
        ].
        (currentCharacter == $a) ifTrue:[
            self step.
            (currentCharacter == $m) ifTrue:[
                self step.
                (currentCharacter == $p) ifTrue:[
                    ^ self scan4
                ].
                ^ self reportLastMatch
            ].
            (currentCharacter == $p) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    self step.
                    (currentCharacter == $s) ifTrue:[
                        ^ self scan4
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        (currentCharacter == $q) ifTrue:[
            self step.
            (currentCharacter == $u) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    ^ self scan3
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $') ifTrue:[
        ^ self scan10
    ].
    (currentCharacter == $() ifTrue:[
        ^ self recordAndReportMatch:#( 30 ).
    ].
    (currentCharacter == $)) ifTrue:[
        ^ self recordAndReportMatch:#( 31 ).
    ].
    (currentCharacter == $*) ifTrue:[
        ^ self recordAndReportMatch:#( 4 ).
    ].
    (currentCharacter == $+) ifTrue:[
        ^ self recordAndReportMatch:#( 2 ).
    ].
    (currentCharacter == $,) ifTrue:[
        ^ self recordAndReportMatch:#( 32 ).
    ].
    (currentCharacter == $-) ifTrue:[
        ^ self recordAndReportMatch:#( 3 ).
    ].
    (currentCharacter == $.) ifTrue:[
        self recordMatch:#( 102 ).
        self step.
        (currentCharacter isXMLDigit) ifTrue:[
            ^ self scan14
        ].
        (currentCharacter == $.) ifTrue:[
            ^ self recordAndReportMatch:#( 104 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $/) ifTrue:[
        self recordMatch:#( 96 ).
        self step.
        (currentCharacter == $/) ifTrue:[
            ^ self recordAndReportMatch:#( 89 ).
        ].
        (currentCharacter == $>) ifTrue:[
            ^ self recordAndReportMatch:#( 65 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $:) ifTrue:[
        self recordMatch:#( 99 ).
        self step.
        (currentCharacter == $:) ifTrue:[
            ^ self recordAndReportMatch:#( 85 ).
        ].
        (currentCharacter == $=) ifTrue:[
            ^ self recordAndReportMatch:#( 53 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $;) ifTrue:[
        ^ self recordAndReportMatch:#( 36 ).
    ].
    (currentCharacter == $<) ifTrue:[
        self recordMatch:#( 19 ).
        self step.
        (currentCharacter == $/) ifTrue:[
            ^ self recordAndReportMatch:#( 66 ).
        ].
        (currentCharacter == $<) ifTrue:[
            ^ self recordAndReportMatch:#( 94 ).
        ].
        (currentCharacter == $=) ifTrue:[
            ^ self recordAndReportMatch:#( 20 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $=) ifTrue:[
        ^ self recordAndReportMatch:#( 34 ).
    ].
    (currentCharacter == $>) ifTrue:[
        self recordMatch:#( 15 ).
        self step.
        (currentCharacter == $=) ifTrue:[
            ^ self recordAndReportMatch:#( 16 ).
        ].
        (currentCharacter == $>) ifTrue:[
            ^ self recordAndReportMatch:#( 95 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $@) ifTrue:[
        ^ self recordAndReportMatch:#( 106 ).
    ].
    (currentCharacter == $[) ifTrue:[
        ^ self recordAndReportMatch:#( 100 ).
    ].
    (currentCharacter == $]) ifTrue:[
        ^ self recordAndReportMatch:#( 101 ).
    ].
    (currentCharacter == $a) ifTrue:[
        self recordMatch:#( 112 113 ).
        self step.
        ((currentCharacter between:$- and:$.) 
            or:[
                (currentCharacter between:$0 and:$9) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$m) 
                                            or:[ (currentCharacter between:$o and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan11 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan1
        ].
        (currentCharacter == $n) ifTrue:[
            self recordMatch:#( 112 113 ).
            self step.
            ((currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$0 and:$9) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$b) 
                                                or:[ (currentCharacter between:$d and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan11 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan1
            ].
            (currentCharacter == $c) ifTrue:[
                self recordMatch:#( 112 113 ).
                self step.
                (currentCharacter isXMLDigit 
                    or:[
                        (currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$d) 
                                                    or:[ (currentCharacter between:$f and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan11 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan1
                ].
                (currentCharacter == $e) ifTrue:[
                    self recordMatch:#( 112 113 ).
                    self step.
                    ((currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$0 and:$9) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$r) 
                                                        or:[ (currentCharacter between:$t and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan11 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan1
                    ].
                    (currentCharacter == $s) ifTrue:[
                        self recordMatch:#( 112 113 ).
                        self step.
                        ((currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$0 and:$9) 
                                    or:[
                                        (currentCharacter between:$A and:$Z) 
                                            or:[
                                                currentCharacter == $_ 
                                                    or:[
                                                        (currentCharacter between:$a and:$s) 
                                                            or:[ (currentCharacter between:$u and:$z) ]
                                                    ]
                                            ]
                                    ]
                            ]) 
                                ifTrue:[ ^ self scan11 ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan1
                        ].
                        (currentCharacter == $t) ifTrue:[
                            self recordMatch:#( 112 113 ).
                            self step.
                            (currentCharacter isXMLDigit 
                                or:[
                                    (currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[
                                                    currentCharacter == $_ 
                                                        or:[
                                                            (currentCharacter between:$a and:$n) 
                                                                or:[ (currentCharacter between:$p and:$z) ]
                                                        ]
                                                ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan11 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan1
                            ].
                            (currentCharacter == $o) ifTrue:[
                                self recordMatch:#( 112 113 ).
                                self step.
                                ((currentCharacter between:$- and:$.) 
                                    or:[
                                        (currentCharacter between:$0 and:$9) 
                                            or:[
                                                (currentCharacter between:$A and:$Z) 
                                                    or:[
                                                        currentCharacter == $_ 
                                                            or:[
                                                                (currentCharacter between:$a and:$q) 
                                                                    or:[ (currentCharacter between:$s and:$z) ]
                                                            ]
                                                    ]
                                            ]
                                    ]) 
                                        ifTrue:[ ^ self scan11 ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan1
                                ].
                                (currentCharacter == $r) ifTrue:[
                                    self recordMatch:#( 112 113 ).
                                    self step.
                                    (currentCharacter isLetterOrDigit 
                                        or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                            ifTrue:[ ^ self scan11 ].
                                    (currentCharacter == $-) ifTrue:[
                                        self recordMatch:#( 112 113 ).
                                        self step.
                                        (currentCharacter isXMLDigit 
                                            or:[
                                                (currentCharacter between:$- and:$.) 
                                                    or:[
                                                        (currentCharacter between:$A and:$Z) 
                                                            or:[
                                                                currentCharacter == $_ 
                                                                    or:[
                                                                        (currentCharacter between:$a and:$n) 
                                                                            or:[ (currentCharacter between:$p and:$z) ]
                                                                    ]
                                                            ]
                                                    ]
                                            ]) 
                                                ifTrue:[ ^ self scan11 ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan1
                                        ].
                                        (currentCharacter == $o) ifTrue:[
                                            self recordMatch:#( 112 113 ).
                                            self step.
                                            ((currentCharacter between:$- and:$.) 
                                                or:[
                                                    (currentCharacter between:$0 and:$9) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[
                                                                            (currentCharacter between:$a and:$q) 
                                                                                or:[ (currentCharacter between:$s and:$z) ]
                                                                        ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan11 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan1
                                            ].
                                            (currentCharacter == $r) ifTrue:[
                                                self recordMatch:#( 112 113 ).
                                                self step.
                                                (currentCharacter isLetterOrDigit 
                                                    or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                                        ifTrue:[ ^ self scan11 ].
                                                (currentCharacter == $-) ifTrue:[
                                                    self recordMatch:#( 112 113 ).
                                                    self step.
                                                    ((currentCharacter between:$- and:$.) 
                                                        or:[
                                                            (currentCharacter between:$0 and:$9) 
                                                                or:[
                                                                    (currentCharacter between:$A and:$Z) 
                                                                        or:[
                                                                            currentCharacter == $_ 
                                                                                or:[
                                                                                    (currentCharacter between:$a and:$r) 
                                                                                        or:[ (currentCharacter between:$t and:$z) ]
                                                                                ]
                                                                        ]
                                                                ]
                                                        ]) 
                                                            ifTrue:[ ^ self scan11 ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan1
                                                    ].
                                                    (currentCharacter == $s) ifTrue:[
                                                        self recordMatch:#( 112 113 ).
                                                        self step.
                                                        (currentCharacter isXMLDigit 
                                                            or:[
                                                                (currentCharacter between:$- and:$.) 
                                                                    or:[
                                                                        (currentCharacter between:$A and:$Z) 
                                                                            or:[
                                                                                currentCharacter == $_ 
                                                                                    or:[
                                                                                        (currentCharacter between:$a and:$d) 
                                                                                            or:[ (currentCharacter between:$f and:$z) ]
                                                                                    ]
                                                                            ]
                                                                    ]
                                                            ]) 
                                                                ifTrue:[ ^ self scan11 ].
                                                        (currentCharacter == $:) ifTrue:[
                                                            ^ self scan1
                                                        ].
                                                        (currentCharacter == $e) ifTrue:[
                                                            self recordMatch:#( 112 113 ).
                                                            self step.
                                                            ((currentCharacter between:$- and:$.) 
                                                                or:[
                                                                    (currentCharacter between:$0 and:$9) 
                                                                        or:[
                                                                            (currentCharacter between:$A and:$Z) 
                                                                                or:[
                                                                                    currentCharacter == $_ 
                                                                                        or:[
                                                                                            (currentCharacter between:$a and:$k) 
                                                                                                or:[ (currentCharacter between:$m and:$z) ]
                                                                                        ]
                                                                                ]
                                                                        ]
                                                                ]) 
                                                                    ifTrue:[ ^ self scan11 ].
                                                            (currentCharacter == $:) ifTrue:[
                                                                ^ self scan1
                                                            ].
                                                            (currentCharacter == $l) ifTrue:[
                                                                self recordMatch:#( 112 113 ).
                                                                self step.
                                                                ((currentCharacter between:$- and:$.) 
                                                                    or:[
                                                                        (currentCharacter between:$0 and:$9) 
                                                                            or:[
                                                                                (currentCharacter between:$A and:$Z) 
                                                                                    or:[
                                                                                        currentCharacter == $_ 
                                                                                            or:[
                                                                                                (currentCharacter between:$a and:$e) 
                                                                                                    or:[ (currentCharacter between:$g and:$z) ]
                                                                                            ]
                                                                                    ]
                                                                            ]
                                                                    ]) 
                                                                        ifTrue:[ ^ self scan11 ].
                                                                (currentCharacter == $:) ifTrue:[
                                                                    ^ self scan1
                                                                ].
                                                                (currentCharacter == $f) ifTrue:[
                                                                    self recordMatch:#( 109 112 113 ).
                                                                    self step.
                                                                    (currentCharacter isLetterOrDigit 
                                                                        or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                                            ifTrue:[ ^ self scan11 ].
                                                                    (currentCharacter == $:) ifTrue:[
                                                                        ^ self scan1
                                                                    ].
                                                                    ^ self reportLastMatch
                                                                ].
                                                                ^ self reportLastMatch
                                                            ].
                                                            ^ self reportLastMatch
                                                        ].
                                                        ^ self reportLastMatch
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan1
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan1
                                    ].
                                    ^ self reportLastMatch
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $d) ifTrue:[
        ^ self scan13
    ].
    (currentCharacter == $f) ifTrue:[
        self recordMatch:#( 112 113 ).
        self step.
        (currentCharacter isXMLDigit 
            or:[
                (currentCharacter between:$- and:$.) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$n) 
                                            or:[ (currentCharacter between:$p and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan11 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan1
        ].
        (currentCharacter == $o) ifTrue:[
            self recordMatch:#( 112 113 ).
            self step.
            ((currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$0 and:$9) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$k) 
                                                or:[ (currentCharacter between:$m and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan11 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan1
            ].
            (currentCharacter == $l) ifTrue:[
                self recordMatch:#( 112 113 ).
                self step.
                ((currentCharacter between:$- and:$.) 
                    or:[
                        (currentCharacter between:$0 and:$9) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$k) 
                                                    or:[ (currentCharacter between:$m and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan11 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan1
                ].
                (currentCharacter == $l) ifTrue:[
                    self recordMatch:#( 112 113 ).
                    self step.
                    (currentCharacter isXMLDigit 
                        or:[
                            (currentCharacter between:$- and:$.) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$n) 
                                                        or:[ (currentCharacter between:$p and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan11 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan1
                    ].
                    (currentCharacter == $o) ifTrue:[
                        self recordMatch:#( 112 113 ).
                        self step.
                        ((currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$0 and:$9) 
                                    or:[
                                        (currentCharacter between:$A and:$Z) 
                                            or:[
                                                currentCharacter == $_ 
                                                    or:[
                                                        (currentCharacter between:$a and:$v) 
                                                            or:[ (currentCharacter between:$x and:$z) ]
                                                    ]
                                            ]
                                    ]
                            ]) 
                                ifTrue:[ ^ self scan11 ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan1
                        ].
                        (currentCharacter == $w) ifTrue:[
                            self recordMatch:#( 112 113 ).
                            self step.
                            (currentCharacter isXMLDigit 
                                or:[
                                    (currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[
                                                    currentCharacter == $_ 
                                                        or:[
                                                            (currentCharacter between:$a and:$h) 
                                                                or:[ (currentCharacter between:$j and:$z) ]
                                                        ]
                                                ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan11 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan1
                            ].
                            (currentCharacter == $i) ifTrue:[
                                self recordMatch:#( 112 113 ).
                                self step.
                                ((currentCharacter between:$- and:$.) 
                                    or:[
                                        (currentCharacter between:$0 and:$9) 
                                            or:[
                                                (currentCharacter between:$A and:$Z) 
                                                    or:[
                                                        currentCharacter == $_ 
                                                            or:[
                                                                (currentCharacter between:$a and:$m) 
                                                                    or:[ (currentCharacter between:$o and:$z) ]
                                                            ]
                                                    ]
                                            ]
                                    ]) 
                                        ifTrue:[ ^ self scan11 ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan1
                                ].
                                (currentCharacter == $n) ifTrue:[
                                    self recordMatch:#( 112 113 ).
                                    self step.
                                    ((currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$0 and:$9) 
                                                or:[
                                                    (currentCharacter between:$A and:$Z) 
                                                        or:[
                                                            currentCharacter == $_ 
                                                                or:[
                                                                    (currentCharacter between:$a and:$f) 
                                                                        or:[ (currentCharacter between:$h and:$z) ]
                                                                ]
                                                        ]
                                                ]
                                        ]) 
                                            ifTrue:[ ^ self scan11 ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan1
                                    ].
                                    (currentCharacter == $g) ifTrue:[
                                        self recordMatch:#( 112 113 ).
                                        self step.
                                        (currentCharacter isLetterOrDigit 
                                            or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                                ifTrue:[ ^ self scan11 ].
                                        (currentCharacter == $-) ifTrue:[
                                            self recordMatch:#( 112 113 ).
                                            self step.
                                            ((currentCharacter between:$- and:$.) 
                                                or:[
                                                    (currentCharacter between:$0 and:$9) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[
                                                                            (currentCharacter between:$a and:$r) 
                                                                                or:[ (currentCharacter between:$t and:$z) ]
                                                                        ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan11 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan1
                                            ].
                                            (currentCharacter == $s) ifTrue:[
                                                self recordMatch:#( 112 113 ).
                                                self step.
                                                (currentCharacter isXMLDigit 
                                                    or:[
                                                        (currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$A and:$Z) 
                                                                    or:[
                                                                        currentCharacter == $_ 
                                                                            or:[
                                                                                (currentCharacter between:$a and:$h) 
                                                                                    or:[ (currentCharacter between:$j and:$z) ]
                                                                            ]
                                                                    ]
                                                            ]
                                                    ]) 
                                                        ifTrue:[ ^ self scan11 ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan1
                                                ].
                                                (currentCharacter == $i) ifTrue:[
                                                    self recordMatch:#( 112 113 ).
                                                    self step.
                                                    ((currentCharacter between:$- and:$.) 
                                                        or:[
                                                            (currentCharacter between:$0 and:$9) 
                                                                or:[
                                                                    (currentCharacter between:$A and:$Z) 
                                                                        or:[
                                                                            currentCharacter == $_ 
                                                                                or:[ currentCharacter == $a or:[ (currentCharacter between:$c and:$z) ] ]
                                                                        ]
                                                                ]
                                                        ]) 
                                                            ifTrue:[ ^ self scan11 ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan1
                                                    ].
                                                    (currentCharacter == $b) ifTrue:[
                                                        self recordMatch:#( 112 113 ).
                                                        self step.
                                                        ((currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$0 and:$9) 
                                                                    or:[
                                                                        (currentCharacter between:$A and:$Z) 
                                                                            or:[
                                                                                currentCharacter == $_ 
                                                                                    or:[
                                                                                        (currentCharacter between:$a and:$k) 
                                                                                            or:[ (currentCharacter between:$m and:$z) ]
                                                                                    ]
                                                                            ]
                                                                    ]
                                                            ]) 
                                                                ifTrue:[ ^ self scan11 ].
                                                        (currentCharacter == $:) ifTrue:[
                                                            ^ self scan1
                                                        ].
                                                        (currentCharacter == $l) ifTrue:[
                                                            self recordMatch:#( 112 113 ).
                                                            self step.
                                                            (currentCharacter isXMLDigit 
                                                                or:[
                                                                    (currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$A and:$Z) 
                                                                                or:[
                                                                                    currentCharacter == $_ 
                                                                                        or:[
                                                                                            (currentCharacter between:$a and:$h) 
                                                                                                or:[ (currentCharacter between:$j and:$z) ]
                                                                                        ]
                                                                                ]
                                                                        ]
                                                                ]) 
                                                                    ifTrue:[ ^ self scan11 ].
                                                            (currentCharacter == $:) ifTrue:[
                                                                ^ self scan1
                                                            ].
                                                            (currentCharacter == $i) ifTrue:[
                                                                self recordMatch:#( 112 113 ).
                                                                self step.
                                                                ((currentCharacter between:$- and:$.) 
                                                                    or:[
                                                                        (currentCharacter between:$0 and:$9) 
                                                                            or:[
                                                                                (currentCharacter between:$A and:$Z) 
                                                                                    or:[
                                                                                        currentCharacter == $_ 
                                                                                            or:[
                                                                                                (currentCharacter between:$a and:$m) 
                                                                                                    or:[ (currentCharacter between:$o and:$z) ]
                                                                                            ]
                                                                                    ]
                                                                            ]
                                                                    ]) 
                                                                        ifTrue:[ ^ self scan11 ].
                                                                (currentCharacter == $:) ifTrue:[
                                                                    ^ self scan1
                                                                ].
                                                                (currentCharacter == $n) ifTrue:[
                                                                    self recordMatch:#( 112 113 ).
                                                                    self step.
                                                                    ((currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$0 and:$9) 
                                                                                or:[
                                                                                    (currentCharacter between:$A and:$Z) 
                                                                                        or:[
                                                                                            currentCharacter == $_ 
                                                                                                or:[
                                                                                                    (currentCharacter between:$a and:$f) 
                                                                                                        or:[ (currentCharacter between:$h and:$z) ]
                                                                                                ]
                                                                                        ]
                                                                                ]
                                                                        ]) 
                                                                            ifTrue:[ ^ self scan11 ].
                                                                    (currentCharacter == $:) ifTrue:[
                                                                        ^ self scan1
                                                                    ].
                                                                    (currentCharacter == $g) ifTrue:[
                                                                        self recordMatch:#( 97 112 113 ).
                                                                        self step.
                                                                        (currentCharacter isLetterOrDigit 
                                                                            or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                                                ifTrue:[ ^ self scan11 ].
                                                                        (currentCharacter == $:) ifTrue:[
                                                                            ^ self scan1
                                                                        ].
                                                                        ^ self reportLastMatch
                                                                    ].
                                                                    ^ self reportLastMatch
                                                                ].
                                                                ^ self reportLastMatch
                                                            ].
                                                            ^ self reportLastMatch
                                                        ].
                                                        ^ self reportLastMatch
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan1
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    ^ self reportLastMatch
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $p) ifTrue:[
        ^ self scan12
    ].
    (currentCharacter == ${) ifTrue:[
        ^ self recordAndReportMatch:#( 77 ).
    ].
    (currentCharacter == $|) ifTrue:[
        ^ self recordAndReportMatch:#( 23 ).
    ].
    (currentCharacter == $}) ifTrue:[
        ^ self recordAndReportMatch:#( 70 ).
    ].
    ^ self reportLastMatch
! !

!XQueryScanner methodsFor:'generated-tokens'!

emptySymbolTokenId
	^235
!

errorTokenId
	^236
! !

!XQueryScanner class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/stx/goodies/xmlsuite/xquery/XQuery__XQueryScanner.st,v 1.11 2008-01-02 14:07:19 wrobll1 Exp $'
! !
