"{ Package: 'stx:goodies/xmlsuite/xquery' }"

"{ NameSpace: XQuery }"

Perseus::Parser subclass:#XQueryParser
	instanceVariableNames:''
	classVariableNames:'Verbose'
	poolDictionaries:''
	category:'XQuery-Executor'
!


!XQueryParser class methodsFor:'accessing'!

isVerbose

    ^Verbose == true

    "Created: / 12-04-2007 / 11:15:13 / janfrog"
!

parseQuery: aString
        ^self parse: aString startingAt: self startingStateForQueryBody

    "Created: / 17-03-2006 / 15:00:57 / ked"
    "Modified: / 02-06-2006 / 12:26:34 / ked"
!

verbose: aBoolean

    "
        self verbose: true  

        self verbose: false
    "

    Verbose := aBoolean

    "Created: / 12-04-2007 / 11:15:13 / janfrog"
    "Modified: / 17-11-2007 / 14:37:07 / janfrog"
! !

!XQueryParser class methodsFor:'generated-accessing'!

scannerClass
	^XQuery::XQueryScanner
! !

!XQueryParser class methodsFor:'generated-comments'!

parserDefinitionComment

	"%start MainModule;

MainModule :
    Prolog QueryBody
	{ AstMainModule new
	    prolog: '1' ;
	    queryBody: '2' }
    ;

Prolog:
    PrologDeclarationClass1List PrologDeclarationClass2List
	{ AstProlog new
		declarations: ('1' addAll: '2'; yourself) }
    ;

PrologDeclarationClass1List:
    PrologDeclarationClass1List PrologDeclarationClass1 "";""
	{ '1' add: '2'; yourself }
    |
	{ OrderedCollection new: 5 }
    ;

PrologDeclarationClass1:
      DefaultNamespaceDecl
	{ '1' }
    | NamespaceDecl
	{ '1' }
    | FunctionDecl
	{ '1' }
    ;

DefaultNamespaceDecl:
      ""declare"" ""default"" ""element"" ""namespace"" URILiteral
	{ AstDefaultNamespaceDecl new
	    uri: '5';
	    type: #element }
    | ""declare"" ""default"" ""function"" ""namespace"" URILiteral
	{ AstDefaultNamespaceDecl new
	    uri: '5';
	    type: #function }
    ;

NamespaceDecl:
    ""declare"" ""namespace"" NCName ""="" URILiteral
	{ AstNamespaceDecl new
	    prefix: '3' ;
	    nsuri: '5'  }
    ;



URILiteral:
    StringLiteral
	{ '1' }
    ;

PrologDeclarationClass2List:
    PrologDeclarationClass2List PrologDeclarationClass2 "";""
	{ '1' add: '2'; yourself }
    |
	{ OrderedCollection new: 5 }
    ;

PrologDeclarationClass2:
    ;

FunctionDecl:
      ""declare"" ""updating""? ""function"" QName ""("" ParamList "")"" EnclosedExpr
	{ AstFunctionDecl new
	    name: '4';
	    paramList: '6';
	    body: '8'
	}
    ;

ParamList:
    OneOrMoreParamList
	{ '1' }
    | EmptyParamList
	{ '2' }
    ;

EmptyParamList:
	{ #() }
    ;

OneOrMoreParamList:
    ParamList "","" Param
	{ '1' add: '3' ; yourself }
    | Param
	{ OrderedCollection with:'1' }
    ;

Param:
    ""$"" QName
	{ AstParam new
	    name: '2'  }
    ;






QueryBody :
  Expr {
    self informAboutRuleReduction:'QueryBody1'.
    '1'.
  };

Expr :
  ExprSingle {
    self informAboutRuleReduction:'Expr1'.
    '1'.
  } |
  ExprSingle "","" Expr {
    self informAboutRuleReduction:'Expr2'.
    AstExpr new exprSingle: '1'; expr: '3'.
  } ;

ExprSingle :
  FLWORExpr {
    self informAboutRuleReduction:'ExprSingle1'.
    '1'.
  } |
  QuantifiedExpr {
    self informAboutRuleReduction:'ExprSingle2'.
    '1'.
  } |
  IfExpr {
    self informAboutRuleReduction:'ExprSingle3'.
    '1'.
  } |
  OrExpr {
    self informAboutRuleReduction:'ExprSingle4'.
    '1'.
  } |
  DeleteExpr {
    self informAboutRuleReduction:'ExprSingle5'.
    '1'.
  } |
  RenameExpr {
    self informAboutRuleReduction:'ExprSingle6'.
    '1'.
  } |
  ReplaceExpr {
    self informAboutRuleReduction:'ExprSingle7'.
    '1'.
  } |
  InsertExpr {
    self informAboutRuleReduction:'ExprSingle8'.
    '1'.
  } |  
  TransformExpr {
    self informAboutRuleReduction:'ExprSingle9'.
    '1'. 
  } ;

FLWORExpr :
  FLWORExpr_ForLet ""return"" ExprSingle {
    self informAboutRuleReduction:'FLWORExpr1'.
    AstFLWORExpr new flworExpr_ForLet: '1'; exprSingle: '3'.
  } |
  FLWORExpr_ForLet WhereClause ""return"" ExprSingle {
    self informAboutRuleReduction:'FLWORExpr2'.
    AstFLWORExpr new flworExpr_ForLet: '1'; whereClause: '2'; exprSingle: '4'.
  } |
  FLWORExpr_ForLet OrderByClause ""return"" ExprSingle {
    self informAboutRuleReduction:'FLWORExpr3'.
    AstFLWORExpr new flworExpr_ForLet: '1'; orderByClause: '2'; exprSingle: '4'.
  } |
  FLWORExpr_ForLet WhereClause OrderByClause ""return"" ExprSingle {
    self informAboutRuleReduction:'FLWORExpr4'.
    AstFLWORExpr new flworExpr_ForLet: '1'; whereClause: '2'; orderByClause: '3'; exprSingle: '5'.
  } ;

FLWORExpr_ForLet :
  ForClause {
    self informAboutRuleReduction:'FLWORExpr_ForLet1'.
    '1'.
  } |
  LetClause {
    self informAboutRuleReduction:'FLWORExpr_ForLet2'.
    '1'.
  } |
  ForClause FLWORExpr_ForLet {
    self informAboutRuleReduction:'FLWORExpr_ForLet3'.
    AstFLWORExpr_ForLet new forClause: '1'; flworExpr_ForLet: '2'.
  } |
  LetClause FLWORExpr_ForLet {
    self informAboutRuleReduction:'FLWORExpr_ForLet4'.
    AstFLWORExpr_ForLet new letClause: '1'; flworExpr_ForLet: '2'.
  } ;

ForClause :
  ""for"" ForClause_Impl {
    self informAboutRuleReduction:'ForClause1'.
    '2'.
  } ;

ForClause_Impl :
  ""$"" VarName ""in"" ExprSingle {
    self informAboutRuleReduction:'ForClause_Impl1'.
    AstForClause new varName: '2'; exprSingle: '4'.
  } |
  ""$"" VarName ""in"" ExprSingle "","" ForClause_Impl {
    self informAboutRuleReduction:'ForClause_Impl2'.
    AstForClause new varName: '2'; exprSingle: '4'; forClause: '6'.
  } |
  ""$"" VarName PositionalVar ""in"" ExprSingle {
    self informAboutRuleReduction:'ForClause_Impl3'.
    AstForClause new varName: '2'; positionalVar: '3'; exprSingle: '5'.
  } |
  ""$"" VarName PositionalVar ""in"" ExprSingle "","" ForClause_Impl {
    self informAboutRuleReduction:'ForClause_Impl4'.
    AstForClause new varName: '2'; positionalVar: '3'; exprSingle: '5'; forClause: '7'.
  } ;

PositionalVar:
  ""at"" ""$"" VarName {
    self informAboutRuleReduction:'PositionalVar1'.
    '3'.
  } ;

LetClause :
  ""let"" LetClause_Impl {
    self informAboutRuleReduction:'LetClause1'.
    '2'.
  } ;

LetClause_Impl :
  ""$"" VarName "":="" ExprSingle {
    self informAboutRuleReduction:'LetClause_Impl1'.
    AstLetClause new varName: '2'; exprSingle: '4'.
  } |
  ""$"" VarName "":="" ExprSingle "","" LetClause_Impl {
    self informAboutRuleReduction:'LetClause_Impl2'.
    AstLetClause new varName: '2'; exprSingle: '4'; letClause: '6'.
  } ;

WhereClause :
  ""where"" ExprSingle {
    self informAboutRuleReduction:'WhereClause1'.
    AstWhereClause new exprSingle: '2'.
  } ;

OrderByClause :
  ""order"" ""by"" OrderSpecList {
    self informAboutRuleReduction:'OrderByClause1'.
    AstOrderByClause new isStable: false; orderSpecList: '3'.
  } |
  ""stable"" ""order"" ""by"" OrderSpecList {
    self informAboutRuleReduction:'OrderByClause2'.
    AstOrderByClause new isStable: true; orderSpecList: '4'.
  } ;

OrderSpecList :
  OrderSpec {
    self informAboutRuleReduction:'OrderSpecList1'.
   '1'.
  } |
  OrderSpec "","" OrderSpecList {
    self informAboutRuleReduction:'OrderSpecList2'.
    AstOrderSpecList new orderSpec: '1'; orderSpecList: '3'.
  } ;

OrderSpec :
  ExprSingle {
    self informAboutRuleReduction:'OrderSpec1'.
    AstOrderSpec new exprSingle: '1'.
  } |
  ExprSingle OrderModifier {
    self informAboutRuleReduction:'OrderSpec2'.
    AstOrderSpec new exprSingle: '1'; orderModifier: '2'.
  } ;

OrderModifier :
  OrderModifier_AscDesc {
    self informAboutRuleReduction:'OrderModifier1'.
    AstOrderModifier new ascDesc: '1'.
  } |
  OrderModifier_GreatestLeast {
    self informAboutRuleReduction:'OrderModifier2'.
    AstOrderModifier new greatestLeast: '1'.
  } |
  OrderModifier_AscDesc OrderModifier_GreatestLeast {
    self informAboutRuleReduction:'OrderModifier3'.
    AstOrderModifier new ascDesc: '1'; greatestLeast: '2'.
  } ;

OrderModifier_AscDesc:
  ""ascending"" {
    self informAboutRuleReduction:'OrderModifier_AscDesc1'.
    ^#asc.
  } |
  ""descending"" {
    self informAboutRuleReduction:'OrderModifier_AscDesc2'.
    ^#desc.
  } ;

OrderModifier_GreatestLeast:
  ""empty"" ""greatest"" {
    self informAboutRuleReduction:'OrderModifier_GreatestLeast1'.
    ^#greatest.
  } |
  ""empty"" ""least"" {
    self informAboutRuleReduction:'OrderModifier_GreatestLeast2'.
    ^#least.
  } ;

QuantifiedExpr :
  ""some"" QuantifiedExpr_Impl ""satisfies"" ExprSingle {
    self informAboutRuleReduction:'QuantifiedExpr1'.
    AstQuantifiedExpr new someEvery: #some; quantifiedExpr_Impl: '2'; exprSingle: '4'.
  } |
  ""every"" QuantifiedExpr_Impl ""satisfies"" ExprSingle {
    self informAboutRuleReduction:'QuantifiedExpr2'.
    AstQuantifiedExpr new someEvery: #every; quantifiedExpr_Impl: '2'; exprSingle: '4'.
  } ;

QuantifiedExpr_Impl :
  ""$"" VarName ""in"" ExprSingle {
    self informAboutRuleReduction:'QuantifiedExpr_Impl1'.
    AstQuantifiedExpr_Impl new varName: '2'; exprSingle: '4'.
  } |
  ""$"" VarName ""in"" ExprSingle "","" QuantifiedExpr_Impl {
    self informAboutRuleReduction:'QuantifiedExpr_Impl2'.
    AstQuantifiedExpr_Impl new varName: '2'; exprSingle: '4'; quantifiedExpr_Impl: '6'.
  } ;

IfExpr :
  ""if"" ""("" Expr "")"" ""then"" ExprSingle ""else"" ExprSingle {
    self informAboutRuleReduction:'IfExpr1'.
    AstIfExpr new expr: '3'; trueExprSingle: '6'; falseExprSingle: '8'.
  } ;

OrExpr :
  AndExpr {
    self informAboutRuleReduction:'OrExpr1'.
    '1'.
  } |
  AndExpr ""or"" OrExpr {
    self informAboutRuleReduction:'OrExpr2'.
    AstOrExpr new andExpr: '1'; orExpr: '3'.
  } ;

AndExpr :
  ComparisonExpr {
    self informAboutRuleReduction:'AndExpr1'.
    '1'.
  } |
  ComparisonExpr ""and"" AndExpr {
    self informAboutRuleReduction:'AndExpr2'.
    AstAndExpr new comparisonExpr: '1'; andExpr: '3'.
  } ;

ComparisonExpr :
  RangeExpr {
    self informAboutRuleReduction:'ComparisonExpr1'.
    '1'.
  } |
  RangeExpr ValueComp RangeExpr {
    self informAboutRuleReduction:'ComparisonExpr2'.
    AstComparisonExpr new rangeExprLeft: '1'; valueComp: '2'; rangeExprRight: '3'.
  } |
  RangeExpr GeneralComp RangeExpr {
    self informAboutRuleReduction:'ComparisonExpr3'.
    AstComparisonExpr new rangeExprLeft: '1'; generalComp: '2'; rangeExprRight: '3'.
  } |
  RangeExpr NodeComp RangeExpr {
    self informAboutRuleReduction:'ComparisonExpr4'.
    AstComparisonExpr new rangeExprLeft: '1'; nodeComp: '2'; rangeExprRight: '3'.
  } ;

RangeExpr :
  AdditiveExpr {
    self informAboutRuleReduction:'RangeExpr1'.
    '1'.
  } |
  AdditiveExpr ""to"" AdditiveExpr {
    self informAboutRuleReduction:'RangeExpr2'.
    AstRangeExpr new additiveExprFrom: '1'; additiveExprTo: '3'.
  } ;

AdditiveExpr :
  MultiplicativeExpr {
    self informAboutRuleReduction:'AdditiveExpr1'.
    '1'.
  } |
  MultiplicativeExpr ""+"" AdditiveExpr {
    self informAboutRuleReduction:'AdditiveExpr2'.
    AstAdditiveExpr new multiplicativeExpr: '1'; operand: #plus; additiveExpr: '3'.
  } |
  MultiplicativeExpr ""-"" AdditiveExpr {
    self informAboutRuleReduction:'AdditiveExpr3'.
    AstAdditiveExpr new multiplicativeExpr: '1'; operand: #minus; additiveExpr: '3'.
  } ;

MultiplicativeExpr :
  UnionExpr {
    self informAboutRuleReduction:'MultiplicativeExpr1'.
    '1'.
  } |
  UnionExpr ""*"" MultiplicativeExpr {
    self informAboutRuleReduction:'MultiplicativeExpr2'.
    AstMultiplicativeExpr new unionExpr: '1'; operand: #krat; multiplicativeExpr: '3'.
  } |
  UnionExpr ""div"" MultiplicativeExpr {
    self informAboutRuleReduction:'MultiplicativeExpr3'.
    AstMultiplicativeExpr new unionExpr: '1'; operand: #div; multiplicativeExpr: '3'.
  } |
  UnionExpr ""idiv"" MultiplicativeExpr {
    self informAboutRuleReduction:'MultiplicativeExpr4'.
    AstMultiplicativeExpr new unionExpr: '1'; operand: #idiv; multiplicativeExpr: '3'.
  } |
  UnionExpr ""mod"" MultiplicativeExpr {
    self informAboutRuleReduction:'MultiplicativeExpr5'.
    AstMultiplicativeExpr new unionExpr: '1'; operand: #mod; multiplicativeExpr: '3'.
  } ;

UnionExpr :
  IntersectExceptExpr {
    self informAboutRuleReduction:'UnionExpr1'.
    '1'.
  } |
  IntersectExceptExpr ""union"" UnionExpr {
    self informAboutRuleReduction:'UnionExpr2'.
    AstUnionExpr new intersectExceptExpr: '1'; unionExpr: '3'.
  } |
  IntersectExceptExpr ""|"" UnionExpr {
    self informAboutRuleReduction:'UnionExpr3'.
    AstUnionExpr new intersectExceptExpr: '1'; unionExpr: '3'.
  } ;

IntersectExceptExpr :
  UnaryExpr {
    self informAboutRuleReduction:'IntersectExceptExpr1'.
    '1'.
  } |
  UnaryExpr ""intersect"" IntersectExceptExpr {
    self informAboutRuleReduction:'IntersectExceptExpr2'.
    AstIntersectExceptExpr new unaryExpr: '1'; operand: #intersect; intersectExceptExpr: '3'.
  } |
  UnaryExpr ""except"" IntersectExceptExpr {
    self informAboutRuleReduction:'IntersectExceptExpr3'.
    AstIntersectExceptExpr new unaryExpr: '1'; operand: #except; intersectExceptExpr: '3'.
  } ;

UnaryExpr :
  ""-"" UnaryExpr {
    self informAboutRuleReduction:'UnaryExpr1'.
    AstUnaryExpr new operand: #minus; unaryExpr: '2'.
  } |
  ""+"" UnaryExpr {
    self informAboutRuleReduction:'UnaryExpr2'.
    AstUnaryExpr new operand: #plus; unaryExpr: '2'.
  } |
  ValueExpr {
   self informAboutRuleReduction:'UnaryExpr3'.
   '1'.
  } ;

ValueExpr :
  PathExpr {
    self informAboutRuleReduction:'ValueExpr'.
    '1'.
  } ;

GeneralComp :
  ""="" {
    self informAboutRuleReduction:'GeneralComp1'.
    ^#eqGeneral.
  } |
  ""!!="" {
    self informAboutRuleReduction:'GeneralComp2'.
    ^#neGeneral.
  } |
  ""<"" {
    self informAboutRuleReduction:'GeneralComp3'.
    ^#ltGeneral.
  } |
  ""<="" {
    self informAboutRuleReduction:'GeneralComp4'.
    ^#leGeneral.
  } |
  "">"" {
    self informAboutRuleReduction:'GeneralComp5'.
    ^#gtGeneral.
  } |
  "">="" {
    self informAboutRuleReduction:'GeneralComp6'.
    ^#geGeneral.
  } ;

ValueComp :
  ""eq"" {
    self informAboutRuleReduction:'ValueComp1'.
    ^#eqValue.
  } |
  ""ne"" {
    self informAboutRuleReduction:'ValueComp2'.
    ^#neValue.
  } |
  ""lt"" {
    self informAboutRuleReduction:'ValueComp3'.
    ^#ltValue.
  } |
  ""le"" {
    self informAboutRuleReduction:'ValueComp4'.
    ^#leValue.
  } |
  ""gt"" {
    self informAboutRuleReduction:'ValueComp5'.
    ^#gtValue.
  } |
  ""ge""{
    self informAboutRuleReduction:'ValueComp6'.
    ^#geValue.
  } ;

NodeComp :
  ""is"" {
    self informAboutRuleReduction:'NodeComp1'.
    ^#is.
  } |
  ""<<"" {
    self informAboutRuleReduction:'NodeComp2'.
    ^#isLess.
  } |
  "">>"" {
    self informAboutRuleReduction:'NodeComp3'.
    ^#isMore.
  } ;

PathExpr :
	  ""/"" RelativePathExpr 
	  	{
		    self informAboutRuleReduction:'PathExpr2'.
		    '2' absolute: true; yourself 
 		 } 
	| ""//"" RelativePathExpr 
		{
		    self informAboutRuleReduction:'PathExpr3'.
			'2'
				addFirst:
			    	(XMLv2::XPathLocationStep new
			        	axis: XMLv2::XPathAxisDescendantOrSelf new;
						nodeTest: XMLv2::XPathAnyKindTest new);
				yourself		    
		}	
	| RelativePathExpr 
		{
		    self informAboutRuleReduction:'PathExpr4'.
		    '1'.
		}
	;

RelativePathExpr :
	  StepExpr 
	  	{
		    self informAboutRuleReduction:'RelativePathExpr1'.
    		XMLv2::XPathExpression with: '1'.
		}    	
	| RelativePathExpr ""/"" StepExpr  
		{
		    self informAboutRuleReduction:'RelativePathExpr2'.
		    '1' add: '3'; yourself
		}		  
	| RelativePathExpr ""//"" StepExpr 
		{
		    self informAboutRuleReduction:'RelativePathExpr3'.
		    '1'
		    	add:
		    		(XMLv2::XPathLocationStep new
		    			axis: XMLv2::XPathAxisDescendantOrSelf new;
		    			nodeTest: XMLv2::XPathAnyKindTest new);
				add: '3';
				yourself
		}
	;

StepExpr :
	  AxisStep 
	  	{
		    self informAboutRuleReduction:'StepExpr1'.
		    '1'.
		}		   
	| FilterExpr 
		{
		    self informAboutRuleReduction:'StepExpr2'.
		    '1'.
		}		   
	;

AxisStep :
  ForwardStep Predicate* {
    self informAboutRuleReduction:'AxisStep2'.
    '1' predicates: '2'; yourself
  } |
  ReverseStep Predicate* {
    self informAboutRuleReduction:'AxisStep4'.
    '1' predicates: '2'; yourself
  } ;

ForwardStep :
	  ForwardAxis NodeTest
		{
    		self informAboutRuleReduction:'ForwardStep1'.
			XMLv2::XPathLocationStep new
				axis: '1';
				nodeTest: '2';
				yourself
		} 
	| AbbrevForwardStep 
		{
			self informAboutRuleReduction:'ForwardStep2'.
			'1'
  		} 
  	;

ForwardAxis :
	  ""child"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ForwardAxis1'.
		    XMLv2::XPathAxisChild new
		}	    
	|  ""descendant"" ""::"" 
		{
		    self informAboutRuleReduction:'ForwardAxis2'.
			XMLv2::XPathAxisDescendant new
		}
	| ""attribute"" ""::""
	  	{
  			self informAboutRuleReduction:'ForwardAxis3'.
		    XMLv2::XPathAxisAttribute new
		}	    	
	| ""self"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ForwardAxis4'.
		    XMLv2::XPathAxisSelf new
		}	    	
	| ""descendant-or-self"" ""::""	
	  	{
  			self informAboutRuleReduction:'ForwardAxis5'.
		    XMLv2::XPathAxisSedcendantOrSelf new
		}	    	
	| ""following-sibling"" ""::"" 
		{
  			self informAboutRuleReduction:'ForwardAxis6'.
		    XMLv2::XPathAxisFollowingSibling new
		}	    	
	| ""following"" ""::"" 
		{
  			self informAboutRuleReduction:'ForwardAxis7'.
		    XMLv2::XPathAxisFollowing new
		}	    	
	;

AbbrevForwardStep :
	  ""@"" NodeTest 
	  	{
			self informAboutRuleReduction:'AbbrevForwardStep1'.
			XMLv2::XPathLocationStep new
				axis: XMLv2::XPathAxisAttribute new;
				nodeTest: '2';
				yourself
		}			
	| NodeTest
	  	{
			self informAboutRuleReduction:'AbbrevForwardStep2'.
			XMLv2::XPathLocationStep new
				axis: XMLv2::XPathAxisChild new;
				nodeTest: '1';
				yourself
		}			
	;
	
ReverseStep :
	  ReverseAxis NodeTest
		{
    		self informAboutRuleReduction:'ReverseStep1'.
			XMLv2::XPathLocationStep new
				axis: '1';
				nodeTest: '2';
				yourself
		} 
	| AbbrevReverseStep 
		{
			self informAboutRuleReduction:'ReverseStep2'.
			'1'
  		} 
  	;

ReverseAxis :
	  ""parent"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ReverseAxis1'.
		    XMLv2::XPathAxisParent new
		}	    
	| ""ancestor"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ReverseAxis2'.
		    XMLv2::XPathAxisAncestor new
		}
	| ""ancestor-or-self"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ReverseAxis3'.
		    XMLv2::XPathAxisAncestorOrSelf new
		}
	| ""preceding-sibling"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ReverseAxis4'.
		    XMLv2::XPathAxisPrecedingSibling new
		}
	| ""preceding"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ReverseAxis5'.
		    XMLv2::XPathAxisPreceding new
		}
	;
		
AbbrevReverseStep :
	"".."" 
		{
			XMLv2::XPathLocationStep new
				axis: XMLv2::XPathAxisParent new;
				nodeTest: XMLv2::XPathAnyKindTest new;
				yourself
		}
	;

NodeTest :
	  NameTest
		{
	  	 	self informAboutRuleReduction:'NodeTest1'.
		    '1'.
		}
	| KindTest 
		{
		    self informAboutRuleReduction:'NodeTest2'.
		    '1'.
		} 
	;

NameTest :
	QName 
		{
			self informAboutRuleReduction:'NameTest1'.
			XMLv2::XPathNameTest new qName: '1' content
		}			
	| ""*"" 
		{
			self informAboutRuleReduction:'NameTest1'.
			XMLv2::XPathNameTest new prefix:'*'; localName:'*'
		}			
	| ""*"" "":"" NCName 
		{
			self informAboutRuleReduction:'NameTest1'.
			XMLv2::XPathNameTest new prefix:'*'; localName:'3' content
		}			
	;

FilterExpr :
	PrimaryExpr Predicate* 
		{
		    self informAboutRuleReduction:'FilterExpr2'.
		    AstFilterExpr new primaryExpr: '1'; predicateList: '2'.
		}
	;


Predicate :
  ""["" Expr ""]"" {
    self informAboutRuleReduction:'Predicate1'.
    XMLv2::XPathPredicate new expr: '2'.
  } |
  ""["" ""]"" {
    self informAboutRuleReduction:'Predicate2'.
    XMLv2::XPathPredicate new
  } ;

PrimaryExpr :
  Literal {
    self informAboutRuleReduction:'PrimaryExpr1'.
    '1'.
  } |
  VarRef {
    self informAboutRuleReduction:'PrimaryExpr2'.
    '1'.
  } |
  ParenthesizedExpr {
    self informAboutRuleReduction:'PrimaryExpr3'.
    '1'.
  } |
  ContextItemExpr {
    self informAboutRuleReduction:'PrimaryExpr4'.
    '1'.
  } |
  FunctionCall {
    self informAboutRuleReduction:'PrimaryExpr5'.
    '1'.
  } |
  Constructor {
    self informAboutRuleReduction:'PrimaryExpr6'.
    '1'.
  } |
  OrderedExpr {
    self informAboutRuleReduction:'PrimaryExpr7'.
    '1'.
  } |
  UnorderedExpr {
    self informAboutRuleReduction:'PrimaryExpr8'.
    '1'.
  } ;

Literal :
  NumericLiteral {
    self informAboutRuleReduction:'Literal1'.
    '1'.
  } |
  StringLiteral {
    self informAboutRuleReduction:'Literal2'.
    '1'.
  } ;

NumericLiteral :
  IntegerLiteral {
    self informAboutRuleReduction:'NumericLiteral1'.
    '1'.
  } |
  DecimalLiteral {
    self informAboutRuleReduction:'NumericLiteral2'.
    '1'.
  } |
  DoubleLiteral {
    self informAboutRuleReduction:'NumericLiteral3'.
    '1'.
  } ;

VarRef :
  ""$"" VarName {
    self informAboutRuleReduction:'VarRef1'.
    AstVarRef new varName: '2'.
  } ;

VarName :
  QName {
    self informAboutRuleReduction:'VarName1'.
    '1'.
  };

ParenthesizedExpr :
  ""("" "")"" {
    self informAboutRuleReduction:'ParenthesizedExpr1'.
    AstParenthesizedExpr new.
  } |
  ""("" Expr "")"" {
    self informAboutRuleReduction:'ParenthesizedExpr2'.
    AstParenthesizedExpr new expr: '2'.
  } ;

ContextItemExpr :
  ""."" {
    self informAboutRuleReduction:'ContextItemExpr1'.
    AstContextItemExpr new.
  } ;

OrderedExpr :
  ""ordered"" ""{"" Expr ""}"" {
    self informAboutRuleReduction:'OrderedExpr1'.
    '3'.
  } ;

UnorderedExpr :
  ""unordered"" ""{"" Expr ""}"" {
    self informAboutRuleReduction:'UnorderedExpr1'.
    '3'.
  } ;

FunctionCall :
  QName ""("" "")"" {
    self informAboutRuleReduction:'FunctionCall1'.
    AstFunctionCall new qname: '1'.
  } |
  QName ""("" FunctionParametersList "")"" {
    self informAboutRuleReduction:'FunctionCall2'.
    AstFunctionCall new qname: '1'; functionParametersList: '3'.
  } ;

FunctionParametersList:
    ExprSingle {
	self informAboutRuleReduction:'FunctionParametersList1'.
	AstFunctionParametersList new exprSingle: '1'.
    } |
    ExprSingle "","" FunctionParametersList {
	self informAboutRuleReduction:'FunctionParametersList2'.
	AstFunctionParametersList new exprSingle: '1'; functionParametersList: '3'.
    } ;

Constructor :
  DirectConstructor {
    self informAboutRuleReduction:'Constructor1'.
    '1'.
  } |
  ComputedConstructor {
    self informAboutRuleReduction:'Constructor2'.
    '1'.
  } ;

DirectConstructor :
  DirElemConstructor {
    self informAboutRuleReduction:'DirectConstructor1'.
    '1'.
  } ;

DirElemConstructor :
  ""<"" QName ""/>"" {
    self informAboutRuleReduction:'DirElemConstructor1'.
    AstDirElemConstructor new qname: '2'.
  } |
  ""<"" QName DirAttributeList ""/>"" {
    self informAboutRuleReduction:'DirElemConstructor2'.
    AstDirElemConstructor new qname: '2'; dirAttributeList: '3'.
  } |
  ""<"" QName "">"" DirElemContent ""</"" QName "">"" {
    self informAboutRuleReduction:'DirElemConstructor3'.
    AstDirElemConstructor new qname: '2'; dirElemContent: '4'.
  } |
  ""<"" QName DirAttributeList "">"" DirElemContent ""</"" QName "">"" {
    self informAboutRuleReduction:'DirElemConstructor4'.
    AstDirElemConstructor new qname: '2'; dirAttributeList: '3'; dirElemContent: '5'.
  } ;

DirAttributeList :
  QName ""="" DirAttributeValue {
    self informAboutRuleReduction:'DirAttributeList1'.
    AstDirAttributeList new qname: '1'; dirAttributeValue: '3'.
  } |
  QName ""="" DirAttributeValue DirAttributeList {
    self informAboutRuleReduction:'DirAttributeList2'.
    AstDirAttributeList new qname: '1'; dirAttributeValue: '3'; dirAttributeList: '4'.
  } ;

DirAttributeValue :
  StringLiteral {
    self informAboutRuleReduction:'DirAttributeValue1'.
    '1'.
  } |
  EnclosedExpr {
    self informAboutRuleReduction:'DirAttributeValue2'.
    '1'.
  } ;

DirElemContent :
  DirectConstructor {
    self informAboutRuleReduction:'DirElemContent1'.
    AstDirElemContent new content: '1'.
  } |
  DirectConstructor DirElemContent {
    self informAboutRuleReduction:'DirElemContent2'.
    AstDirElemContent new content: '1'; dirElemContent: '2'.
  } |
  CommonContent {
    self informAboutRuleReduction:'DirElemContent3'.
    AstDirElemContent new content: '1'.
  } |
  CommonContent DirElemContent {
    self informAboutRuleReduction:'DirElemContent4'.
    AstDirElemContent new content: '1'; dirElemContent: '2'.
  } ;

CommonContent :
  PredefinedEntityRef {
    self informAboutRuleReduction:'CommonContent1'.
    '1'.
  } |
  EnclosedExpr {
    self informAboutRuleReduction:'CommonContent2'.
    '1'.
  } |
  Literal {
    self informAboutRuleReduction:'CommonContent3'.
    '1'.
  } |
  NCName {
    self informAboutRuleReduction:'CommonContent7'.
    '1'.
  } |
  QName {
    self informAboutRuleReduction:'CommonContent8'.
    '1'.
  } ;

ComputedConstructor :
  CompDocConstructor {
    self informAboutRuleReduction:'ComputedConstructor1'.
    '1'.
  } |
  CompElemConstructor {
    self informAboutRuleReduction:'ComputedConstructor2'.
    '1'.
  } |
  CompAttrConstructor {
    self informAboutRuleReduction:'ComputedConstructor3'.
    '1'.
  } |
  CompTextConstructor {
    self informAboutRuleReduction:'ComputedConstructor4'.
    '1'.
  } ;

CompDocConstructor :
  ""document"" ""{"" Expr ""}"" {
    self informAboutRuleReduction:'CompDocConstructor1'.
    AstCompDocConstructor new expr: '3'.
  } ;

CompElemConstructor :
  ""element"" QName ""{"" ""}"" {
    self informAboutRuleReduction:'CompElemConstructor1'.
    AstCompElemConstructor new qname: '2'.
  } |
  ""element"" QName ""{"" ContentExpr ""}"" {
    self informAboutRuleReduction:'CompElemConstructor2'.
    AstCompElemConstructor new qname: '2'; contentExpr: '4'.
  } |
  ""element"" ""{"" Expr ""}"" ""{"" ""}"" {
    self informAboutRuleReduction:'CompElemConstructor3'.
    AstCompElemConstructor new expr: '3'.
  } |
  ""element"" ""{"" Expr ""}"" ""{"" ContentExpr ""}"" {
    self informAboutRuleReduction:'CompElemConstructor4'.
    AstCompElemConstructor new expr: '3'; contentExpr: '6'.
  } ;

ContentExpr :
  Expr {
    self informAboutRuleReduction:'ContentExpr'.
    '1'.
  } ;

CompAttrConstructor :
  ""attribute"" QName ""{"" ""}"" {
    self informAboutRuleReduction:'CompAttrConstructor1'.
    AstCompAttrConstructor new qname: '2'.
  } |
  ""attribute"" QName ""{"" Expr ""}"" {
    self informAboutRuleReduction:'CompAttrConstructor2'.
    AstCompAttrConstructor new qname: '2'; contentExpr: '4'.
  } |
  ""attribute"" ""{"" Expr ""}"" ""{"" ""}"" {
    self informAboutRuleReduction:'CompAttrConstructor3'.
    AstCompAttrConstructor new expr: '3'.
  } |
  ""attribute"" ""{"" Expr ""}"" ""{"" Expr ""}"" {
    self informAboutRuleReduction:'CompAttrConstructor4'.
    AstCompAttrConstructor new expr: '3'; contentExpr: '6'.
  } ;

CompTextConstructor :
  ""text"" ""{"" Expr ""}"" {
    self informAboutRuleReduction:'CompTextConstructor1'.
    AstCompTextConstructor new expr: '3'.
  } ;

KindTest :
  DocumentTest {
    self informAboutRuleReduction:'KindTest1'.
    '1'.
  } |
  ElementTest {
    self informAboutRuleReduction:'KindTest2'.
    '1'.
  } |
  AttributeTest {
    self informAboutRuleReduction:'KindTest3'.
    '1'.
  } |
  TextTest {
    self informAboutRuleReduction:'KindTest4'.
    '1'.
  } |
  AnyKindTest {
    self informAboutRuleReduction:'KindTest5'.
    '1'.
  }
  | ""comment"" ""("" "")""
  	{ XMLv2::XPathCommentTest new }  	
  | ""processing-instruction"" ""("" "")""
  	{ XMLv2::XPathProcessingInstructionTest new }
  ;

AnyKindTest :
  ""node"" ""("" "")"" {
    self informAboutRuleReduction:'AnyKindTest1'.
    XMLv2::XPathAnyKindTest new
  } ;

DocumentTest :
  ""document-node"" ""("" "")"" {
    self informAboutRuleReduction:'DocumentTest1'.
    XMLv2::XPathDocumentTest new.
  } |
  ""document-node"" ""("" ElementTest "")"" {
    self informAboutRuleReduction:'DocumentTest2'.
    XMLv2::XPathDocumentTest new elementTest: '3'.
  } ;

TextTest :
  ""text"" ""("" "")"" {
    self informAboutRuleReduction:'TextTest1'.
    XMLv2::XPathTextTest new.
  } ;
  
AttributeTest :
  ""attribute"" ""("" "")"" {
    self informAboutRuleReduction:'AttributeTest1'.
    XMLv2::XPathAttributeTest new
  } |
  ""attribute"" ""("" AttribNameOrWildcard "")"" {
    self informAboutRuleReduction:'AttributeTest2'.
	XMLv2::XPathAttributeTest halt:'Not yet implemented. See grammar'
  } ;

AttribNameOrWildcard :
  AttributeName {
    self informAboutRuleReduction:'AttributeNameOrWildcard1'.
    AstAttribNameOrWildcard new attributeName: '1'.
  } |
  ""*"" {
    self informAboutRuleReduction:'AttributeNameOrWildcard2'.
    AstAttribNameOrWildcard new.
  } ;

ElementTest :
  ""element"" ""("" "")"" {
    self informAboutRuleReduction:'ElementTest1'.
    AstElementTest new.
  } |
  ""element"" ""("" ElementNameOrWildcard "")"" {
    self informAboutRuleReduction:'ElementTest2'.
    AstElementTest new elementName: '3'.
  } ;

ElementNameOrWildcard :
  ElementName {
    self informAboutRuleReduction:'ElementNameOrWildcard1'.
    AstElementNameOrWildcard new elementName: '1'.
  } |
  ""*"" {
    self informAboutRuleReduction:'ElementNameOrWildcard2'.
    AstElementNameOrWildcard new.
  } ;

AttributeName :
  QName {
    self informAboutRuleReduction:'AttributeName1'.
    '1'.
  } ;

ElementName :
  QName {
    self informAboutRuleReduction:'ElementName1'.
    '1'.
  } ;

EnclosedExpr :
  ""{"" Expr ""}"" {
    self informAboutRuleReduction:'EnclosedExpr1'.
    AstEnclosedExpr new expr: '2'.
  } ;

PredefinedEntityRef :
  <predefined_entity_ref> {
    self informAboutRuleReduction:'PredefinedEntityRef1 -', ('1' asString).
    AstPredefinedEntityRef new content: ('1' value).
  } ;

QName :
  <qname> {
    self informAboutRuleReduction:'QName1 - ', ('1' asString).
    AstQName new content: ('1' value).
  } ;

NCName :
  <ncname> {
    self informAboutRuleReduction:'NCName1 - ', ('1' asString).
    AstNCName new content: ('1' value).
  } ;

StringLiteral :
  <string_literal> {
    self informAboutRuleReduction:'StringLiteral1 -', ('1' asString).
    AstStringLiteral new content: ('1' value).
  } ;

IntegerLiteral :
  <integer_literal> {
    self informAboutRuleReduction:'IntegerLiteral1 -', ('1' asString).
    AstIntegerLiteral new content: ('1' value asInteger).
  } ;

DecimalLiteral :
  <decimal_literal> {
    self informAboutRuleReduction:'DecimalLiteral1 -', ('1' asString).
    AstDecimalLiteral new content: ('1' value asFloat).
  } ;

DoubleLiteral :
  <double_literal> {
    self informAboutRuleReduction:'DoubleLiteral1 -', ('1' asString).
    AstDoubleLiteral new content: ('1' value asDouble).
  } ;

DeleteExpr :
  ""do"" ""delete"" TargetExpr {
    self informAboutRuleReduction:'DeleteExpr'.
    (AstDeleteExpr new) targetExpr: '3'
  };

RenameExpr:
  ""do"" ""rename"" TargetExpr ""as"" NewNameExpr {
    self informAboutRuleReduction:'RenameExpr'.
    (AstRenameExpr new) targetExpr: '3'; newNameExpr: '5'.
  };

ReplaceExpr :
  ""do"" ""replace"" ReplaceClause {
    self informAboutRuleReduction:'ReplaceExpr'.
    '3'.
  };

ReplaceClause :
  ""value"" ""of"" TargetExpr ""with"" ExprSingle {
    self informAboutRuleReduction:'ReplaceValueOfClause'.
    (AstReplaceValueOfExpr new) targetExpr: '3'; sourceExpr: '5'.
  } |
  TargetExpr ""with"" ExprSingle {
    self informAboutRuleReduction:'ReplaceClause'.
    (AstReplaceExpr new) targetExpr: '1'; sourceExpr: '3'.
  };



InsertExpr :
  ""do"" ""insert"" InsertClause  {
    self informAboutRuleReduction:'InsertExpr'.
    '3'.
  };

InsertClause :
  SourceExpr ""into"" TargetExpr {
    self informAboutRuleReduction:'InsertIntoClause'.
    (AstInsertIntoExpr new) targetExpr: '3'; sourceExpr: '1'.
  } |
  SourceExpr ""as"" ""first"" ""into"" TargetExpr {
    self informAboutRuleReduction:'InsertAsFirstIntoClause'.
    (AstInsertAsFirstIntoExpr new) targetExpr: '5'; sourceExpr: '1'.
  } |
  SourceExpr ""as"" ""last"" ""into"" TargetExpr {
    self informAboutRuleReduction:'InsertAsLastIntoClause'.
    (AstInsertAsLastIntoExpr new) targetExpr: '5'; sourceExpr: '1'.
  } |
  SourceExpr ""after"" TargetExpr {
    self informAboutRuleReduction:'InsertAfterClause'.
    (AstInsertAfterExpr new) targetExpr: '3'; sourceExpr: '1'.
  } |
  SourceExpr ""before"" TargetExpr {
    self informAboutRuleReduction:'InsertBeforeClause'.
    (AstInsertBeforeExpr new) targetExpr: '3'; sourceExpr: '1'.
  };
  
TransformExpr:
  ""transform"" ""copy"" TransformCopyClause ""modify"" ExprSingle ""return"" ExprSingle {
    self informAboutRuleReduction:'TransformExpr'.
    (AstTransformExpr new) transformCopyClause: '3'; modifyExpr: '5'; returnExpr: '7'.
  };

TransformCopyClause:
	""$"" VarName "":="" ExprSingle {
	    self informAboutRuleReduction:'TransformCopyClause1'.
	    (AstTransformCopyClause new) varName: '2'; exprSingle: '4'.
  }|
	""$"" VarName "":="" ExprSingle "","" TransformCopyClause {
  		self informAboutRuleReduction:'TransformCopyClause2'.
	    (AstTransformCopyClause new) varName: '2'; exprSingle: '4' ; transformCopyClause: '6'.
  };


TargetExpr :
  ExprSingle{
    self informAboutRuleReduction:'TargetExpr'.
    '1'.
  };

SourceExpr :
  ExprSingle{
    self informAboutRuleReduction:'SourceExpr'.
    '1'.
  };


NewNameExpr :
  ExprSingle{
    self informAboutRuleReduction:'NewNameExpr'.
    '1'.
  };









"
! !

!XQueryParser class methodsFor:'generated-starting states'!

startingStateForMainModule
	^2
!

startingStateForQueryBody
	^1

    "Modified: / 03-12-2006 / 19:46:11 / ked"
! !

!XQueryParser methodsFor:'accessing'!

parse
    | module |
    module := super parse.
    module source: self source.
    ^module

    "Created: / 12-04-2007 / 11:51:15 / janfrog"
!

source

    ^scanner source

    "Created: / 12-04-2007 / 11:51:56 / janfrog"
! !

!XQueryParser methodsFor:'generated-reduction actions'!

reduceActionForAbbrevForwardStep1:nodes 
    self informAboutRuleReduction:'AbbrevForwardStep1'.
    ^ (XMLv2::XPathLocationStep new)
        axis:XMLv2::XPathAxisAttribute new;
        nodeTest:(nodes at:2);
        yourself
!

reduceActionForAbbrevForwardStep2:nodes 
    self informAboutRuleReduction:'AbbrevForwardStep2'.
    ^ (XMLv2::XPathLocationStep new)
        axis:XMLv2::XPathAxisChild new;
        nodeTest:(nodes at:1);
        yourself
!

reduceActionForAbbrevReverseStep1:nodes 
    ^ (XMLv2::XPathLocationStep new)
        axis:XMLv2::XPathAxisParent new;
        nodeTest:XMLv2::XPathAnyKindTest new;
        yourself
!

reduceActionForAdditiveExpr1:nodes 
    self informAboutRuleReduction:'AdditiveExpr1'.
    ^ nodes at:1.
!

reduceActionForAdditiveExpr2:nodes 
    self informAboutRuleReduction:'AdditiveExpr2'.
    ^ (AstAdditiveExpr new)
        multiplicativeExpr:(nodes at:1);
        operand:#plus;
        additiveExpr:(nodes at:3).
!

reduceActionForAdditiveExpr3:nodes 
    self informAboutRuleReduction:'AdditiveExpr3'.
    ^ (AstAdditiveExpr new)
        multiplicativeExpr:(nodes at:1);
        operand:#minus;
        additiveExpr:(nodes at:3).
!

reduceActionForAndExpr1:nodes 
    self informAboutRuleReduction:'AndExpr1'.
    ^ nodes at:1.
!

reduceActionForAndExpr2:nodes 
    self informAboutRuleReduction:'AndExpr2'.
    ^ (AstAndExpr new)
        comparisonExpr:(nodes at:1);
        andExpr:(nodes at:3).
!

reduceActionForAnyKindTest1:nodes 
    self informAboutRuleReduction:'AnyKindTest1'.
    ^ XMLv2::XPathAnyKindTest new
!

reduceActionForAttribNameOrWildcard1:nodes 
    self informAboutRuleReduction:'AttributeNameOrWildcard1'.
    ^ AstAttribNameOrWildcard new attributeName:(nodes at:1).
!

reduceActionForAttribNameOrWildcard2:nodes 
    self informAboutRuleReduction:'AttributeNameOrWildcard2'.
    ^ AstAttribNameOrWildcard new.
!

reduceActionForAttributeName1:nodes 
    self informAboutRuleReduction:'AttributeName1'.
    ^ nodes at:1.
!

reduceActionForAttributeTest1:nodes 
    self informAboutRuleReduction:'AttributeTest1'.
    ^ XMLv2::XPathAttributeTest new
!

reduceActionForAttributeTest2:nodes 
    self informAboutRuleReduction:'AttributeTest2'.
    ^ XMLv2::XPathAttributeTest halt:'Not yet implemented. See grammar'
!

reduceActionForAxisStep1:nodes 
    self informAboutRuleReduction:'AxisStep2'.
    ^ (nodes at:1)
        predicates:(nodes at:2);
        yourself
!

reduceActionForAxisStep2:nodes 
    self informAboutRuleReduction:'AxisStep4'.
    ^ (nodes at:1)
        predicates:(nodes at:2);
        yourself
!

reduceActionForAxisStep3:nodes 
    self informAboutRuleReduction:'AxisStep3'.
    ^ nodes at:1.

    "Modified: / 17-11-2007 / 13:50:27 / janfrog"
!

reduceActionForAxisStep4:nodes 
    self informAboutRuleReduction:'AxisStep4'.
    ^ (nodes at:1)
        predicates:(nodes at:2);
        yourself

    "Modified: / 17-11-2007 / 13:50:27 / janfrog"
!

reduceActionForCommonContent1:nodes 
    self informAboutRuleReduction:'CommonContent1'.
    ^ nodes at:1.
!

reduceActionForCommonContent2:nodes 
    self informAboutRuleReduction:'CommonContent2'.
    ^ nodes at:1.
!

reduceActionForCommonContent3:nodes 
    self informAboutRuleReduction:'CommonContent3'.
    ^ nodes at:1.
!

reduceActionForCommonContent4:nodes 
    self informAboutRuleReduction:'CommonContent7'.
    ^ nodes at:1.
!

reduceActionForCommonContent5:nodes 
    self informAboutRuleReduction:'CommonContent8'.
    ^ nodes at:1.
!

reduceActionForCommonContent6:nodes 
    Transcript showCR:'[PARSER] CommonContent6'.
    ^ nodes at:1.

    "Created: / 17-11-2006 / 22:20:50 / ked"
!

reduceActionForCommonContent7:nodes 
    Transcript showCR:'[PARSER] CommonContent7'.
    ^ nodes at:1.

    "Created: / 17-11-2006 / 22:20:50 / ked"
!

reduceActionForCommonContent8:nodes 
    Transcript showCR:'[PARSER] CommonContent8'.
    ^ nodes at:1.

    "Created: / 17-11-2006 / 22:20:50 / ked"
!

reduceActionForCompAttrConstructor1:nodes 
    self informAboutRuleReduction:'CompAttrConstructor1'.
    ^ AstCompAttrConstructor new qname:(nodes at:2).
!

reduceActionForCompAttrConstructor2:nodes 
    self informAboutRuleReduction:'CompAttrConstructor2'.
    ^ (AstCompAttrConstructor new)
        qname:(nodes at:2);
        contentExpr:(nodes at:4).
!

reduceActionForCompAttrConstructor3:nodes 
    self informAboutRuleReduction:'CompAttrConstructor3'.
    ^ AstCompAttrConstructor new expr:(nodes at:3).
!

reduceActionForCompAttrConstructor4:nodes 
    self informAboutRuleReduction:'CompAttrConstructor4'.
    ^ (AstCompAttrConstructor new)
        expr:(nodes at:3);
        contentExpr:(nodes at:6).
!

reduceActionForCompDocConstructor1:nodes 
    self informAboutRuleReduction:'CompDocConstructor1'.
    ^ AstCompDocConstructor new expr:(nodes at:3).
!

reduceActionForCompElemConstructor1:nodes 
    self informAboutRuleReduction:'CompElemConstructor1'.
    ^ AstCompElemConstructor new qname:(nodes at:2).
!

reduceActionForCompElemConstructor2:nodes 
    self informAboutRuleReduction:'CompElemConstructor2'.
    ^ (AstCompElemConstructor new)
        qname:(nodes at:2);
        contentExpr:(nodes at:4).
!

reduceActionForCompElemConstructor3:nodes 
    self informAboutRuleReduction:'CompElemConstructor3'.
    ^ AstCompElemConstructor new expr:(nodes at:3).
!

reduceActionForCompElemConstructor4:nodes 
    self informAboutRuleReduction:'CompElemConstructor4'.
    ^ (AstCompElemConstructor new)
        expr:(nodes at:3);
        contentExpr:(nodes at:6).
!

reduceActionForCompTextConstructor1:nodes 
    self informAboutRuleReduction:'CompTextConstructor1'.
    ^ AstCompTextConstructor new expr:(nodes at:3).
!

reduceActionForComparisonExpr1:nodes 
    self informAboutRuleReduction:'ComparisonExpr1'.
    ^ nodes at:1.
!

reduceActionForComparisonExpr2:nodes 
    self informAboutRuleReduction:'ComparisonExpr2'.
    ^ (AstComparisonExpr new)
        rangeExprLeft:(nodes at:1);
        valueComp:(nodes at:2);
        rangeExprRight:(nodes at:3).
!

reduceActionForComparisonExpr3:nodes 
    self informAboutRuleReduction:'ComparisonExpr3'.
    ^ (AstComparisonExpr new)
        rangeExprLeft:(nodes at:1);
        generalComp:(nodes at:2);
        rangeExprRight:(nodes at:3).
!

reduceActionForComparisonExpr4:nodes 
    self informAboutRuleReduction:'ComparisonExpr4'.
    ^ (AstComparisonExpr new)
        rangeExprLeft:(nodes at:1);
        nodeComp:(nodes at:2);
        rangeExprRight:(nodes at:3).
!

reduceActionForComputedConstructor1:nodes 
    self informAboutRuleReduction:'ComputedConstructor1'.
    ^ nodes at:1.
!

reduceActionForComputedConstructor2:nodes 
    self informAboutRuleReduction:'ComputedConstructor2'.
    ^ nodes at:1.
!

reduceActionForComputedConstructor3:nodes 
    self informAboutRuleReduction:'ComputedConstructor3'.
    ^ nodes at:1.
!

reduceActionForComputedConstructor4:nodes 
    self informAboutRuleReduction:'ComputedConstructor4'.
    ^ nodes at:1.
!

reduceActionForConstructor1:nodes 
    self informAboutRuleReduction:'Constructor1'.
    ^ nodes at:1.
!

reduceActionForConstructor2:nodes 
    self informAboutRuleReduction:'Constructor2'.
    ^ nodes at:1.
!

reduceActionForContentExpr1:nodes 
    self informAboutRuleReduction:'ContentExpr'.
    ^ nodes at:1.
!

reduceActionForContextItemExpr1:nodes 
    self informAboutRuleReduction:'ContextItemExpr1'.
    ^ AstContextItemExpr new.
!

reduceActionForDecimalLiteral1:nodes 
    self 
        informAboutRuleReduction:'DecimalLiteral1 -' , ((nodes at:1) asString).
    ^ AstDecimalLiteral new content:((nodes at:1) value asFloat).
!

reduceActionForDefaultNamespaceDecl1:nodes 
    ^ (AstDefaultNamespaceDecl new)
        uri:(nodes at:5);
        type:#element
!

reduceActionForDefaultNamespaceDecl2:nodes 
    ^ (AstDefaultNamespaceDecl new)
        uri:(nodes at:5);
        type:#function
!

reduceActionForDeleteExpr1:nodes 
    self informAboutRuleReduction:'DeleteExpr'.
    ^ (AstDeleteExpr new) targetExpr:(nodes at:3)
!

reduceActionForDirAttributeList1:nodes 
    self informAboutRuleReduction:'DirAttributeList1'.
    ^ (AstDirAttributeList new)
        qname:(nodes at:1);
        dirAttributeValue:(nodes at:3).
!

reduceActionForDirAttributeList2:nodes 
    self informAboutRuleReduction:'DirAttributeList2'.
    ^ (AstDirAttributeList new)
        qname:(nodes at:1);
        dirAttributeValue:(nodes at:3);
        dirAttributeList:(nodes at:4).
!

reduceActionForDirAttributeValue1:nodes 
    self informAboutRuleReduction:'DirAttributeValue1'.
    ^ nodes at:1.
!

reduceActionForDirAttributeValue2:nodes 
    self informAboutRuleReduction:'DirAttributeValue2'.
    ^ nodes at:1.
!

reduceActionForDirElemConstructor1:nodes 
    self informAboutRuleReduction:'DirElemConstructor1'.
    ^ AstDirElemConstructor new qname:(nodes at:2).
!

reduceActionForDirElemConstructor2:nodes 
    self informAboutRuleReduction:'DirElemConstructor2'.
    ^ (AstDirElemConstructor new)
        qname:(nodes at:2);
        dirAttributeList:(nodes at:3).
!

reduceActionForDirElemConstructor3:nodes 
    self informAboutRuleReduction:'DirElemConstructor3'.
    ^ (AstDirElemConstructor new)
        qname:(nodes at:2);
        dirElemContent:(nodes at:4).
!

reduceActionForDirElemConstructor4:nodes 
    self informAboutRuleReduction:'DirElemConstructor4'.
    ^ (AstDirElemConstructor new)
        qname:(nodes at:2);
        dirAttributeList:(nodes at:3);
        dirElemContent:(nodes at:5).
!

reduceActionForDirElemContent1:nodes 
    self informAboutRuleReduction:'DirElemContent1'.
    ^ AstDirElemContent new content:(nodes at:1).
!

reduceActionForDirElemContent2:nodes 
    self informAboutRuleReduction:'DirElemContent2'.
    ^ (AstDirElemContent new)
        content:(nodes at:1);
        dirElemContent:(nodes at:2).
!

reduceActionForDirElemContent3:nodes 
    self informAboutRuleReduction:'DirElemContent3'.
    ^ AstDirElemContent new content:(nodes at:1).
!

reduceActionForDirElemContent4:nodes 
    self informAboutRuleReduction:'DirElemContent4'.
    ^ (AstDirElemContent new)
        content:(nodes at:1);
        dirElemContent:(nodes at:2).
!

reduceActionForDirectConstructor1:nodes 
    self informAboutRuleReduction:'DirectConstructor1'.
    ^ nodes at:1.
!

reduceActionForDocumentTest1:nodes 
    self informAboutRuleReduction:'DocumentTest1'.
    ^ XMLv2::XPathDocumentTest new.
!

reduceActionForDocumentTest2:nodes 
    self informAboutRuleReduction:'DocumentTest2'.
    ^ XMLv2::XPathDocumentTest new elementTest:(nodes at:3).
!

reduceActionForDoubleLiteral1:nodes 
    self 
        informAboutRuleReduction:'DoubleLiteral1 -' , ((nodes at:1) asString).
    ^ AstDoubleLiteral new content:((nodes at:1) value asDouble).
!

reduceActionForElementName1:nodes 
    self informAboutRuleReduction:'ElementName1'.
    ^ nodes at:1.
!

reduceActionForElementNameOrWildcard1:nodes 
    self informAboutRuleReduction:'ElementNameOrWildcard1'.
    ^ AstElementNameOrWildcard new elementName:(nodes at:1).
!

reduceActionForElementNameOrWildcard2:nodes 
    self informAboutRuleReduction:'ElementNameOrWildcard2'.
    ^ AstElementNameOrWildcard new.
!

reduceActionForElementTest1:nodes 
    self informAboutRuleReduction:'ElementTest1'.
    ^ AstElementTest new.
!

reduceActionForElementTest2:nodes 
    self informAboutRuleReduction:'ElementTest2'.
    ^ AstElementTest new elementName:(nodes at:3).
!

reduceActionForEmptyParamList1:nodes 
    ^ #()
!

reduceActionForEnclosedExpr1:nodes 
    self informAboutRuleReduction:'EnclosedExpr1'.
    ^ AstEnclosedExpr new expr:(nodes at:2).
!

reduceActionForExpr1:nodes 
    self informAboutRuleReduction:'Expr1'.
    ^ nodes at:1.
!

reduceActionForExpr2:nodes 
    self informAboutRuleReduction:'Expr2'.
    ^ (AstExpr new)
        exprSingle:(nodes at:1);
        expr:(nodes at:3).
!

reduceActionForExprSingle1:nodes 
    self informAboutRuleReduction:'ExprSingle1'.
    ^ nodes at:1.
!

reduceActionForExprSingle2:nodes 
    self informAboutRuleReduction:'ExprSingle2'.
    ^ nodes at:1.
!

reduceActionForExprSingle3:nodes 
    self informAboutRuleReduction:'ExprSingle3'.
    ^ nodes at:1.
!

reduceActionForExprSingle4:nodes 
    self informAboutRuleReduction:'ExprSingle4'.
    ^ nodes at:1.
!

reduceActionForExprSingle5:nodes 
    self informAboutRuleReduction:'ExprSingle5'.
    ^ nodes at:1.
!

reduceActionForExprSingle6:nodes 
    self informAboutRuleReduction:'ExprSingle6'.
    ^ nodes at:1.
!

reduceActionForExprSingle7:nodes 
    self informAboutRuleReduction:'ExprSingle7'.
    ^ nodes at:1.
!

reduceActionForExprSingle8:nodes 
    self informAboutRuleReduction:'ExprSingle8'.
    ^ nodes at:1.
!

reduceActionForExprSingle9:nodes 
    self informAboutRuleReduction:'ExprSingle9'.
    ^ nodes at:1.
!

reduceActionForFLWORExpr1:nodes 
    self informAboutRuleReduction:'FLWORExpr1'.
    ^ (AstFLWORExpr new)
        flworExpr_ForLet:(nodes at:1);
        exprSingle:(nodes at:3).
!

reduceActionForFLWORExpr2:nodes 
    self informAboutRuleReduction:'FLWORExpr2'.
    ^ (AstFLWORExpr new)
        flworExpr_ForLet:(nodes at:1);
        whereClause:(nodes at:2);
        exprSingle:(nodes at:4).
!

reduceActionForFLWORExpr3:nodes 
    self informAboutRuleReduction:'FLWORExpr3'.
    ^ (AstFLWORExpr new)
        flworExpr_ForLet:(nodes at:1);
        orderByClause:(nodes at:2);
        exprSingle:(nodes at:4).
!

reduceActionForFLWORExpr4:nodes 
    self informAboutRuleReduction:'FLWORExpr4'.
    ^ (AstFLWORExpr new)
        flworExpr_ForLet:(nodes at:1);
        whereClause:(nodes at:2);
        orderByClause:(nodes at:3);
        exprSingle:(nodes at:5).
!

reduceActionForFLWORExpr_ForLet1:nodes 
    self informAboutRuleReduction:'FLWORExpr_ForLet1'.
    ^ nodes at:1.
!

reduceActionForFLWORExpr_ForLet2:nodes 
    self informAboutRuleReduction:'FLWORExpr_ForLet2'.
    ^ nodes at:1.
!

reduceActionForFLWORExpr_ForLet3:nodes 
    self informAboutRuleReduction:'FLWORExpr_ForLet3'.
    ^ (AstFLWORExpr_ForLet new)
        forClause:(nodes at:1);
        flworExpr_ForLet:(nodes at:2).
!

reduceActionForFLWORExpr_ForLet4:nodes 
    self informAboutRuleReduction:'FLWORExpr_ForLet4'.
    ^ (AstFLWORExpr_ForLet new)
        letClause:(nodes at:1);
        flworExpr_ForLet:(nodes at:2).
!

reduceActionForFilterExpr1:nodes 
    self informAboutRuleReduction:'FilterExpr2'.
    ^ (AstFilterExpr new)
        primaryExpr:(nodes at:1);
        predicateList:(nodes at:2).
!

reduceActionForFilterExpr2:nodes 
    self informAboutRuleReduction:'FilterExpr2'.
    ^ (AstFilterExpr new)
        primaryExpr:(nodes at:1);
        predicateList:(nodes at:2).

    "Modified: / 17-11-2007 / 14:03:09 / janfrog"
!

reduceActionForForClause1:nodes 
    self informAboutRuleReduction:'ForClause1'.
    ^ nodes at:2.
!

reduceActionForForClause_Impl1:nodes 
    self informAboutRuleReduction:'ForClause_Impl1'.
    ^ (AstForClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4).
!

reduceActionForForClause_Impl2:nodes 
    self informAboutRuleReduction:'ForClause_Impl2'.
    ^ (AstForClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4);
        forClause:(nodes at:6).
!

reduceActionForForClause_Impl3:nodes 
    self informAboutRuleReduction:'ForClause_Impl3'.
    ^ (AstForClause new)
        varName:(nodes at:2);
        positionalVar:(nodes at:3);
        exprSingle:(nodes at:5).
!

reduceActionForForClause_Impl4:nodes 
    self informAboutRuleReduction:'ForClause_Impl4'.
    ^ (AstForClause new)
        varName:(nodes at:2);
        positionalVar:(nodes at:3);
        exprSingle:(nodes at:5);
        forClause:(nodes at:7).
!

reduceActionForForwardAxis1:nodes 
    self informAboutRuleReduction:'ForwardAxis1'.
    ^ XMLv2::XPathAxisChild new
!

reduceActionForForwardAxis2:nodes 
    self informAboutRuleReduction:'ForwardAxis2'.
    ^ XMLv2::XPathAxisDescendant new
!

reduceActionForForwardAxis3:nodes 
    self informAboutRuleReduction:'ForwardAxis3'.
    ^ XMLv2::XPathAxisAttribute new
!

reduceActionForForwardAxis4:nodes 
    self informAboutRuleReduction:'ForwardAxis4'.
    ^ XMLv2::XPathAxisSelf new
!

reduceActionForForwardAxis5:nodes 
    self informAboutRuleReduction:'ForwardAxis5'.
    ^ XMLv2::XPathAxisSedcendantOrSelf new
!

reduceActionForForwardAxis6:nodes 
    self informAboutRuleReduction:'ForwardAxis6'.
    ^ XMLv2::XPathAxisFollowingSibling new
!

reduceActionForForwardAxis7:nodes 
    self informAboutRuleReduction:'ForwardAxis7'.
    ^ XMLv2::XPathAxisFollowing new
!

reduceActionForForwardStep1:nodes 
    self informAboutRuleReduction:'ForwardStep1'.
    ^ (XMLv2::XPathLocationStep new)
        axis:(nodes at:1);
        nodeTest:(nodes at:2);
        yourself
!

reduceActionForForwardStep2:nodes 
    self informAboutRuleReduction:'ForwardStep2'.
    ^ nodes at:1
!

reduceActionForFunctionCall1:nodes 
    self informAboutRuleReduction:'FunctionCall1'.
    ^ AstFunctionCall new qname:(nodes at:1).
!

reduceActionForFunctionCall2:nodes 
    self informAboutRuleReduction:'FunctionCall2'.
    ^ (AstFunctionCall new)
        qname:(nodes at:1);
        functionParametersList:(nodes at:3).
!

reduceActionForFunctionDecl1:nodes 
    ^ (AstFunctionDecl new)
        name:(nodes at:4);
        paramList:(nodes at:6);
        body:(nodes at:8)
!

reduceActionForFunctionParametersList1:nodes 
    self informAboutRuleReduction:'FunctionParametersList1'.
    ^ AstFunctionParametersList new exprSingle:(nodes at:1).
!

reduceActionForFunctionParametersList2:nodes 
    self informAboutRuleReduction:'FunctionParametersList2'.
    ^ (AstFunctionParametersList new)
        exprSingle:(nodes at:1);
        functionParametersList:(nodes at:3).
!

reduceActionForGeneralComp1:nodes 
    self informAboutRuleReduction:'GeneralComp1'.
    ^ #eqGeneral.
!

reduceActionForGeneralComp2:nodes 
    self informAboutRuleReduction:'GeneralComp2'.
    ^ #neGeneral.
!

reduceActionForGeneralComp3:nodes 
    self informAboutRuleReduction:'GeneralComp3'.
    ^ #ltGeneral.
!

reduceActionForGeneralComp4:nodes 
    self informAboutRuleReduction:'GeneralComp4'.
    ^ #leGeneral.
!

reduceActionForGeneralComp5:nodes 
    self informAboutRuleReduction:'GeneralComp5'.
    ^ #gtGeneral.
!

reduceActionForGeneralComp6:nodes 
    self informAboutRuleReduction:'GeneralComp6'.
    ^ #geGeneral.
!

reduceActionForGroup______updating_1:nodes 
    ^ nodes at:1
!

reduceActionForIfExpr1:nodes 
    self informAboutRuleReduction:'IfExpr1'.
    ^ (AstIfExpr new)
        expr:(nodes at:3);
        trueExprSingle:(nodes at:6);
        falseExprSingle:(nodes at:8).
!

reduceActionForInsertClause1:nodes 
    self informAboutRuleReduction:'InsertIntoClause'.
    ^ (AstInsertIntoExpr new)
        targetExpr:(nodes at:3);
        sourceExpr:(nodes at:1).
!

reduceActionForInsertClause2:nodes 
    self informAboutRuleReduction:'InsertAsFirstIntoClause'.
    ^ (AstInsertAsFirstIntoExpr new)
        targetExpr:(nodes at:5);
        sourceExpr:(nodes at:1).
!

reduceActionForInsertClause3:nodes 
    self informAboutRuleReduction:'InsertAsLastIntoClause'.
    ^ (AstInsertAsLastIntoExpr new)
        targetExpr:(nodes at:5);
        sourceExpr:(nodes at:1).
!

reduceActionForInsertClause4:nodes 
    self informAboutRuleReduction:'InsertAfterClause'.
    ^ (AstInsertAfterExpr new)
        targetExpr:(nodes at:3);
        sourceExpr:(nodes at:1).
!

reduceActionForInsertClause5:nodes 
    self informAboutRuleReduction:'InsertBeforeClause'.
    ^ (AstInsertBeforeExpr new)
        targetExpr:(nodes at:3);
        sourceExpr:(nodes at:1).
!

reduceActionForInsertExpr1:nodes 
    self informAboutRuleReduction:'InsertExpr'.
    ^ nodes at:3.
!

reduceActionForIntegerLiteral1:nodes 
    self 
        informAboutRuleReduction:'IntegerLiteral1 -' , ((nodes at:1) asString).
    ^ AstIntegerLiteral new content:((nodes at:1) value asInteger).
!

reduceActionForIntersectExceptExpr1:nodes 
    self informAboutRuleReduction:'IntersectExceptExpr1'.
    ^ nodes at:1.
!

reduceActionForIntersectExceptExpr2:nodes 
    self informAboutRuleReduction:'IntersectExceptExpr2'.
    ^ (AstIntersectExceptExpr new)
        unaryExpr:(nodes at:1);
        operand:#intersect;
        intersectExceptExpr:(nodes at:3).
!

reduceActionForIntersectExceptExpr3:nodes 
    self informAboutRuleReduction:'IntersectExceptExpr3'.
    ^ (AstIntersectExceptExpr new)
        unaryExpr:(nodes at:1);
        operand:#except;
        intersectExceptExpr:(nodes at:3).
!

reduceActionForKindTest1:nodes 
    self informAboutRuleReduction:'KindTest1'.
    ^ nodes at:1.
!

reduceActionForKindTest2:nodes 
    self informAboutRuleReduction:'KindTest2'.
    ^ nodes at:1.
!

reduceActionForKindTest3:nodes 
    self informAboutRuleReduction:'KindTest3'.
    ^ nodes at:1.
!

reduceActionForKindTest4:nodes 
    self informAboutRuleReduction:'KindTest4'.
    ^ nodes at:1.
!

reduceActionForKindTest5:nodes 
    self informAboutRuleReduction:'KindTest5'.
    ^ nodes at:1.
!

reduceActionForKindTest6:nodes 
    ^ XMLv2::XPathCommentTest new
!

reduceActionForKindTest7:nodes 
    ^ XMLv2::XPathProcessingInstructionTest new
!

reduceActionForLetClause1:nodes 
    self informAboutRuleReduction:'LetClause1'.
    ^ nodes at:2.
!

reduceActionForLetClause_Impl1:nodes 
    self informAboutRuleReduction:'LetClause_Impl1'.
    ^ (AstLetClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4).
!

reduceActionForLetClause_Impl2:nodes 
    self informAboutRuleReduction:'LetClause_Impl2'.
    ^ (AstLetClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4);
        letClause:(nodes at:6).
!

reduceActionForLiteral1:nodes 
    self informAboutRuleReduction:'Literal1'.
    ^ nodes at:1.
!

reduceActionForLiteral2:nodes 
    self informAboutRuleReduction:'Literal2'.
    ^ nodes at:1.
!

reduceActionForMainModule1:nodes 
    ^ (AstMainModule new)
        prolog:(nodes at:1);
        queryBody:(nodes at:2)
!

reduceActionForMultiplicativeExpr1:nodes 
    self informAboutRuleReduction:'MultiplicativeExpr1'.
    ^ nodes at:1.
!

reduceActionForMultiplicativeExpr2:nodes 
    self informAboutRuleReduction:'MultiplicativeExpr2'.
    ^ (AstMultiplicativeExpr new)
        unionExpr:(nodes at:1);
        operand:#krat;
        multiplicativeExpr:(nodes at:3).
!

reduceActionForMultiplicativeExpr3:nodes 
    self informAboutRuleReduction:'MultiplicativeExpr3'.
    ^ (AstMultiplicativeExpr new)
        unionExpr:(nodes at:1);
        operand:#div;
        multiplicativeExpr:(nodes at:3).
!

reduceActionForMultiplicativeExpr4:nodes 
    self informAboutRuleReduction:'MultiplicativeExpr4'.
    ^ (AstMultiplicativeExpr new)
        unionExpr:(nodes at:1);
        operand:#idiv;
        multiplicativeExpr:(nodes at:3).
!

reduceActionForMultiplicativeExpr5:nodes 
    self informAboutRuleReduction:'MultiplicativeExpr5'.
    ^ (AstMultiplicativeExpr new)
        unionExpr:(nodes at:1);
        operand:#mod;
        multiplicativeExpr:(nodes at:3).
!

reduceActionForNCName1:nodes 
    self informAboutRuleReduction:'NCName1 - ' , ((nodes at:1) asString).
    ^ AstNCName new content:((nodes at:1) value).
!

reduceActionForNameTest1:nodes 
    self informAboutRuleReduction:'NameTest1'.
    ^ XMLv2::XPathNameTest new qName:(nodes at:1) content
!

reduceActionForNameTest2:nodes 
    self informAboutRuleReduction:'NameTest1'.
    ^ (XMLv2::XPathNameTest new)
        prefix:'*';
        localName:'*'
!

reduceActionForNameTest3:nodes 
    self informAboutRuleReduction:'NameTest1'.
    ^ (XMLv2::XPathNameTest new)
        prefix:'*';
        localName:(nodes at:3) content
!

reduceActionForNamespaceDecl1:nodes 
    ^ (AstNamespaceDecl new)
        prefix:(nodes at:3);
        nsuri:(nodes at:5)
!

reduceActionForNewNameExpr1:nodes 
    self informAboutRuleReduction:'NewNameExpr'.
    ^ nodes at:1.
!

reduceActionForNodeComp1:nodes 
    self informAboutRuleReduction:'NodeComp1'.
    ^ #is.
!

reduceActionForNodeComp2:nodes 
    self informAboutRuleReduction:'NodeComp2'.
    ^ #isLess.
!

reduceActionForNodeComp3:nodes 
    self informAboutRuleReduction:'NodeComp3'.
    ^ #isMore.
!

reduceActionForNodeTest1:nodes 
    self informAboutRuleReduction:'NodeTest1'.
    ^ nodes at:1.
!

reduceActionForNodeTest2:nodes 
    self informAboutRuleReduction:'NodeTest2'.
    ^ nodes at:1.
!

reduceActionForNumericLiteral1:nodes 
    self informAboutRuleReduction:'NumericLiteral1'.
    ^ nodes at:1.
!

reduceActionForNumericLiteral2:nodes 
    self informAboutRuleReduction:'NumericLiteral2'.
    ^ nodes at:1.
!

reduceActionForNumericLiteral3:nodes 
    self informAboutRuleReduction:'NumericLiteral3'.
    ^ nodes at:1.
!

reduceActionForOneOrMoreParamList1:nodes 
    ^ (nodes at:1)
        add:(nodes at:3);
        yourself
!

reduceActionForOneOrMoreParamList2:nodes 
    ^ OrderedCollection with:(nodes at:1)
!

reduceActionForOptional__Group______updating_1:nodes 
    ^ nil
!

reduceActionForOptional__Group______updating_2:nodes 
    ^ nodes at:1
!

reduceActionForOptional__Group______value___of_1:nodes 
    ^ nil

    "Modified: / 31-10-2007 / 09:24:55 / janfrog"
!

reduceActionForOptional__Group______value___of_2:nodes 
    ^ nodes at:1

    "Modified: / 31-10-2007 / 09:24:55 / janfrog"
!

reduceActionForOptional___updating_1:nodes 
    ^ nil
!

reduceActionForOptional___updating_2:nodes 
    ^ nodes at:1
!

reduceActionForOrExpr1:nodes 
    self informAboutRuleReduction:'OrExpr1'.
    ^ nodes at:1.
!

reduceActionForOrExpr2:nodes 
    self informAboutRuleReduction:'OrExpr2'.
    ^ (AstOrExpr new)
        andExpr:(nodes at:1);
        orExpr:(nodes at:3).
!

reduceActionForOrderByClause1:nodes 
    self informAboutRuleReduction:'OrderByClause1'.
    ^ (AstOrderByClause new)
        isStable:false;
        orderSpecList:(nodes at:3).
!

reduceActionForOrderByClause2:nodes 
    self informAboutRuleReduction:'OrderByClause2'.
    ^ (AstOrderByClause new)
        isStable:true;
        orderSpecList:(nodes at:4).
!

reduceActionForOrderModifier1:nodes 
    self informAboutRuleReduction:'OrderModifier1'.
    ^ AstOrderModifier new ascDesc:(nodes at:1).
!

reduceActionForOrderModifier2:nodes 
    self informAboutRuleReduction:'OrderModifier2'.
    ^ AstOrderModifier new greatestLeast:(nodes at:1).
!

reduceActionForOrderModifier3:nodes 
    self informAboutRuleReduction:'OrderModifier3'.
    ^ (AstOrderModifier new)
        ascDesc:(nodes at:1);
        greatestLeast:(nodes at:2).
!

reduceActionForOrderModifier_AscDesc1:nodes 
    self informAboutRuleReduction:'OrderModifier_AscDesc1'.
    ^ #asc.
!

reduceActionForOrderModifier_AscDesc2:nodes 
    self informAboutRuleReduction:'OrderModifier_AscDesc2'.
    ^ #desc.
!

reduceActionForOrderModifier_GreatestLeast1:nodes 
    self informAboutRuleReduction:'OrderModifier_GreatestLeast1'.
    ^ #greatest.
!

reduceActionForOrderModifier_GreatestLeast2:nodes 
    self informAboutRuleReduction:'OrderModifier_GreatestLeast2'.
    ^ #least.
!

reduceActionForOrderSpec1:nodes 
    self informAboutRuleReduction:'OrderSpec1'.
    ^ AstOrderSpec new exprSingle:(nodes at:1).
!

reduceActionForOrderSpec2:nodes 
    self informAboutRuleReduction:'OrderSpec2'.
    ^ (AstOrderSpec new)
        exprSingle:(nodes at:1);
        orderModifier:(nodes at:2).
!

reduceActionForOrderSpecList1:nodes 
    self informAboutRuleReduction:'OrderSpecList1'.
    ^ nodes at:1.
!

reduceActionForOrderSpecList2:nodes 
    self informAboutRuleReduction:'OrderSpecList2'.
    ^ (AstOrderSpecList new)
        orderSpec:(nodes at:1);
        orderSpecList:(nodes at:3).
!

reduceActionForOrderedExpr1:nodes 
    self informAboutRuleReduction:'OrderedExpr1'.
    ^ nodes at:3.
!

reduceActionForParam1:nodes 
    ^ AstParam new name:(nodes at:2)
!

reduceActionForParamList1:nodes 
    ^ nodes at:1
!

reduceActionForParamList2:nodes 
    ^ '2'
!

reduceActionForParenthesizedExpr1:nodes 
    self informAboutRuleReduction:'ParenthesizedExpr1'.
    ^ AstParenthesizedExpr new.
!

reduceActionForParenthesizedExpr2:nodes 
    self informAboutRuleReduction:'ParenthesizedExpr2'.
    ^ AstParenthesizedExpr new expr:(nodes at:2).
!

reduceActionForPathExpr1:nodes 
    self informAboutRuleReduction:'PathExpr2'.
    ^ (nodes at:2)
        absolute:true;
        yourself
!

reduceActionForPathExpr2:nodes 
    self informAboutRuleReduction:'PathExpr3'.
    ^ (nodes at:2)
        addFirst:((XMLv2::XPathLocationStep new)
                    axis:XMLv2::XPathAxisDescendantOrSelf new;
                    nodeTest:XMLv2::XPathAnyKindTest new);
        yourself
!

reduceActionForPathExpr3:nodes 
    self informAboutRuleReduction:'PathExpr4'.
    ^ nodes at:1.
!

reduceActionForPositionalVar1:nodes 
    self informAboutRuleReduction:'PositionalVar1'.
    ^ nodes at:3.
!

reduceActionForPredefinedEntityRef1:nodes 
    self informAboutRuleReduction:'PredefinedEntityRef1 -' 
                , ((nodes at:1) asString).
    ^ AstPredefinedEntityRef new content:((nodes at:1) value).
!

reduceActionForPredicate1:nodes 
    self informAboutRuleReduction:'Predicate1'.
    ^ XMLv2::XPathPredicate new expr:(nodes at:2).
!

reduceActionForPredicate2:nodes 
    self informAboutRuleReduction:'Predicate2'.
    ^ XMLv2::XPathPredicate new
!

reduceActionForPredicateList1:nodes 
    self informAboutRuleReduction:'PredicateList1'.
    ^ nodes at:1.

    "Modified: / 17-11-2007 / 14:00:00 / janfrog"
!

reduceActionForPredicateList2:nodes 
    self informAboutRuleReduction:'PredicateList2'.
    ^ (AstPredicateList new)
        predicate:(nodes at:1);
        predicateList:(nodes at:2).

    "Modified: / 17-11-2007 / 14:00:00 / janfrog"
!

reduceActionForPrimaryExpr1:nodes 
    self informAboutRuleReduction:'PrimaryExpr1'.
    ^ nodes at:1.
!

reduceActionForPrimaryExpr2:nodes 
    self informAboutRuleReduction:'PrimaryExpr2'.
    ^ nodes at:1.
!

reduceActionForPrimaryExpr3:nodes 
    self informAboutRuleReduction:'PrimaryExpr3'.
    ^ nodes at:1.
!

reduceActionForPrimaryExpr4:nodes 
    self informAboutRuleReduction:'PrimaryExpr4'.
    ^ nodes at:1.
!

reduceActionForPrimaryExpr5:nodes 
    self informAboutRuleReduction:'PrimaryExpr5'.
    ^ nodes at:1.
!

reduceActionForPrimaryExpr6:nodes 
    self informAboutRuleReduction:'PrimaryExpr6'.
    ^ nodes at:1.
!

reduceActionForPrimaryExpr7:nodes 
    self informAboutRuleReduction:'PrimaryExpr7'.
    ^ nodes at:1.
!

reduceActionForPrimaryExpr8:nodes 
    self informAboutRuleReduction:'PrimaryExpr8'.
    ^ nodes at:1.
!

reduceActionForProlog1:nodes 
    ^ AstProlog new declarations:((nodes at:1)
                addAll:(nodes at:2);
                yourself)
!

reduceActionForPrologDeclarationClass11:nodes 
    ^ nodes at:1
!

reduceActionForPrologDeclarationClass12:nodes 
    ^ nodes at:1
!

reduceActionForPrologDeclarationClass13:nodes 
    ^ nodes at:1
!

reduceActionForPrologDeclarationClass1List1:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself
!

reduceActionForPrologDeclarationClass1List2:nodes 
    ^ OrderedCollection new:5
!

reduceActionForPrologDeclarationClass21:nodes 
    ^ nodes at:1

    "Modified: / 28-12-2006 / 13:35:22 / janfrog"
!

reduceActionForPrologDeclarationClass2List1:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself
!

reduceActionForPrologDeclarationClass2List2:nodes 
    ^ OrderedCollection new:5
!

reduceActionForQName1:nodes 
    self informAboutRuleReduction:'QName1 - ' , ((nodes at:1) asString).
    ^ AstQName new content:((nodes at:1) value).
!

reduceActionForQuantifiedExpr1:nodes 
    self informAboutRuleReduction:'QuantifiedExpr1'.
    ^ (AstQuantifiedExpr new)
        someEvery:#some;
        quantifiedExpr_Impl:(nodes at:2);
        exprSingle:(nodes at:4).
!

reduceActionForQuantifiedExpr2:nodes 
    self informAboutRuleReduction:'QuantifiedExpr2'.
    ^ (AstQuantifiedExpr new)
        someEvery:#every;
        quantifiedExpr_Impl:(nodes at:2);
        exprSingle:(nodes at:4).
!

reduceActionForQuantifiedExpr_Impl1:nodes 
    self informAboutRuleReduction:'QuantifiedExpr_Impl1'.
    ^ (AstQuantifiedExpr_Impl new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4).
!

reduceActionForQuantifiedExpr_Impl2:nodes 
    self informAboutRuleReduction:'QuantifiedExpr_Impl2'.
    ^ (AstQuantifiedExpr_Impl new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4);
        quantifiedExpr_Impl:(nodes at:6).
!

reduceActionForQueryBody1:nodes 
    self informAboutRuleReduction:'QueryBody1'.
    ^ nodes at:1.
!

reduceActionForRangeExpr1:nodes 
    self informAboutRuleReduction:'RangeExpr1'.
    ^ nodes at:1.
!

reduceActionForRangeExpr2:nodes 
    self informAboutRuleReduction:'RangeExpr2'.
    ^ (AstRangeExpr new)
        additiveExprFrom:(nodes at:1);
        additiveExprTo:(nodes at:3).
!

reduceActionForRelativePathExpr1:nodes 
    self informAboutRuleReduction:'RelativePathExpr1'.
    ^ XMLv2::XPathExpression with:(nodes at:1).
!

reduceActionForRelativePathExpr2:nodes 
    self informAboutRuleReduction:'RelativePathExpr2'.
    ^ (nodes at:1)
        add:(nodes at:3);
        yourself
!

reduceActionForRelativePathExpr3:nodes 
    self informAboutRuleReduction:'RelativePathExpr3'.
    ^ (nodes at:1)
        add:((XMLv2::XPathLocationStep new)
                    axis:XMLv2::XPathAxisDescendantOrSelf new;
                    nodeTest:XMLv2::XPathAnyKindTest new);
        add:(nodes at:3);
        yourself
!

reduceActionForRenameExpr1:nodes 
    self informAboutRuleReduction:'RenameExpr'.
    ^ (AstRenameExpr new)
        targetExpr:(nodes at:3);
        newNameExpr:(nodes at:5).
!

reduceActionForRepeat__Group_____________VarName______ExprSingle1:nodes 
    ^ OrderedCollection new
!

reduceActionForRepeat__Group_____________VarName______ExprSingle2:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself
!

reduceActionForRepeat__Predicate1:nodes 
    ^ OrderedCollection new
!

reduceActionForRepeat__Predicate2:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself
!

reduceActionForReplaceClause1:nodes 
    self informAboutRuleReduction:'ReplaceValueOfClause'.
    ^ (AstReplaceValueOfExpr new)
        targetExpr:(nodes at:3);
        sourceExpr:(nodes at:5).
!

reduceActionForReplaceClause2:nodes 
    self informAboutRuleReduction:'ReplaceClause'.
    ^ (AstReplaceExpr new)
        targetExpr:(nodes at:1);
        sourceExpr:(nodes at:3).
!

reduceActionForReplaceExpr1:nodes 
    self informAboutRuleReduction:'ReplaceExpr'.
    ^ nodes at:3.
!

reduceActionForReverseAxis1:nodes 
    self informAboutRuleReduction:'ReverseAxis1'.
    ^ XMLv2::XPathAxisParent new
!

reduceActionForReverseAxis2:nodes 
    self informAboutRuleReduction:'ReverseAxis2'.
    ^ XMLv2::XPathAxisAncestor new
!

reduceActionForReverseAxis3:nodes 
    self informAboutRuleReduction:'ReverseAxis3'.
    ^ XMLv2::XPathAxisAncestorOrSelf new
!

reduceActionForReverseAxis4:nodes 
    self informAboutRuleReduction:'ReverseAxis4'.
    ^ XMLv2::XPathAxisPrecedingSibling new
!

reduceActionForReverseAxis5:nodes 
    self informAboutRuleReduction:'ReverseAxis5'.
    ^ XMLv2::XPathAxisPreceding new
!

reduceActionForReverseStep1:nodes 
    self informAboutRuleReduction:'ReverseStep1'.
    ^ (XMLv2::XPathLocationStep new)
        axis:(nodes at:1);
        nodeTest:(nodes at:2);
        yourself
!

reduceActionForReverseStep2:nodes 
    self informAboutRuleReduction:'ReverseStep2'.
    ^ nodes at:1
!

reduceActionForSourceExpr1:nodes 
    self informAboutRuleReduction:'SourceExpr'.
    ^ nodes at:1.
!

reduceActionForStepExpr1:nodes 
    self informAboutRuleReduction:'StepExpr1'.
    ^ nodes at:1.
!

reduceActionForStepExpr2:nodes 
    self informAboutRuleReduction:'StepExpr2'.
    ^ nodes at:1.
!

reduceActionForStringLiteral1:nodes 
    self 
        informAboutRuleReduction:'StringLiteral1 -' , ((nodes at:1) asString).
    ^ AstStringLiteral new content:((nodes at:1) value).
!

reduceActionForTargetExpr1:nodes 
    self informAboutRuleReduction:'TargetExpr'.
    ^ nodes at:1.
!

reduceActionForTextTest1:nodes 
    self informAboutRuleReduction:'TextTest1'.
    ^ XMLv2::XPathTextTest new.
!

reduceActionForTransformCopyClause1:nodes 
    self informAboutRuleReduction:'TransformCopyClause1'.
    ^ (AstTransformCopyClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4).
!

reduceActionForTransformCopyClause2:nodes 
    self informAboutRuleReduction:'TransformCopyClause2'.
    ^ (AstTransformCopyClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4);
        transformCopyClause:(nodes at:6).
!

reduceActionForTransformExpr1:nodes 
    self informAboutRuleReduction:'TransformExpr'.
    ^ (AstTransformExpr new)
        transformCopyClause:(nodes at:3);
        modifyExpr:(nodes at:5);
        returnExpr:(nodes at:7).
!

reduceActionForURILiteral1:nodes 
    ^ nodes at:1
!

reduceActionForUnaryExpr1:nodes 
    self informAboutRuleReduction:'UnaryExpr1'.
    ^ (AstUnaryExpr new)
        operand:#minus;
        unaryExpr:(nodes at:2).
!

reduceActionForUnaryExpr2:nodes 
    self informAboutRuleReduction:'UnaryExpr2'.
    ^ (AstUnaryExpr new)
        operand:#plus;
        unaryExpr:(nodes at:2).
!

reduceActionForUnaryExpr3:nodes 
    self informAboutRuleReduction:'UnaryExpr3'.
    ^ nodes at:1.
!

reduceActionForUnionExpr1:nodes 
    self informAboutRuleReduction:'UnionExpr1'.
    ^ nodes at:1.
!

reduceActionForUnionExpr2:nodes 
    self informAboutRuleReduction:'UnionExpr2'.
    ^ (AstUnionExpr new)
        intersectExceptExpr:(nodes at:1);
        unionExpr:(nodes at:3).
!

reduceActionForUnionExpr3:nodes 
    self informAboutRuleReduction:'UnionExpr3'.
    ^ (AstUnionExpr new)
        intersectExceptExpr:(nodes at:1);
        unionExpr:(nodes at:3).
!

reduceActionForUnorderedExpr1:nodes 
    self informAboutRuleReduction:'UnorderedExpr1'.
    ^ nodes at:3.
!

reduceActionForValueComp1:nodes 
    self informAboutRuleReduction:'ValueComp1'.
    ^ #eqValue.
!

reduceActionForValueComp2:nodes 
    self informAboutRuleReduction:'ValueComp2'.
    ^ #neValue.
!

reduceActionForValueComp3:nodes 
    self informAboutRuleReduction:'ValueComp3'.
    ^ #ltValue.
!

reduceActionForValueComp4:nodes 
    self informAboutRuleReduction:'ValueComp4'.
    ^ #leValue.
!

reduceActionForValueComp5:nodes 
    self informAboutRuleReduction:'ValueComp5'.
    ^ #gtValue.
!

reduceActionForValueComp6:nodes 
    self informAboutRuleReduction:'ValueComp6'.
    ^ #geValue.
!

reduceActionForValueExpr1:nodes 
    self informAboutRuleReduction:'ValueExpr'.
    ^ nodes at:1.
!

reduceActionForVarName1:nodes 
    self informAboutRuleReduction:'VarName1'.
    ^ nodes at:1.
!

reduceActionForVarRef1:nodes 
    self informAboutRuleReduction:'VarRef1'.
    ^ AstVarRef new varName:(nodes at:2).
!

reduceActionForWhereClause1:nodes 
    self informAboutRuleReduction:'WhereClause1'.
    ^ AstWhereClause new exprSingle:(nodes at:2).
!

reduceActionForWildcard1:nodes 
    self informAboutRuleReduction:'Wildcard1'.
    ^ AstWildcard new.

    "Modified: / 17-11-2007 / 14:00:00 / janfrog"
!

reduceActionForWildcard2:nodes 
    self informAboutRuleReduction:'Wildcard2'.
    ^ AstWildcard new ncName:(nodes at:3).

    "Modified: / 17-11-2007 / 14:00:00 / janfrog"
! !

!XQueryParser methodsFor:'generated-tables'!

reduceTable
	^#(
#(119 2 #reduceActionForMainModule1:)
#(120 8 #reduceActionForFunctionDecl1:)
#(121 1 #reduceActionForURILiteral1:)
#(122 1 #reduceActionForNCName1:)
#(123 1 #reduceActionForStringLiteral1:)
#(124 0 #reduceFor:)
#(125 0 #'reduceActionForOptional___updating_1:')
#(125 1 #'reduceActionForOptional___updating_2:')
#(126 1 #reduceActionForQName1:)
#(127 1 #reduceActionForParamList1:)
#(127 1 #reduceActionForParamList2:)
#(128 3 #reduceActionForEnclosedExpr1:)
#(129 3 #reduceActionForOneOrMoreParamList1:)
#(129 1 #reduceActionForOneOrMoreParamList2:)
#(130 0 #reduceActionForEmptyParamList1:)
#(131 2 #reduceActionForParam1:)
#(132 1 #reduceActionForExpr1:)
#(132 3 #reduceActionForExpr2:)
#(133 1 #reduceActionForExprSingle1:)
#(133 1 #reduceActionForExprSingle2:)
#(133 1 #reduceActionForExprSingle3:)
#(133 1 #reduceActionForExprSingle4:)
#(133 1 #reduceActionForExprSingle5:)
#(133 1 #reduceActionForExprSingle6:)
#(133 1 #reduceActionForExprSingle7:)
#(133 1 #reduceActionForExprSingle8:)
#(133 1 #reduceActionForExprSingle9:)
#(134 3 #reduceActionForFLWORExpr1:)
#(134 4 #reduceActionForFLWORExpr2:)
#(134 4 #reduceActionForFLWORExpr3:)
#(134 5 #reduceActionForFLWORExpr4:)
#(135 4 #reduceActionForQuantifiedExpr1:)
#(135 4 #reduceActionForQuantifiedExpr2:)
#(136 8 #reduceActionForIfExpr1:)
#(137 1 #reduceActionForOrExpr1:)
#(137 3 #reduceActionForOrExpr2:)
#(138 3 #reduceActionForDeleteExpr1:)
#(139 5 #reduceActionForRenameExpr1:)
#(140 3 #reduceActionForReplaceExpr1:)
#(141 3 #reduceActionForInsertExpr1:)
#(142 7 #reduceActionForTransformExpr1:)
#(143 1 #'reduceActionForFLWORExpr_ForLet1:')
#(143 1 #'reduceActionForFLWORExpr_ForLet2:')
#(143 2 #'reduceActionForFLWORExpr_ForLet3:')
#(143 2 #'reduceActionForFLWORExpr_ForLet4:')
#(144 2 #reduceActionForWhereClause1:)
#(145 3 #reduceActionForOrderByClause1:)
#(145 4 #reduceActionForOrderByClause2:)
#(146 2 #reduceActionForForClause1:)
#(147 2 #reduceActionForLetClause1:)
#(148 4 #'reduceActionForForClause_Impl1:')
#(148 6 #'reduceActionForForClause_Impl2:')
#(148 5 #'reduceActionForForClause_Impl3:')
#(148 7 #'reduceActionForForClause_Impl4:')
#(149 1 #reduceActionForVarName1:)
#(150 3 #reduceActionForPositionalVar1:)
#(151 4 #'reduceActionForLetClause_Impl1:')
#(151 6 #'reduceActionForLetClause_Impl2:')
#(152 1 #reduceActionForOrderSpecList1:)
#(152 3 #reduceActionForOrderSpecList2:)
#(153 1 #reduceActionForOrderSpec1:)
#(153 2 #reduceActionForOrderSpec2:)
#(154 1 #reduceActionForOrderModifier1:)
#(154 1 #reduceActionForOrderModifier2:)
#(154 2 #reduceActionForOrderModifier3:)
#(155 1 #'reduceActionForOrderModifier_AscDesc1:')
#(155 1 #'reduceActionForOrderModifier_AscDesc2:')
#(156 2 #'reduceActionForOrderModifier_GreatestLeast1:')
#(156 2 #'reduceActionForOrderModifier_GreatestLeast2:')
#(157 4 #'reduceActionForQuantifiedExpr_Impl1:')
#(157 6 #'reduceActionForQuantifiedExpr_Impl2:')
#(158 1 #reduceActionForAndExpr1:)
#(158 3 #reduceActionForAndExpr2:)
#(159 1 #reduceActionForComparisonExpr1:)
#(159 3 #reduceActionForComparisonExpr2:)
#(159 3 #reduceActionForComparisonExpr3:)
#(159 3 #reduceActionForComparisonExpr4:)
#(160 1 #reduceActionForRangeExpr1:)
#(160 3 #reduceActionForRangeExpr2:)
#(161 1 #reduceActionForValueComp1:)
#(161 1 #reduceActionForValueComp2:)
#(161 1 #reduceActionForValueComp3:)
#(161 1 #reduceActionForValueComp4:)
#(161 1 #reduceActionForValueComp5:)
#(161 1 #reduceActionForValueComp6:)
#(162 1 #reduceActionForGeneralComp1:)
#(162 1 #reduceActionForGeneralComp2:)
#(162 1 #reduceActionForGeneralComp3:)
#(162 1 #reduceActionForGeneralComp4:)
#(162 1 #reduceActionForGeneralComp5:)
#(162 1 #reduceActionForGeneralComp6:)
#(163 1 #reduceActionForNodeComp1:)
#(163 1 #reduceActionForNodeComp2:)
#(163 1 #reduceActionForNodeComp3:)
#(164 1 #reduceActionForAdditiveExpr1:)
#(164 3 #reduceActionForAdditiveExpr2:)
#(164 3 #reduceActionForAdditiveExpr3:)
#(165 1 #reduceActionForMultiplicativeExpr1:)
#(165 3 #reduceActionForMultiplicativeExpr2:)
#(165 3 #reduceActionForMultiplicativeExpr3:)
#(165 3 #reduceActionForMultiplicativeExpr4:)
#(165 3 #reduceActionForMultiplicativeExpr5:)
#(166 1 #reduceActionForUnionExpr1:)
#(166 3 #reduceActionForUnionExpr2:)
#(166 3 #reduceActionForUnionExpr3:)
#(167 1 #reduceActionForIntersectExceptExpr1:)
#(167 3 #reduceActionForIntersectExceptExpr2:)
#(167 3 #reduceActionForIntersectExceptExpr3:)
#(168 2 #reduceActionForUnaryExpr1:)
#(168 2 #reduceActionForUnaryExpr2:)
#(168 1 #reduceActionForUnaryExpr3:)
#(169 5 #reduceActionForDefaultNamespaceDecl1:)
#(169 5 #reduceActionForDefaultNamespaceDecl2:)
#(170 2 #reduceActionForPathExpr1:)
#(170 2 #reduceActionForPathExpr2:)
#(170 1 #reduceActionForPathExpr3:)
#(171 1 #reduceActionForRelativePathExpr1:)
#(171 3 #reduceActionForRelativePathExpr2:)
#(171 3 #reduceActionForRelativePathExpr3:)
#(172 1 #reduceActionForStepExpr1:)
#(172 1 #reduceActionForStepExpr2:)
#(173 2 #reduceActionForAxisStep1:)
#(173 2 #reduceActionForAxisStep2:)
#(174 2 #reduceActionForFilterExpr1:)
#(175 2 #reduceActionForForwardStep1:)
#(175 1 #reduceActionForForwardStep2:)
#(176 3 #reduceActionForPredicate1:)
#(176 2 #reduceActionForPredicate2:)
#(177 0 #'reduceActionForRepeat__Predicate1:')
#(177 2 #'reduceActionForRepeat__Predicate2:')
#(178 2 #reduceActionForReverseStep1:)
#(178 1 #reduceActionForReverseStep2:)
#(179 2 #reduceActionForForwardAxis1:)
#(179 2 #reduceActionForForwardAxis2:)
#(179 2 #reduceActionForForwardAxis3:)
#(179 2 #reduceActionForForwardAxis4:)
#(179 2 #reduceActionForForwardAxis5:)
#(179 2 #reduceActionForForwardAxis6:)
#(179 2 #reduceActionForForwardAxis7:)
#(180 1 #reduceActionForNodeTest1:)
#(180 1 #reduceActionForNodeTest2:)
#(181 2 #reduceActionForAbbrevForwardStep1:)
#(181 1 #reduceActionForAbbrevForwardStep2:)
#(182 2 #reduceActionForReverseAxis1:)
#(182 2 #reduceActionForReverseAxis2:)
#(182 2 #reduceActionForReverseAxis3:)
#(182 2 #reduceActionForReverseAxis4:)
#(182 2 #reduceActionForReverseAxis5:)
#(183 1 #reduceActionForAbbrevReverseStep1:)
#(184 1 #reduceActionForNameTest1:)
#(184 1 #reduceActionForNameTest2:)
#(184 3 #reduceActionForNameTest3:)
#(185 1 #reduceActionForKindTest1:)
#(185 1 #reduceActionForKindTest2:)
#(185 1 #reduceActionForKindTest3:)
#(185 1 #reduceActionForKindTest4:)
#(185 1 #reduceActionForKindTest5:)
#(185 3 #reduceActionForKindTest6:)
#(185 3 #reduceActionForKindTest7:)
#(186 1 #reduceActionForPrimaryExpr1:)
#(186 1 #reduceActionForPrimaryExpr2:)
#(186 1 #reduceActionForPrimaryExpr3:)
#(186 1 #reduceActionForPrimaryExpr4:)
#(186 1 #reduceActionForPrimaryExpr5:)
#(186 1 #reduceActionForPrimaryExpr6:)
#(186 1 #reduceActionForPrimaryExpr7:)
#(186 1 #reduceActionForPrimaryExpr8:)
#(187 1 #reduceActionForLiteral1:)
#(187 1 #reduceActionForLiteral2:)
#(188 2 #reduceActionForVarRef1:)
#(189 2 #reduceActionForParenthesizedExpr1:)
#(189 3 #reduceActionForParenthesizedExpr2:)
#(190 1 #reduceActionForContextItemExpr1:)
#(191 3 #reduceActionForFunctionCall1:)
#(191 4 #reduceActionForFunctionCall2:)
#(192 1 #reduceActionForConstructor1:)
#(192 1 #reduceActionForConstructor2:)
#(193 4 #reduceActionForOrderedExpr1:)
#(194 4 #reduceActionForUnorderedExpr1:)
#(195 1 #reduceActionForNumericLiteral1:)
#(195 1 #reduceActionForNumericLiteral2:)
#(195 1 #reduceActionForNumericLiteral3:)
#(196 1 #reduceActionForIntegerLiteral1:)
#(197 1 #reduceActionForDecimalLiteral1:)
#(198 1 #reduceActionForDoubleLiteral1:)
#(199 1 #reduceActionForFunctionParametersList1:)
#(199 3 #reduceActionForFunctionParametersList2:)
#(200 1 #reduceActionForDirectConstructor1:)
#(201 1 #reduceActionForComputedConstructor1:)
#(201 1 #reduceActionForComputedConstructor2:)
#(201 1 #reduceActionForComputedConstructor3:)
#(201 1 #reduceActionForComputedConstructor4:)
#(202 3 #reduceActionForDirElemConstructor1:)
#(202 4 #reduceActionForDirElemConstructor2:)
#(202 7 #reduceActionForDirElemConstructor3:)
#(202 8 #reduceActionForDirElemConstructor4:)
#(203 3 #reduceActionForDirAttributeList1:)
#(203 4 #reduceActionForDirAttributeList2:)
#(204 1 #reduceActionForDirElemContent1:)
#(204 2 #reduceActionForDirElemContent2:)
#(204 1 #reduceActionForDirElemContent3:)
#(204 2 #reduceActionForDirElemContent4:)
#(205 1 #reduceActionForDirAttributeValue1:)
#(205 1 #reduceActionForDirAttributeValue2:)
#(206 1 #reduceActionForCommonContent1:)
#(206 1 #reduceActionForCommonContent2:)
#(206 1 #reduceActionForCommonContent3:)
#(206 1 #reduceActionForCommonContent4:)
#(206 1 #reduceActionForCommonContent5:)
#(207 1 #reduceActionForPredefinedEntityRef1:)
#(208 4 #reduceActionForCompDocConstructor1:)
#(209 4 #reduceActionForCompElemConstructor1:)
#(209 5 #reduceActionForCompElemConstructor2:)
#(209 6 #reduceActionForCompElemConstructor3:)
#(209 7 #reduceActionForCompElemConstructor4:)
#(210 4 #reduceActionForCompAttrConstructor1:)
#(210 5 #reduceActionForCompAttrConstructor2:)
#(210 6 #reduceActionForCompAttrConstructor3:)
#(210 7 #reduceActionForCompAttrConstructor4:)
#(211 4 #reduceActionForCompTextConstructor1:)
#(212 1 #reduceActionForContentExpr1:)
#(213 3 #reduceActionForDocumentTest1:)
#(213 4 #reduceActionForDocumentTest2:)
#(214 3 #reduceActionForElementTest1:)
#(214 4 #reduceActionForElementTest2:)
#(215 3 #reduceActionForAttributeTest1:)
#(215 4 #reduceActionForAttributeTest2:)
#(216 3 #reduceActionForTextTest1:)
#(217 3 #reduceActionForAnyKindTest1:)
#(218 1 #reduceActionForAttribNameOrWildcard1:)
#(218 1 #reduceActionForAttribNameOrWildcard2:)
#(219 1 #reduceActionForAttributeName1:)
#(220 1 #reduceActionForElementNameOrWildcard1:)
#(220 1 #reduceActionForElementNameOrWildcard2:)
#(221 1 #reduceActionForElementName1:)
#(222 3 #reduceActionForPrologDeclarationClass2List1:)
#(222 0 #reduceActionForPrologDeclarationClass2List2:)
#(223 3 #reduceActionForPrologDeclarationClass1List1:)
#(223 0 #reduceActionForPrologDeclarationClass1List2:)
#(224 1 #reduceFor:)
#(225 1 #reduceActionForPrologDeclarationClass11:)
#(225 1 #reduceActionForPrologDeclarationClass12:)
#(225 1 #reduceActionForPrologDeclarationClass13:)
#(226 1 #reduceActionForQueryBody1:)
#(227 1 #reduceActionForValueExpr1:)
#(228 2 #reduceActionForProlog1:)
#(229 1 #reduceActionForTargetExpr1:)
#(230 1 #reduceActionForNewNameExpr1:)
#(231 5 #reduceActionForReplaceClause1:)
#(231 3 #reduceActionForReplaceClause2:)
#(232 3 #reduceActionForInsertClause1:)
#(232 5 #reduceActionForInsertClause2:)
#(232 5 #reduceActionForInsertClause3:)
#(232 3 #reduceActionForInsertClause4:)
#(232 3 #reduceActionForInsertClause5:)
#(233 1 #reduceActionForSourceExpr1:)
#(234 4 #reduceActionForTransformCopyClause1:)
#(234 6 #reduceActionForTransformCopyClause2:)
#(237 5 #reduceActionForNamespaceDecl1:)
)
!

transitionTable
	^#(
#[1 3 190 0 2 3 190 0 3 3 190 0 4 3 190 0 9 3 190 0 10 3 190 0 14 3 190 0 19 3 190 0 30 3 190 0 35 3 190 0 36 3 190 0 37 3 190 0 39 3 190 0 52 3 190 0 55 3 190 0 57 3 190 0 58 3 190 0 59 3 190 0 61 3 190 0 62 3 190 0 64 3 190 0 67 3 190 0 68 3 190 0 73 3 190 0 86 3 190 0 87 3 190 0 88 3 190 0 89 3 190 0 90 3 190 0 91 3 190 0 96 3 190 0 97 3 190 0 98 3 190 0 102 3 190 0 103 3 190 0 104 3 190 0 105 3 190 0 106 3 190 0 107 3 190 0 108 3 190 0 109 3 190 0 110 3 190 0 113 3 190 0 114 3 190 0 115 3 190 0 116 3 190 0 118 0 13 0 119 0 17 0 223 0 21 0 228]
#[1 3 190 0 2 3 190 0 3 3 190 0 4 3 190 0 9 3 190 0 10 3 190 0 14 3 190 0 19 3 190 0 30 3 190 0 35 3 190 0 36 3 190 0 37 3 190 0 39 3 190 0 52 3 190 0 55 3 190 0 57 3 190 0 58 3 190 0 59 3 190 0 61 3 190 0 62 3 190 0 64 3 190 0 67 3 190 0 68 3 190 0 73 3 190 0 86 3 190 0 87 3 190 0 88 3 190 0 89 3 190 0 90 3 190 0 91 3 190 0 96 3 190 0 97 3 190 0 98 3 190 0 102 3 190 0 103 3 190 0 104 3 190 0 105 3 190 0 106 3 190 0 107 3 190 0 108 3 190 0 109 3 190 0 110 3 190 0 113 3 190 0 114 3 190 0 115 3 190 0 116 3 190 0 118 0 25 0 119 0 17 0 223 0 21 0 228]
#[0 0 0 0 235]
#[1 3 182 0 2 3 182 0 3 3 182 0 4 3 182 0 9 3 182 0 10 3 182 0 14 3 182 0 19 3 182 0 30 3 182 0 35 3 182 0 36 0 29 0 37 3 182 0 39 3 182 0 52 3 182 0 55 3 182 0 57 3 182 0 58 3 182 0 59 3 182 0 61 3 182 0 62 3 182 0 64 3 182 0 67 3 182 0 68 3 182 0 73 3 182 0 86 3 182 0 87 3 182 0 88 3 182 0 89 3 182 0 90 3 182 0 91 3 182 0 96 3 182 0 97 3 182 0 98 3 182 0 102 3 182 0 103 3 182 0 104 3 182 0 105 3 182 0 106 3 182 0 107 3 182 0 108 3 182 0 109 3 182 0 110 3 182 0 113 3 182 0 114 3 182 0 115 3 182 0 116 3 182 0 118 0 33 0 120 0 37 0 169 0 41 0 222 0 45 0 225 0 49 0 237]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 0 237 0 132 0 241 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 225 0 226 1 229 0 227]
#[0 0 0 0 235]
#[1 1 233 0 29 0 30 0 33 1 237 0 38 1 241 0 40 1 245 0 125]
#[0 3 206 0 36]
#[0 3 198 0 36]
#[1 3 218 0 2 3 218 0 3 3 218 0 4 3 218 0 9 3 218 0 10 3 218 0 14 3 218 0 19 3 218 0 30 3 218 0 35 0 26 0 36 3 218 0 39 3 218 0 52 3 218 0 55 3 218 0 57 3 218 0 58 3 218 0 59 3 218 0 61 3 218 0 62 3 218 0 64 3 218 0 67 3 218 0 68 3 218 0 73 3 218 0 86 3 218 0 87 3 218 0 88 3 218 0 89 3 218 0 90 3 218 0 91 3 218 0 96 3 218 0 97 3 218 0 98 3 218 0 102 3 218 0 103 3 218 0 104 3 218 0 105 3 218 0 106 3 218 0 107 3 218 0 108 3 218 0 109 3 218 0 110 3 218 0 113 3 218 0 114 3 218 0 115 3 218 0 116 3 218 0 118 1 249 0 124]
#[0 1 253 0 36]
#[0 3 202 0 36]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 2 1 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 2 5 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 2 94 0 1 2 94 0 2 2 94 0 3 2 94 0 4 2 94 0 5 2 94 0 6 2 94 0 7 2 94 0 8 2 94 0 12 2 94 0 13 2 94 0 15 2 94 0 16 2 94 0 17 2 94 0 18 2 94 0 19 2 94 0 20 2 94 0 22 2 94 0 23 2 94 0 24 2 94 0 25 2 94 0 26 2 94 0 27 2 94 0 28 2 94 0 31 2 94 0 32 2 94 0 34 2 94 0 41 2 94 0 42 2 94 0 43 2 94 0 44 2 94 0 45 2 94 0 46 2 94 0 47 2 94 0 52 2 94 0 54 2 94 0 55 2 94 0 56 2 94 0 69 2 94 0 70 2 94 0 71 2 94 0 72 2 94 0 80 2 94 0 82 2 94 0 84 2 94 0 89 2 94 0 92 2 94 0 93 2 94 0 94 2 94 0 95 2 94 0 96 2 9 0 99 2 94 0 100 2 94 0 101 2 94 0 235]
#[1 2 13 0 35 2 17 0 157]
#[0 2 21 0 30]
#[1 2 13 0 35 2 25 0 157]
#[1 0 209 0 113 2 29 0 126]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 2 33 0 31 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 2 37 0 132 0 241 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 209 0 113 2 41 0 126 2 45 0 149]
#[1 2 49 0 30 2 53 0 77 0 209 0 113 2 57 0 126]
#[1 2 61 0 35 2 65 0 151]
#[1 2 69 0 35 2 73 0 148]
#[0 2 77 0 30]
#[0 2 81 0 30]
#[1 2 85 0 60 2 89 0 63 2 93 0 81 2 97 0 83]
#[0 2 101 0 30]
#[0 2 105 0 30]
#[0 2 109 0 77]
#[0 2 113 0 77]
#[1 2 117 0 30 2 121 0 77]
#[0 2 125 0 74]
#[0 2 129 0 85]
#[1 2 133 0 30 2 137 0 77 2 141 0 85 0 209 0 113 2 145 0 126]
#[0 2 149 0 85]
#[1 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 153 0 90 0 157 0 91 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 2 153 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217]
#[0 2 157 0 85]
#[0 2 161 0 85]
#[1 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 153 0 90 0 157 0 91 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 2 165 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217]
#[0 2 169 0 85]
#[0 2 173 0 77]
#[0 2 182 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 177 0 85]
#[0 2 86 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 181 0 85]
#[1 0 61 0 4 2 185 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 2 189 0 68 2 193 0 87 0 209 0 113 2 197 0 126 2 201 0 180 1 117 0 184 1 121 0 185 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217]
#[0 2 205 0 85]
#[0 2 209 0 85]
#[0 2 213 0 85]
#[0 2 217 0 85]
#[0 0 38 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 65 0 66 0 69 0 70 0 71 0 72 0 77 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 235]
#[0 2 222 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 66 0 69 0 70 0 71 0 72 0 77 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 235]
#[0 2 226 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 66 0 69 0 70 0 71 0 72 0 77 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 235]
#[0 2 230 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 66 0 69 0 70 0 71 0 72 0 77 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 235]
#[0 0 22 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 36 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 65 0 66 0 69 0 70 0 71 0 72 0 77 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 235]
#[0 2 166 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 66 0 69 0 70 0 71 0 72 0 77 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 235]
#[1 2 90 0 1 2 90 0 2 2 90 0 3 2 90 0 4 2 90 0 5 2 90 0 6 2 90 0 7 2 90 0 8 2 90 0 12 2 90 0 13 2 90 0 15 2 90 0 16 2 90 0 17 2 90 0 18 2 90 0 19 2 90 0 20 2 90 0 22 2 90 0 23 2 90 0 24 2 90 0 25 2 90 0 26 2 90 0 27 2 90 0 28 2 221 0 30 2 90 0 31 2 90 0 32 2 90 0 34 2 90 0 41 2 90 0 42 2 90 0 43 2 90 0 44 2 90 0 45 2 90 0 46 2 90 0 47 2 90 0 52 2 90 0 54 2 90 0 55 2 90 0 56 2 90 0 69 2 90 0 70 2 90 0 71 2 90 0 72 2 90 0 80 2 90 0 82 2 90 0 84 2 90 0 89 2 90 0 92 2 90 0 93 2 90 0 94 2 90 0 95 2 90 0 96 2 90 0 100 2 90 0 101 2 90 0 235]
#[0 3 210 0 235]
#[1 0 70 0 31 2 225 0 32 0 70 0 70 0 70 0 101 0 70 0 235]
#[0 0 78 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 0 82 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 0 86 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 0 90 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 0 94 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 0 98 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 0 102 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 0 106 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 0 110 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[1 2 229 0 41 2 233 0 43 2 237 0 47 2 241 0 54 2 245 0 144 2 249 0 145]
#[1 0 170 0 41 0 170 0 43 0 170 0 47 0 93 0 52 0 170 0 54 0 97 0 55 2 253 0 143 1 29 0 146 1 33 0 147]
#[1 0 174 0 41 0 174 0 43 0 174 0 47 0 93 0 52 0 174 0 54 0 97 0 55 3 1 0 143 1 29 0 146 1 33 0 147]
#[1 3 5 0 5 0 142 0 8 0 142 0 12 0 142 0 31 0 142 0 32 0 142 0 41 0 142 0 43 0 142 0 44 0 142 0 45 0 142 0 46 0 142 0 47 0 142 0 52 0 142 0 54 0 142 0 55 0 142 0 56 0 142 0 69 0 142 0 70 0 142 0 71 0 142 0 72 0 142 0 80 0 142 0 82 0 142 0 101 0 142 0 235]
#[1 1 34 0 5 3 9 0 6 1 34 0 8 1 34 0 12 1 34 0 31 1 34 0 32 1 34 0 41 1 34 0 43 1 34 0 44 1 34 0 45 1 34 0 46 1 34 0 47 1 34 0 52 1 34 0 54 1 34 0 55 1 34 0 56 1 34 0 69 1 34 0 70 1 34 0 71 1 34 0 72 1 34 0 80 1 34 0 82 1 34 0 101 1 34 0 235]
#[1 1 42 0 5 1 42 0 6 1 42 0 8 1 42 0 12 3 13 0 15 3 17 0 16 3 21 0 17 3 25 0 18 3 29 0 19 3 33 0 20 3 37 0 26 3 41 0 28 1 42 0 31 1 42 0 32 3 45 0 34 1 42 0 41 3 49 0 42 1 42 0 43 1 42 0 44 1 42 0 45 1 42 0 46 1 42 0 47 1 42 0 52 1 42 0 54 1 42 0 55 1 42 0 56 1 42 0 69 1 42 0 70 1 42 0 71 1 42 0 72 1 42 0 80 1 42 0 82 3 53 0 84 3 57 0 92 3 61 0 93 3 65 0 94 3 69 0 95 1 42 0 101 3 73 0 161 3 77 0 162 3 81 0 163 1 42 0 235]
#[1 3 85 0 1 1 58 0 5 1 58 0 6 1 58 0 8 1 58 0 12 1 58 0 15 1 58 0 16 1 58 0 17 1 58 0 18 1 58 0 19 1 58 0 20 1 58 0 26 1 58 0 28 1 58 0 31 1 58 0 32 1 58 0 34 1 58 0 41 1 58 0 42 1 58 0 43 1 58 0 44 1 58 0 45 1 58 0 46 1 58 0 47 1 58 0 52 1 58 0 54 1 58 0 55 1 58 0 56 1 58 0 69 1 58 0 70 1 58 0 71 1 58 0 72 1 58 0 80 1 58 0 82 1 58 0 84 1 58 0 92 1 58 0 93 1 58 0 94 1 58 0 95 1 58 0 101 1 58 0 235]
#[1 1 126 0 1 3 89 0 2 3 93 0 3 1 126 0 5 1 126 0 6 1 126 0 8 1 126 0 12 1 126 0 15 1 126 0 16 1 126 0 17 1 126 0 18 1 126 0 19 1 126 0 20 1 126 0 26 1 126 0 28 1 126 0 31 1 126 0 32 1 126 0 34 1 126 0 41 1 126 0 42 1 126 0 43 1 126 0 44 1 126 0 45 1 126 0 46 1 126 0 47 1 126 0 52 1 126 0 54 1 126 0 55 1 126 0 56 1 126 0 69 1 126 0 70 1 126 0 71 1 126 0 72 1 126 0 80 1 126 0 82 1 126 0 84 1 126 0 92 1 126 0 93 1 126 0 94 1 126 0 95 1 126 0 101 1 126 0 235]
#[1 1 138 0 1 1 138 0 2 1 138 0 3 3 97 0 4 1 138 0 5 1 138 0 6 3 101 0 7 1 138 0 8 1 138 0 12 3 105 0 13 1 138 0 15 1 138 0 16 1 138 0 17 1 138 0 18 1 138 0 19 1 138 0 20 1 138 0 26 3 109 0 27 1 138 0 28 1 138 0 31 1 138 0 32 1 138 0 34 1 138 0 41 1 138 0 42 1 138 0 43 1 138 0 44 1 138 0 45 1 138 0 46 1 138 0 47 1 138 0 52 1 138 0 54 1 138 0 55 1 138 0 56 1 138 0 69 1 138 0 70 1 138 0 71 1 138 0 72 1 138 0 80 1 138 0 82 1 138 0 84 1 138 0 92 1 138 0 93 1 138 0 94 1 138 0 95 1 138 0 101 1 138 0 235]
#[1 1 158 0 1 1 158 0 2 1 158 0 3 1 158 0 4 1 158 0 5 1 158 0 6 1 158 0 7 1 158 0 8 1 158 0 12 1 158 0 13 1 158 0 15 1 158 0 16 1 158 0 17 1 158 0 18 1 158 0 19 1 158 0 20 3 113 0 22 3 117 0 23 1 158 0 26 1 158 0 27 1 158 0 28 1 158 0 31 1 158 0 32 1 158 0 34 1 158 0 41 1 158 0 42 1 158 0 43 1 158 0 44 1 158 0 45 1 158 0 46 1 158 0 47 1 158 0 52 1 158 0 54 1 158 0 55 1 158 0 56 1 158 0 69 1 158 0 70 1 158 0 71 1 158 0 72 1 158 0 80 1 158 0 82 1 158 0 84 1 158 0 92 1 158 0 93 1 158 0 94 1 158 0 95 1 158 0 101 1 158 0 235]
#[1 1 170 0 1 1 170 0 2 1 170 0 3 1 170 0 4 1 170 0 5 1 170 0 6 1 170 0 7 1 170 0 8 1 170 0 12 1 170 0 13 1 170 0 15 1 170 0 16 1 170 0 17 1 170 0 18 1 170 0 19 1 170 0 20 1 170 0 22 1 170 0 23 3 121 0 24 3 125 0 25 1 170 0 26 1 170 0 27 1 170 0 28 1 170 0 31 1 170 0 32 1 170 0 34 1 170 0 41 1 170 0 42 1 170 0 43 1 170 0 44 1 170 0 45 1 170 0 46 1 170 0 47 1 170 0 52 1 170 0 54 1 170 0 55 1 170 0 56 1 170 0 69 1 170 0 70 1 170 0 71 1 170 0 72 1 170 0 80 1 170 0 82 1 170 0 84 1 170 0 92 1 170 0 93 1 170 0 94 1 170 0 95 1 170 0 101 1 170 0 235]
#[0 3 214 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 92 0 93 0 94 0 95 0 101 0 235]
#[1 1 210 0 1 1 210 0 2 1 210 0 3 1 210 0 4 1 210 0 5 1 210 0 6 1 210 0 7 1 210 0 8 1 210 0 12 1 210 0 13 1 210 0 15 1 210 0 16 1 210 0 17 1 210 0 18 1 210 0 19 1 210 0 20 1 210 0 22 1 210 0 23 1 210 0 24 1 210 0 25 1 210 0 26 1 210 0 27 1 210 0 28 1 210 0 31 1 210 0 32 1 210 0 34 1 210 0 41 1 210 0 42 1 210 0 43 1 210 0 44 1 210 0 45 1 210 0 46 1 210 0 47 1 210 0 52 1 210 0 54 1 210 0 55 1 210 0 56 1 210 0 69 1 210 0 70 1 210 0 71 1 210 0 72 1 210 0 80 1 210 0 82 1 210 0 84 3 129 0 89 1 210 0 92 1 210 0 93 1 210 0 94 1 210 0 95 3 133 0 96 1 210 0 101 1 210 0 235]
#[0 1 214 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 101 0 235]
#[0 1 226 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 101 0 235]
#[0 1 230 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 101 0 235]
#[1 2 6 0 1 2 6 0 2 2 6 0 3 2 6 0 4 2 6 0 5 2 6 0 6 2 6 0 7 2 6 0 8 2 6 0 12 2 6 0 13 2 6 0 15 2 6 0 16 2 6 0 17 2 6 0 18 2 6 0 19 2 6 0 20 2 6 0 22 2 6 0 23 2 6 0 24 2 6 0 25 2 6 0 26 2 6 0 27 2 6 0 28 2 6 0 31 2 6 0 32 2 6 0 34 2 6 0 41 2 6 0 42 2 6 0 43 2 6 0 44 2 6 0 45 2 6 0 46 2 6 0 47 2 6 0 52 2 6 0 54 2 6 0 55 2 6 0 56 2 6 0 69 2 6 0 70 2 6 0 71 2 6 0 72 2 6 0 80 2 6 0 82 2 6 0 84 2 6 0 89 2 6 0 92 2 6 0 93 2 6 0 94 2 6 0 95 2 6 0 96 2 6 0 100 2 6 0 101 3 137 0 177 2 6 0 235]
#[1 2 6 0 1 2 6 0 2 2 6 0 3 2 6 0 4 2 6 0 5 2 6 0 6 2 6 0 7 2 6 0 8 2 6 0 12 2 6 0 13 2 6 0 15 2 6 0 16 2 6 0 17 2 6 0 18 2 6 0 19 2 6 0 20 2 6 0 22 2 6 0 23 2 6 0 24 2 6 0 25 2 6 0 26 2 6 0 27 2 6 0 28 2 6 0 31 2 6 0 32 2 6 0 34 2 6 0 41 2 6 0 42 2 6 0 43 2 6 0 44 2 6 0 45 2 6 0 46 2 6 0 47 2 6 0 52 2 6 0 54 2 6 0 55 2 6 0 56 2 6 0 69 2 6 0 70 2 6 0 71 2 6 0 72 2 6 0 80 2 6 0 82 2 6 0 84 2 6 0 89 2 6 0 92 2 6 0 93 2 6 0 94 2 6 0 95 2 6 0 96 2 6 0 100 2 6 0 101 3 141 0 177 2 6 0 235]
#[1 0 61 0 4 2 185 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 2 189 0 68 2 193 0 87 0 209 0 113 2 197 0 126 3 145 0 180 1 117 0 184 1 121 0 185 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217]
#[0 2 62 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 1 250 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[1 0 61 0 4 2 185 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 2 189 0 68 2 193 0 87 0 209 0 113 2 197 0 126 3 149 0 180 1 117 0 184 1 121 0 185 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217]
#[0 2 18 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 50 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 54 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[1 2 6 0 1 2 6 0 2 2 6 0 3 2 6 0 4 2 6 0 5 2 6 0 6 2 6 0 7 2 6 0 8 2 6 0 12 2 6 0 13 2 6 0 15 2 6 0 16 2 6 0 17 2 6 0 18 2 6 0 19 2 6 0 20 2 6 0 22 2 6 0 23 2 6 0 24 2 6 0 25 2 6 0 26 2 6 0 27 2 6 0 28 2 6 0 31 2 6 0 32 2 6 0 34 2 6 0 41 2 6 0 42 2 6 0 43 2 6 0 44 2 6 0 45 2 6 0 46 2 6 0 47 2 6 0 52 2 6 0 54 2 6 0 55 2 6 0 56 2 6 0 69 2 6 0 70 2 6 0 71 2 6 0 72 2 6 0 80 2 6 0 82 2 6 0 84 2 6 0 89 2 6 0 92 2 6 0 93 2 6 0 94 2 6 0 95 2 6 0 96 2 6 0 100 2 6 0 101 3 153 0 177 2 6 0 235]
#[0 2 130 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 134 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 138 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 142 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 146 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 150 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 154 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 158 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 162 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 66 0 69 0 70 0 71 0 72 0 77 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 235]
#[0 2 210 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 66 0 69 0 70 0 71 0 72 0 77 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 235]
#[0 2 214 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 66 0 69 0 70 0 71 0 72 0 77 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 235]
#[0 2 218 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 66 0 69 0 70 0 71 0 72 0 77 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 235]
#[0 2 194 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 198 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 242 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 66 0 69 0 70 0 71 0 72 0 77 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 235]
#[0 2 246 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 250 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 254 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 3 2 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 102 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 106 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 110 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 114 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 118 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 0 6 0 235]
#[0 1 190 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 92 0 93 0 94 0 95 0 101 0 235]
#[0 0 34 0 33]
#[1 3 157 0 33 3 161 0 39]
#[1 3 165 0 112 3 169 0 122]
#[0 3 173 0 33]
#[0 3 177 0 36]
#[0 3 186 0 2 0 3 0 4 0 9 0 10 0 14 0 19 0 30 0 35 0 36 0 37 0 39 0 52 0 55 0 57 0 58 0 59 0 61 0 62 0 64 0 67 0 68 0 73 0 86 0 87 0 88 0 89 0 90 0 91 0 96 0 97 0 98 0 102 0 103 0 104 0 105 0 106 0 107 0 108 0 109 0 110 0 113 0 114 0 115 0 116 0 118]
#[0 1 186 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 92 0 93 0 94 0 95 0 101 0 235]
#[0 1 182 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 92 0 93 0 94 0 95 0 101 0 235]
#[1 3 165 0 112 3 181 0 122]
#[1 0 209 0 113 2 41 0 126 3 185 0 149]
#[0 3 189 0 8]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 3 193 0 132 0 241 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 3 197 0 8]
#[1 3 201 0 15 3 205 0 65 0 209 0 113 3 209 0 126 3 213 0 203]
#[0 2 174 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 3 217 0 31]
#[0 0 222 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 170 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[1 3 221 0 4 3 225 0 31 0 209 0 113 3 229 0 126 3 233 0 220 3 237 0 221]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 3 241 0 132 0 241 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 3 245 0 77]
#[1 0 209 0 113 2 41 0 126 3 249 0 149]
#[0 0 202 0 41 0 43 0 47 0 52 0 54 0 55]
#[1 0 209 0 113 2 41 0 126 3 253 0 149]
#[0 0 198 0 41 0 43 0 47 0 52 0 54 0 55]
#[0 4 1 0 31]
#[1 4 5 0 31 2 185 0 39 4 9 0 214]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 13 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227 4 17 0 229]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 13 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227 4 21 0 229]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 25 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227 4 29 0 232 4 33 0 233]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 4 37 0 78 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 13 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227 4 41 0 229 4 45 0 231]
#[0 4 49 0 31]
#[0 4 53 0 31]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 57 0 132 0 241 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 61 0 132 0 241 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 4 65 0 31]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 69 0 132 0 241 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 4 73 0 35 4 77 0 234]
#[0 2 26 0 4 0 39 0 57 0 58 0 61 0 62 0 68 0 87 0 113]
#[1 4 81 0 4 4 85 0 31 0 209 0 113 4 89 0 126 4 93 0 218 4 97 0 219]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 101 0 132 0 241 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 2 30 0 4 0 39 0 57 0 58 0 61 0 62 0 68 0 87 0 113]
#[0 4 105 0 77]
#[0 2 34 0 4 0 39 0 57 0 58 0 61 0 62 0 68 0 87 0 113]
#[1 1 206 0 1 1 206 0 2 1 206 0 3 1 206 0 4 1 206 0 5 1 206 0 6 1 206 0 7 1 206 0 8 1 206 0 12 1 206 0 13 1 206 0 15 1 206 0 16 1 206 0 17 1 206 0 18 1 206 0 19 1 206 0 20 1 206 0 22 1 206 0 23 1 206 0 24 1 206 0 25 1 206 0 26 1 206 0 27 1 206 0 28 1 206 0 31 1 206 0 32 1 206 0 34 1 206 0 41 1 206 0 42 1 206 0 43 1 206 0 44 1 206 0 45 1 206 0 46 1 206 0 47 1 206 0 52 1 206 0 54 1 206 0 55 1 206 0 56 1 206 0 69 1 206 0 70 1 206 0 71 1 206 0 72 1 206 0 80 1 206 0 82 1 206 0 84 3 129 0 89 1 206 0 92 1 206 0 93 1 206 0 94 1 206 0 95 3 133 0 96 1 206 0 101 1 206 0 235]
#[0 2 22 0 4 0 39 0 57 0 58 0 61 0 62 0 68 0 87 0 113]
#[0 2 38 0 4 0 39 0 57 0 58 0 61 0 62 0 68 0 87 0 113]
#[1 1 202 0 1 1 202 0 2 1 202 0 3 1 202 0 4 1 202 0 5 1 202 0 6 1 202 0 7 1 202 0 8 1 202 0 12 1 202 0 13 1 202 0 15 1 202 0 16 1 202 0 17 1 202 0 18 1 202 0 19 1 202 0 20 1 202 0 22 1 202 0 23 1 202 0 24 1 202 0 25 1 202 0 26 1 202 0 27 1 202 0 28 1 202 0 31 1 202 0 32 1 202 0 34 1 202 0 41 1 202 0 42 1 202 0 43 1 202 0 44 1 202 0 45 1 202 0 46 1 202 0 47 1 202 0 52 1 202 0 54 1 202 0 55 1 202 0 56 1 202 0 69 1 202 0 70 1 202 0 71 1 202 0 72 1 202 0 80 1 202 0 82 1 202 0 84 3 129 0 89 1 202 0 92 1 202 0 93 1 202 0 94 1 202 0 95 3 133 0 96 1 202 0 101 1 202 0 235]
#[0 2 42 0 4 0 39 0 57 0 58 0 61 0 62 0 68 0 87 0 113]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 109 0 132 0 241 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 2 82 0 4 0 39 0 57 0 58 0 61 0 62 0 68 0 87 0 113]
#[0 2 46 0 4 0 39 0 57 0 58 0 61 0 62 0 68 0 87 0 113]
#[0 2 49 0 30]
#[0 2 117 0 30]
#[0 2 133 0 30]
#[0 2 90 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 58 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 66 0 4 0 39 0 57 0 58 0 61 0 62 0 68 0 87 0 113]
#[0 2 70 0 4 0 39 0 57 0 58 0 61 0 62 0 68 0 87 0 113]
#[0 2 74 0 4 0 39 0 57 0 58 0 61 0 62 0 68 0 87 0 113]
#[0 2 78 0 4 0 39 0 57 0 58 0 61 0 62 0 68 0 87 0 113]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 4 113 0 31 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 117 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 4 121 0 199 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 125 0 132 0 241 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 129 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 4 133 0 47]
#[0 4 137 0 48]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 141 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 4 145 0 41 2 233 0 43 2 237 0 47 4 149 0 145]
#[0 4 153 0 41]
#[0 0 178 0 41 0 43 0 47 0 54]
#[0 0 182 0 41 0 43 0 47 0 54]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 157 0 137 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 161 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 1 106 0 2 0 3 0 4 0 19 0 30 0 35 0 39 0 57 0 58 0 61 0 62 0 64 0 67 0 68 0 86 0 87 0 88 0 89 0 90 0 91 0 96 0 97 0 98 0 102 0 103 0 104 0 105 0 106 0 107 0 108 0 109 0 110 0 113 0 114 0 115 0 116 0 118]
#[0 1 110 0 2 0 3 0 4 0 19 0 30 0 35 0 39 0 57 0 58 0 61 0 62 0 64 0 67 0 68 0 86 0 87 0 88 0 89 0 90 0 91 0 96 0 97 0 98 0 102 0 103 0 104 0 105 0 106 0 107 0 108 0 109 0 110 0 113 0 114 0 115 0 116 0 118]
#[0 1 66 0 2 0 3 0 4 0 19 0 30 0 35 0 39 0 57 0 58 0 61 0 62 0 64 0 67 0 68 0 86 0 87 0 88 0 89 0 90 0 91 0 96 0 97 0 98 0 102 0 103 0 104 0 105 0 106 0 107 0 108 0 109 0 110 0 113 0 114 0 115 0 116 0 118]
#[0 1 70 0 2 0 3 0 4 0 19 0 30 0 35 0 39 0 57 0 58 0 61 0 62 0 64 0 67 0 68 0 86 0 87 0 88 0 89 0 90 0 91 0 96 0 97 0 98 0 102 0 103 0 104 0 105 0 106 0 107 0 108 0 109 0 110 0 113 0 114 0 115 0 116 0 118]
#[0 1 98 0 2 0 3 0 4 0 19 0 30 0 35 0 39 0 57 0 58 0 61 0 62 0 64 0 67 0 68 0 86 0 87 0 88 0 89 0 90 0 91 0 96 0 97 0 98 0 102 0 103 0 104 0 105 0 106 0 107 0 108 0 109 0 110 0 113 0 114 0 115 0 116 0 118]
#[0 1 102 0 2 0 3 0 4 0 19 0 30 0 35 0 39 0 57 0 58 0 61 0 62 0 64 0 67 0 68 0 86 0 87 0 88 0 89 0 90 0 91 0 96 0 97 0 98 0 102 0 103 0 104 0 105 0 106 0 107 0 108 0 109 0 110 0 113 0 114 0 115 0 116 0 118]
#[0 1 94 0 2 0 3 0 4 0 19 0 30 0 35 0 39 0 57 0 58 0 61 0 62 0 64 0 67 0 68 0 86 0 87 0 88 0 89 0 90 0 91 0 96 0 97 0 98 0 102 0 103 0 104 0 105 0 106 0 107 0 108 0 109 0 110 0 113 0 114 0 115 0 116 0 118]
#[0 1 74 0 2 0 3 0 4 0 19 0 30 0 35 0 39 0 57 0 58 0 61 0 62 0 64 0 67 0 68 0 86 0 87 0 88 0 89 0 90 0 91 0 96 0 97 0 98 0 102 0 103 0 104 0 105 0 106 0 107 0 108 0 109 0 110 0 113 0 114 0 115 0 116 0 118]
#[0 1 90 0 2 0 3 0 4 0 19 0 30 0 35 0 39 0 57 0 58 0 61 0 62 0 64 0 67 0 68 0 86 0 87 0 88 0 89 0 90 0 91 0 96 0 97 0 98 0 102 0 103 0 104 0 105 0 106 0 107 0 108 0 109 0 110 0 113 0 114 0 115 0 116 0 118]
#[0 1 78 0 2 0 3 0 4 0 19 0 30 0 35 0 39 0 57 0 58 0 61 0 62 0 64 0 67 0 68 0 86 0 87 0 88 0 89 0 90 0 91 0 96 0 97 0 98 0 102 0 103 0 104 0 105 0 106 0 107 0 108 0 109 0 110 0 113 0 114 0 115 0 116 0 118]
#[0 1 82 0 2 0 3 0 4 0 19 0 30 0 35 0 39 0 57 0 58 0 61 0 62 0 64 0 67 0 68 0 86 0 87 0 88 0 89 0 90 0 91 0 96 0 97 0 98 0 102 0 103 0 104 0 105 0 106 0 107 0 108 0 109 0 110 0 113 0 114 0 115 0 116 0 118]
#[0 1 86 0 2 0 3 0 4 0 19 0 30 0 35 0 39 0 57 0 58 0 61 0 62 0 64 0 67 0 68 0 86 0 87 0 88 0 89 0 90 0 91 0 96 0 97 0 98 0 102 0 103 0 104 0 105 0 106 0 107 0 108 0 109 0 110 0 113 0 114 0 115 0 116 0 118]
#[0 1 114 0 2 0 3 0 4 0 19 0 30 0 35 0 39 0 57 0 58 0 61 0 62 0 64 0 67 0 68 0 86 0 87 0 88 0 89 0 90 0 91 0 96 0 97 0 98 0 102 0 103 0 104 0 105 0 106 0 107 0 108 0 109 0 110 0 113 0 114 0 115 0 116 0 118]
#[0 1 118 0 2 0 3 0 4 0 19 0 30 0 35 0 39 0 57 0 58 0 61 0 62 0 64 0 67 0 68 0 86 0 87 0 88 0 89 0 90 0 91 0 96 0 97 0 98 0 102 0 103 0 104 0 105 0 106 0 107 0 108 0 109 0 110 0 113 0 114 0 115 0 116 0 118]
#[0 1 122 0 2 0 3 0 4 0 19 0 30 0 35 0 39 0 57 0 58 0 61 0 62 0 64 0 67 0 68 0 86 0 87 0 88 0 89 0 90 0 91 0 96 0 97 0 98 0 102 0 103 0 104 0 105 0 106 0 107 0 108 0 109 0 110 0 113 0 114 0 115 0 116 0 118]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 165 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 169 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 173 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 177 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 181 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 185 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 189 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 193 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 197 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 201 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 205 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 209 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 213 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 217 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 153 0 90 0 157 0 91 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 221 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217]
#[1 0 61 0 4 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 101 0 57 0 105 0 58 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 137 0 86 0 141 0 87 0 145 0 88 0 153 0 90 0 157 0 91 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 225 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217]
#[1 1 234 0 1 1 234 0 2 1 234 0 3 1 234 0 4 1 234 0 5 1 234 0 6 1 234 0 7 1 234 0 8 1 234 0 12 1 234 0 13 1 234 0 15 1 234 0 16 1 234 0 17 1 234 0 18 1 234 0 19 1 234 0 20 1 234 0 22 1 234 0 23 1 234 0 24 1 234 0 25 1 234 0 26 1 234 0 27 1 234 0 28 1 234 0 31 1 234 0 32 1 234 0 34 1 234 0 41 1 234 0 42 1 234 0 43 1 234 0 44 1 234 0 45 1 234 0 46 1 234 0 47 1 234 0 52 1 234 0 54 1 234 0 55 1 234 0 56 1 234 0 69 1 234 0 70 1 234 0 71 1 234 0 72 1 234 0 80 1 234 0 82 1 234 0 84 1 234 0 89 1 234 0 92 1 234 0 93 1 234 0 94 1 234 0 95 1 234 0 96 4 229 0 100 1 234 0 101 4 233 0 176 1 234 0 235]
#[1 1 238 0 1 1 238 0 2 1 238 0 3 1 238 0 4 1 238 0 5 1 238 0 6 1 238 0 7 1 238 0 8 1 238 0 12 1 238 0 13 1 238 0 15 1 238 0 16 1 238 0 17 1 238 0 18 1 238 0 19 1 238 0 20 1 238 0 22 1 238 0 23 1 238 0 24 1 238 0 25 1 238 0 26 1 238 0 27 1 238 0 28 1 238 0 31 1 238 0 32 1 238 0 34 1 238 0 41 1 238 0 42 1 238 0 43 1 238 0 44 1 238 0 45 1 238 0 46 1 238 0 47 1 238 0 52 1 238 0 54 1 238 0 55 1 238 0 56 1 238 0 69 1 238 0 70 1 238 0 71 1 238 0 72 1 238 0 80 1 238 0 82 1 238 0 84 1 238 0 89 1 238 0 92 1 238 0 93 1 238 0 94 1 238 0 95 1 238 0 96 4 229 0 100 1 238 0 101 4 233 0 176 1 238 0 235]
#[0 1 246 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 14 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[1 1 242 0 1 1 242 0 2 1 242 0 3 1 242 0 4 1 242 0 5 1 242 0 6 1 242 0 7 1 242 0 8 1 242 0 12 1 242 0 13 1 242 0 15 1 242 0 16 1 242 0 17 1 242 0 18 1 242 0 19 1 242 0 20 1 242 0 22 1 242 0 23 1 242 0 24 1 242 0 25 1 242 0 26 1 242 0 27 1 242 0 28 1 242 0 31 1 242 0 32 1 242 0 34 1 242 0 41 1 242 0 42 1 242 0 43 1 242 0 44 1 242 0 45 1 242 0 46 1 242 0 47 1 242 0 52 1 242 0 54 1 242 0 55 1 242 0 56 1 242 0 69 1 242 0 70 1 242 0 71 1 242 0 72 1 242 0 80 1 242 0 82 1 242 0 84 1 242 0 89 1 242 0 92 1 242 0 93 1 242 0 94 1 242 0 95 1 242 0 96 4 229 0 100 1 242 0 101 4 233 0 176 1 242 0 235]
#[0 4 237 0 40]
#[0 4 241 0 40]
#[0 0 18 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 66 0 69 0 70 0 71 0 72 0 77 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 235]
#[0 4 245 0 34]
#[1 0 209 0 113 4 249 0 126]
#[0 3 178 0 2 0 3 0 4 0 9 0 10 0 14 0 19 0 30 0 35 0 36 0 39 0 52 0 55 0 57 0 58 0 59 0 61 0 62 0 64 0 67 0 68 0 73 0 86 0 87 0 88 0 89 0 90 0 91 0 96 0 97 0 98 0 102 0 103 0 104 0 105 0 106 0 107 0 108 0 109 0 110 0 113 0 114 0 115 0 116 0 118]
#[0 2 98 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 4 253 0 50]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 5 1 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 5 5 0 31]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 5 9 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 77 0 19 5 13 0 77 3 165 0 112 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 5 17 0 117 0 225 0 118 5 21 0 122 0 229 0 123 5 25 0 126 5 29 0 128 5 33 0 187 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 5 37 0 200 1 185 0 202 5 41 0 204 5 45 0 206 5 49 0 207]
#[0 3 6 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 66 0 69 0 70 0 71 0 72 0 77 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 235]
#[0 5 53 0 34]
#[1 5 57 0 15 5 61 0 65]
#[0 2 178 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 3 170 0 31]
#[0 3 130 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 3 174 0 31]
#[0 5 65 0 31]
#[0 3 166 0 31]
#[0 5 69 0 70]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 5 73 0 70 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 5 77 0 132 0 241 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 5 81 0 212 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 5 85 0 53]
#[1 5 89 0 50 5 93 0 51 5 97 0 150]
#[0 3 150 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 3 122 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 5 101 0 31]
#[0 3 222 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 0 150 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 5 105 0 69]
#[0 4 2 0 69 0 71 0 72 0 82]
#[0 0 162 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[1 5 109 0 69 5 113 0 71 5 117 0 72 5 121 0 82]
#[0 5 125 0 79]
#[0 5 129 0 80]
#[0 0 158 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 2 122 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 126 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 5 133 0 70]
#[0 5 137 0 70]
#[0 3 146 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 5 141 0 70]
#[1 0 209 0 113 2 41 0 126 5 145 0 149]
#[0 5 149 0 56]
#[0 3 158 0 31]
#[0 3 138 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 3 162 0 31]
#[0 5 153 0 31]
#[0 3 154 0 31]
#[0 5 157 0 70]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 5 161 0 70 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 5 165 0 132 0 241 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 5 169 0 70]
#[0 2 186 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[1 2 234 0 31 5 173 0 32]
#[0 5 177 0 31]
#[0 0 74 0 31 0 70 0 101 0 235]
#[0 0 114 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 5 181 0 48]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 5 185 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 5 189 0 152 5 193 0 153 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 0 186 0 41 0 43 0 47]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 5 197 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 5 201 0 41]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 5 205 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 0 146 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 1 38 0 5 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 1 46 0 5 0 6 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 1 50 0 5 0 6 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 1 54 0 5 0 6 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 1 62 0 5 0 6 0 8 0 12 0 15 0 16 0 17 0 18 0 19 0 20 0 26 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 92 0 93 0 94 0 95 0 101 0 235]
#[0 1 130 0 1 0 5 0 6 0 8 0 12 0 15 0 16 0 17 0 18 0 19 0 20 0 26 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 92 0 93 0 94 0 95 0 101 0 235]
#[0 1 134 0 1 0 5 0 6 0 8 0 12 0 15 0 16 0 17 0 18 0 19 0 20 0 26 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 92 0 93 0 94 0 95 0 101 0 235]
#[0 1 142 0 1 0 2 0 3 0 5 0 6 0 8 0 12 0 15 0 16 0 17 0 18 0 19 0 20 0 26 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 92 0 93 0 94 0 95 0 101 0 235]
#[0 1 146 0 1 0 2 0 3 0 5 0 6 0 8 0 12 0 15 0 16 0 17 0 18 0 19 0 20 0 26 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 92 0 93 0 94 0 95 0 101 0 235]
#[0 1 150 0 1 0 2 0 3 0 5 0 6 0 8 0 12 0 15 0 16 0 17 0 18 0 19 0 20 0 26 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 92 0 93 0 94 0 95 0 101 0 235]
#[0 1 154 0 1 0 2 0 3 0 5 0 6 0 8 0 12 0 15 0 16 0 17 0 18 0 19 0 20 0 26 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 92 0 93 0 94 0 95 0 101 0 235]
#[0 1 162 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 92 0 93 0 94 0 95 0 101 0 235]
#[0 1 166 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 92 0 93 0 94 0 95 0 101 0 235]
#[0 1 174 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 92 0 93 0 94 0 95 0 101 0 235]
#[0 1 178 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 92 0 93 0 94 0 95 0 101 0 235]
#[0 1 222 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 101 0 235]
#[0 1 218 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 101 0 235]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 5 209 0 101 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 5 213 0 132 0 241 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 2 10 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[1 0 225 0 118 5 217 0 121 5 221 0 123]
#[1 0 225 0 118 5 225 0 121 5 221 0 123]
#[1 0 225 0 118 5 229 0 121 5 221 0 123]
#[0 5 233 0 30]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 5 237 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 0 134 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 5 241 0 11]
#[0 0 130 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 5 245 0 132 0 241 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 3 74 0 19 0 66 0 77 0 112 0 113 0 114 0 115 0 116 0 117 0 118]
#[0 3 66 0 19 0 66 0 77 0 112 0 113 0 114 0 115 0 116 0 117 0 118]
#[0 3 70 0 19 0 66 0 77 0 112 0 113 0 114 0 115 0 116 0 117 0 118]
#[0 3 58 0 19 0 66 0 77 0 112 0 113 0 114 0 115 0 116 0 117 0 118]
#[0 3 62 0 19 0 66 0 77 0 112 0 113 0 114 0 115 0 116 0 117 0 118]
#[1 0 77 0 19 3 30 0 66 5 13 0 77 3 165 0 112 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 5 17 0 117 0 225 0 118 5 21 0 122 0 229 0 123 5 25 0 126 5 29 0 128 5 33 0 187 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 5 37 0 200 1 185 0 202 5 249 0 204 5 45 0 206 5 49 0 207]
#[0 5 253 0 66]
#[1 0 77 0 19 3 38 0 66 5 13 0 77 3 165 0 112 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 5 17 0 117 0 225 0 118 5 21 0 122 0 229 0 123 5 25 0 126 5 29 0 128 5 33 0 187 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 5 37 0 200 1 185 0 202 6 1 0 204 5 45 0 206 5 49 0 207]
#[0 3 54 0 19 0 66 0 77 0 112 0 113 0 114 0 115 0 116 0 117 0 118]
#[1 5 13 0 77 0 225 0 118 6 5 0 123 6 9 0 128 6 13 0 205]
#[1 0 77 0 19 5 13 0 77 3 165 0 112 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 5 17 0 117 0 225 0 118 5 21 0 122 0 229 0 123 5 25 0 126 5 29 0 128 5 33 0 187 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 5 37 0 200 1 185 0 202 6 17 0 204 5 45 0 206 5 49 0 207]
#[0 3 10 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 66 0 69 0 70 0 71 0 72 0 77 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 235]
#[0 3 134 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 6 21 0 77]
#[0 3 82 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 3 118 0 70]
#[0 6 25 0 70]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 6 29 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 6 33 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 6 37 0 35]
#[0 6 41 0 50]
#[0 3 126 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 6 45 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227 6 49 0 230]
#[1 6 53 0 75 6 57 0 76]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 13 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227 6 61 0 229]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 13 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227 6 65 0 229]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 13 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227 6 69 0 229]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 13 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227 6 73 0 229]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 6 77 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 2 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 3 78 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 3 114 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 6 81 0 53]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 6 85 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 3 142 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 6 89 0 77]
#[0 3 98 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 6 93 0 70]
#[0 2 202 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 117 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 6 97 0 199 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 2 190 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 5 185 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 6 101 0 152 5 193 0 153 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 0 246 0 32 0 246 0 41 6 105 0 44 6 109 0 45 6 113 0 46 6 117 0 154 6 121 0 155 6 125 0 156]
#[0 0 190 0 41]
#[1 6 129 0 32 0 238 0 41]
#[0 0 118 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 6 133 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 0 122 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 2 2 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 6 137 0 101]
#[0 1 198 0 36]
#[0 0 14 0 36]
#[0 1 194 0 36]
#[0 4 14 0 36]
#[1 0 62 0 31 0 62 0 32 6 141 0 35 6 145 0 127 6 149 0 129 6 153 0 130 6 157 0 131]
#[1 1 26 0 8 6 161 0 32]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 6 165 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 6 169 0 70]
#[0 3 34 0 66]
#[1 0 209 0 113 6 173 0 126]
#[0 3 42 0 66]
#[0 3 46 0 15 0 65 0 113]
#[0 3 50 0 15 0 65 0 113]
#[1 3 22 0 15 3 22 0 65 0 209 0 113 3 209 0 126 6 177 0 203]
#[0 6 181 0 66]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 6 185 0 70 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 5 77 0 132 0 241 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 6 189 0 212 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 3 86 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[1 6 193 0 32 0 230 0 41 0 230 0 43 0 230 0 47 0 230 0 52 0 230 0 54 0 230 0 55]
#[1 6 197 0 32 0 206 0 41 0 206 0 43 0 206 0 47 0 206 0 52 0 206 0 54 0 206 0 55]
#[1 0 209 0 113 2 41 0 126 6 201 0 149]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 6 205 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 3 226 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 0 154 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 6 209 0 82]
#[0 6 213 0 82]
#[0 3 250 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 3 254 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 3 238 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 6 217 0 80]
#[0 3 234 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 6 221 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 6 225 0 41]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 6 229 0 70 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 6 233 0 132 0 241 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 3 102 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 2 238 0 31]
#[0 0 194 0 41]
#[0 1 10 0 32 0 41 0 46]
#[0 1 14 0 32 0 41 0 46]
#[1 6 237 0 21 6 241 0 49]
#[0 0 250 0 32 0 41]
#[1 0 254 0 32 0 254 0 41 6 113 0 46 6 245 0 156]
#[0 1 2 0 32 0 41]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 5 185 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 6 249 0 152 5 193 0 153 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 0 126 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 1 254 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[1 0 209 0 113 6 253 0 126]
#[1 7 1 0 31 7 5 0 32]
#[0 0 42 0 31 0 32]
#[0 0 46 0 31 0 32]
#[0 0 58 0 31 0 32]
#[1 2 13 0 35 7 9 0 157]
#[0 7 13 0 12]
#[0 0 50 0 15 0 19 0 36 0 65 0 66 0 77 0 112 0 113 0 114 0 115 0 116 0 117 0 118]
#[0 7 17 0 15]
#[0 3 26 0 15 0 65]
#[1 0 209 0 113 7 21 0 126]
#[0 3 90 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 7 25 0 70]
#[1 2 61 0 35 7 29 0 151]
#[1 2 69 0 35 7 33 0 148]
#[0 0 226 0 50]
#[1 7 37 0 32 0 214 0 41 0 214 0 43 0 214 0 47 0 214 0 52 0 214 0 54 0 214 0 55]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 13 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227 7 41 0 229]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 4 13 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227 7 45 0 229]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 7 49 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[1 7 53 0 32 4 6 0 56]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 7 57 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 3 106 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 7 61 0 70]
#[0 1 22 0 32 0 41]
#[0 1 18 0 32 0 41]
#[0 1 6 0 32 0 41]
#[0 0 242 0 41]
#[0 0 66 0 31 0 32]
#[1 5 13 0 77 7 65 0 128]
#[1 6 141 0 35 7 69 0 131]
#[0 1 30 0 8]
#[1 0 53 0 2 0 57 0 3 0 61 0 4 0 65 0 9 0 69 0 10 0 73 0 14 0 77 0 19 0 81 0 30 0 85 0 35 0 89 0 39 0 93 0 52 0 97 0 55 0 101 0 57 0 105 0 58 0 109 0 59 0 113 0 61 0 117 0 62 0 121 0 64 0 125 0 67 0 129 0 68 0 133 0 73 0 137 0 86 0 141 0 87 0 145 0 88 0 149 0 89 0 153 0 90 0 157 0 91 0 161 0 96 0 165 0 97 0 169 0 98 0 173 0 102 0 177 0 103 0 181 0 104 0 185 0 105 0 189 0 106 0 193 0 107 0 197 0 108 0 201 0 109 0 205 0 110 0 209 0 113 0 213 0 114 0 217 0 115 0 221 0 116 0 225 0 118 0 229 0 123 0 233 0 126 7 73 0 133 0 245 0 134 0 249 0 135 0 253 0 136 1 1 0 137 1 5 0 138 1 9 0 139 1 13 0 140 1 17 0 141 1 21 0 142 1 25 0 143 1 29 0 146 1 33 0 147 1 37 0 158 1 41 0 159 1 45 0 160 1 49 0 164 1 53 0 165 1 57 0 166 1 61 0 167 1 65 0 168 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 178 1 97 0 179 1 101 0 180 1 105 0 181 1 109 0 182 1 113 0 183 1 117 0 184 1 121 0 185 1 125 0 186 1 129 0 187 1 133 0 188 1 137 0 189 1 141 0 190 1 145 0 191 1 149 0 192 1 153 0 193 1 157 0 194 1 161 0 195 1 165 0 196 1 169 0 197 1 173 0 198 1 177 0 200 1 181 0 201 1 185 0 202 1 189 0 208 1 193 0 209 1 197 0 210 1 201 0 211 1 205 0 213 1 209 0 214 1 213 0 215 1 217 0 216 1 221 0 217 1 229 0 227]
#[0 3 14 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 66 0 69 0 70 0 71 0 72 0 77 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 235]
#[0 7 77 0 15]
#[0 3 94 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 0 234 0 41 0 43 0 47 0 52 0 54 0 55]
#[0 0 210 0 41 0 43 0 47 0 52 0 54 0 55]
#[1 2 69 0 35 7 81 0 148]
#[0 3 242 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 3 246 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 3 230 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[1 4 73 0 35 7 85 0 234]
#[0 0 166 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 3 110 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 235]
#[0 0 10 0 36]
#[0 0 54 0 31 0 32]
#[0 0 138 0 8 0 12 0 31 0 32 0 41 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 69 0 70 0 71 0 72 0 80 0 82 0 101 0 235]
#[0 3 18 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 12 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 34 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 52 0 54 0 55 0 56 0 66 0 69 0 70 0 71 0 72 0 77 0 80 0 82 0 84 0 89 0 92 0 93 0 94 0 95 0 96 0 100 0 101 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 235]
#[0 0 218 0 41 0 43 0 47 0 52 0 54 0 55]
#[0 4 10 0 56]
)
! !

!XQueryParser methodsFor:'informing'!

informAboutRuleReduction: aString

    (Smalltalk isStandAloneApp or:[self class isVerbose]) ifTrue:
        [Transcript show: '[XQuery::Parser] reducing rule '; showCR: aString]

    "Created: / 10-02-2007 / 13:00:28 / janfrog"
    "Modified: / 12-04-2007 / 11:16:11 / janfrog"
! !

!XQueryParser methodsFor:'private'!

actionForCurrentToken
        | ids action |
        ids := currentToken id.
        1 to: ids size
                do: 
                        [:i | 
                        action := self actionFor: (ids at: i).
                        (action bitAnd: self actionMask) = self errorAction ifFalse: [^action].
                        "(ids at: i) = scanner negative_numberId 
                                ifTrue: 
                                        [currentToken := SmaCCToken 
                                                                value: '-'
                                                                start: currentToken startPosition
                                                                id: (Array with: scanner binary_symbolId).
                                        scanner position: currentToken stopPosition - 1.
                                        ^self actionForCurrentToken]"].
        ^self errorAction

    "Created: / 17-03-2006 / 14:55:30 / ked"
! !

!XQueryParser class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/stx/goodies/xmlsuite/xquery/XQuery__XQueryParser.st,v 1.16 2008-01-02 14:05:41 wrobll1 Exp $'
! !
